#include "main.h"
// Verify that the GDIPlus path is in your project options (additional include directories)
// Same for the lib
#include "Includes/gdiplus.h"

// /DELAYLOADING
#pragma message("Ractiver a sous Visual Studio 6.0!")
// #pragma comment(linker, "/delayload:GdiPlus.dll")

void ToW(const char *string, WCHAR *dest)			{
	MultiByteToWideChar( CP_ACP, 0, string, -1, dest, 260 );
}

void gdipImageKeying(int dx, int dy)
{
	int x, y;
	u32 c;
	if (!curPF->pfList[curCMode].bUseColorKey)
		return;
	for (y=0;y<dy;y++)
		for (x=0;x<dx;x++)
		{
			c = LitPix(x, y);
			//Transparente?
			if ((c & 0x00ffffff) == RGB(bleuMasque, vertMasque, rougeMasque))
				c = 0x00000000;
			else
				c |= 0xff000000;
			DessPix(x, y, c);
		}
}

int gdipPaletteCalcSize(int dx, int dy, unsigned long *pal, int palCount)
{
	int x, y, i;
	u32 c;
	u32 *palused;
	//Permet de dterminer les couleurs utilises
	palused = (u32*)malloc(sizeof(u32) * palCount);
	memset(palused, 0, palCount * sizeof(u32));

	for (y=0;y<dy;y++)		{
		for (x=0;x<dx;x++)		{
			c = LitPix(x, y);
			for (i=0;i<palCount;i++)		{
				//ATTENTION: va merder si on a une couleur 0x40ffffff et 0x80ffffff par exemple!
				if ((pal[i]&0x00ffffff) == (c&0x00ffffff))			{
					palused[i] = 1;
					if (i>0)
						i=i;
					break;
				}
			}
		}
	}
	//Bon on a notre histogramme, les couleurs non-utilises depuis la fin sont supprimes
	for (i=palCount-1;i>=0;i--)		{
		//Utilise => termin
		if (palused[i])
			break;
	}
	free(palused);
	return i+1;
}

int Real_GDIPLUS_DrawImage (const char *fichier, int *dx, int *dy)
{
	using namespace Gdiplus;
	WCHAR wfichier[1024];

	ToW(fichier, wfichier);
//	mbstowcs( wfichier, fichier, strlen(fichier));
	Image image(wfichier);

	*dx = image.GetWidth();
	*dy = image.GetHeight();
	if (*dx==0 || *dy==0)
		return 0;

	vbConv.Create(*dx, *dy);

	vbApercu.Resize(*dx, *dy, TRUE);
	vbApercu.Use();

	//Dessin (enfin)
	Graphics graphics(vbConv.m_hdc);
	int palSize = image.GetPaletteSize();
	ColorPalette *pal = new ColorPalette[palSize];
	int i;
	graphics.DrawImage(&image, 0, 0, *dx, *dy);
	//Palette dispo?
	if (palSize > 0)		{
		image.GetPalette(pal, palSize);
		gblGdipPaletteEntries = (unsigned long*)realloc(gblGdipPaletteEntries, palSize * 4);
		for (i=0;i<(signed)pal->Count;i++)
			gblGdipPaletteEntries[i] = pal->Entries[i];
	}
	//Ncessaire pour l'analyse ci-dessous
	vbConv.Use();
	gblGdipPaletteCount = gdipPaletteCalcSize(*dx, *dy, gblGdipPaletteEntries, pal->Count);
	gdipImageKeying(*dx, *dy);
	delete pal;
	return 1;
}

int GDIPLUS_DrawImage (const char *fichier, int *dx, int *dy)			{
	using namespace Gdiplus;
	GdiplusStartupInput gdiplusStartupInput;
	Gdiplus::ULONG_PTR  gdiplusToken;

	//   hInstGdiPlus = LoadLibrary("gdiplus.dll");
	// Initialize GDI+.
	if (!bGdiPlusDemarre)
		GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
	bGdiPlusDemarre = TRUE;
	return Real_GDIPLUS_DrawImage (fichier, dx, dy);
}

void InitGDIPlus()		{
	using namespace Gdiplus;
	GdiplusStartupInput gdiplusStartupInput;
	Gdiplus::ULONG_PTR  gdiplusToken;
	// Initialize GDI+.
	if (!bGdiPlusDemarre)
		GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
	bGdiPlusDemarre = TRUE;
}

int GetEncoderClsid(const WCHAR* format, CLSID* pClsid)
{
   UINT  num = 0;          // number of image encoders
   UINT  size = 0;         // size of the image encoder array in bytes
   using namespace Gdiplus;

   ImageCodecInfo* pImageCodecInfo = NULL;

   GetImageEncodersSize(&num, &size);
   if(size == 0)
      return -1;  // Failure

   pImageCodecInfo = (ImageCodecInfo*)(malloc(size));
   if(pImageCodecInfo == NULL)
      return -1;  // Failure

   GetImageEncoders(num, size, pImageCodecInfo);

   for(UINT j = 0; j < num; ++j)
   {
      if( wcscmp(pImageCodecInfo[j].MimeType, format) == 0 )
      {
         *pClsid = pImageCodecInfo[j].Clsid;
         free(pImageCodecInfo);
         return j;  // Success
      }    
   }

   free(pImageCodecInfo);
   return -1;  // Failure
}

void GDIPLUS_SaveToDisk(HDC hdc2, int x, int y, char *nom_fichier)			{
	using namespace Gdiplus;
	InitGDIPlus();
	char *extension;
	WCHAR wfichier[1024];
	int redid = 0;

redo:
	ToW(nom_fichier, wfichier);

	HPALETTE hPalette = (HPALETTE)GetCurrentObject(vbApercu.m_hdc, OBJ_PAL) ;
	Bitmap *myBitMap = new Bitmap(vbApercu.m_hbm, hPalette ) ;
	CLSID   encoderClsid;

	extension = GetExtension(nom_fichier);
	if (!strcmp(extension, "png"))
		GetEncoderClsid(L"image/png", &encoderClsid);
	else if (!strcmp(extension, "jpg") || !strcmp(extension, "jpeg"))
		GetEncoderClsid(L"image/jpeg", &encoderClsid);
	else if (!strcmp(extension, "bmp"))
		GetEncoderClsid(L"image/bmp", &encoderClsid);
	else if (!strcmp(extension, "gif"))
		GetEncoderClsid(L"image/gif", &encoderClsid);
	else if (!strcmp(extension, "tiff"))
		GetEncoderClsid(L"image/tiff", &encoderClsid);
	else		{
		//Dfaut: bmp
		strcat(nom_fichier, ".bmp");
//		GetEncoderClsid(L"image/bmp", &encoderClsid);
		if (redid)
			return;
		redid=1;
		goto redo;
	}
	myBitMap->Save(wfichier, &encoderClsid) ;
}

bool gdipPalettesIdentical(unsigned char *palette, int count, int nCoulMax)		{
	int i;
	unsigned char *pal = (unsigned char*)gblGdipPaletteEntries;
	// Si une palette existe
	if (gblGdipPaletteCount <= 0)
		return 0;
	// La base de palette qui correspond
	for (i=0;i<min(gblGdipPaletteCount, count);i++)		{
//		if (!(palette[i*4]/MULTB == tblCoulB[pal[i*4]] && palette[i*4+1]/MULTV == tblCoulV[pal[i*4+1]] && palette[i*4+2]/MULTR == tblCoulR[pal[i*4+2]]))
		if (!(palette[i*4] == tblCoulB[pal[i*4]] && palette[i*4+1] == tblCoulV[pal[i*4+1]] && palette[i*4+2] == tblCoulR[pal[i*4+2]]))
			break;
	}
	// Si le mode "premire couleur transparente" est active, on rajoutera une couleur au dbut
	// Avec GDIPlus la premire couleur est transparente
//	if (curPF->pfList[curCMode].bFirstColorTransparent)
//		nCoulMax--;
	// Assez de couleurs dispo?
	if (gblGdipPaletteCount <= nCoulMax - count + i)
		return 1;
	else
		return 0;
}

int gdipCalcPalette(unsigned long *tableau, unsigned char *palette, int h, int l, int nCoulInitiales, int nbBase, int nbMax)		{
	int nbCouleurs=nCoulInitiales, coulTransparente, bestDifference, bestDiffNum;
	int x,y,i, difference = 0xffffff;
	unsigned char rouge,vert,bleu,alpha;

	unsigned char *pal = (unsigned char*)gblGdipPaletteEntries;
	// La base de palette qui correspond
	for (i=0;i<gblGdipPaletteCount;i++)		{
//		if (!(palette[i*4]/MULTB == tblCoulB[pal[i*4]] && palette[i*4+1]/MULTV == tblCoulV[pal[i*4+1]] && palette[i*4+2]/MULTR == tblCoulR[pal[i*4+2]]))
		if (!(palette[i*4] == tblCoulB[pal[i*4]] && palette[i*4+1] == tblCoulV[pal[i*4+1]] && palette[i*4+2] == tblCoulR[pal[i*4+2]]))
			break;
	}

	//Une couleur de perdue...
//	if (curPF->pfList[curCMode].bFirstColorTransparent)
//		nbMax--;

	// A partir du moment o a correspond plus -> on ajoute
//	for (;i<gblGdipPaletteCount * 4;i+=4)
	for (;i<gblGdipPaletteCount;i++)
	{
		if (nbCouleurs >= nbMax)
			break;

		bleu = tblCoulB[pal[i*4+0]];
		vert = tblCoulV[pal[i*4+1]];
		rouge = tblCoulR[pal[i*4+2]];
		alpha = pal[i*4+3];
		// Vrifie si la couleur existe dj...
/*		int j;
		for (j=0;j<nbCouleurs;j++)		{
			if (palette[j*4]==bleu && palette[j*4+1]==vert && palette[j*4+2]==rouge)
				continue;
		}
		//Trouv?
		if (j >= nbCouleurs)			{*/
			palette[nbCouleurs * 4] = bleu;
			palette[nbCouleurs * 4 + 1] = vert;
			palette[nbCouleurs * 4 + 2] = rouge;
			palette[nbCouleurs * 4 + 3] = alpha;
			nbCouleurs++;
//		}
//		pal += 4;
	}

	if (tailleVoulueX==0 || tailleVoulueY==0)
		tailleVoulueX=l, tailleVoulueY=h;

	if (curPF->pfList[curCMode].bAllowUnoptimizedPal && !optimisePal)
		coulTransparente=nbCouleurs;
	else
		coulTransparente=0;

	for (y=0;y<tailleVoulueY;y++)		{
		for (x=0;x<tailleVoulueX;x++)		{
			if (x>=l || y>=h)		{
				tableau[tailleVoulueX*y+x]=coulTransparente;
			}
			else	{
				LitPixRVBA(x,y,&rouge,&vert,&bleu,&alpha);
				if (alpha == 0)		{
					tableau[tailleVoulueX*y+x]=coulTransparente;
					continue;
				}
				rouge=tblCoulR[rouge];
				vert=tblCoulV[vert];
				bleu=tblCoulB[bleu];
				if (curPF->pfList[curCMode].fctConvertColorAfter)
					curPF->pfList[curCMode].fctConvertColorAfter(&rouge,&vert,&bleu);
				bestDifference=difference, bestDiffNum=-1;
				for (i=nbBase;i<nbCouleurs;i++)		{
					if (COLORPALDIFF()<=bestDifference)			{
						bestDiffNum=i;
						bestDifference=COLORPALDIFF();
					}
				}
				i=bestDiffNum;
				if (i==-1)					//Ne devrait pas arriver
					Debug("BUG: gdipCalcPalette#1");
				tableau[tailleVoulueX*y+x]=i;
			}
		}
	}

	if (utilMaxCoul)
		nbCouleurs = nbMax;
	return nbCouleurs;
}

int gdipDisplayImage(HDC hdc, const char *fichier)		{
	using namespace Gdiplus;
	WCHAR wfichier[1024];
	ToW(fichier, wfichier);
	
	InitGDIPlus();
	Image image(wfichier);
	if (image.GetWidth() == 0)
		return 0;
	if (hdc)		{
		Graphics graphics(hdc);
		graphics.DrawImage(&image, 0, 0);
	}
	return 1;
}

