#include "main.h"

/*
	Suggestions
	Etape supplmentaire:
		Supprime les couleurs trop proches et les redistribue pour le post processing.
		En gros, on note toutes les palettes qui ont des couleurs supprimables, et les prend quand mme en compte (comme si
		elles avaient des emplacements libres, quoi), mais pas en priorit. Aprs si a vaut le coup (comment savoir??) on
		supprime ces couleurs de la palette et on recommence.



	Si des palettes ne sont pas compltement utilises, repasser  la fin pour donner les couleurs qu'il reste aux tiles qui mritent!

	xUnfavorNewColorCreation=1000, xPostProcessingCompletePalette=1 : trs bon
	xUnfavorNewColorCreation=1200, xPostProcessingCompletePalette=1 :  tester
	xUnfavorNewColorCreation=2000, xPostProcessingCompletePalette=1 : bon
	xUnfavorNewColorCreation=0, xPostProcessingCompletePalette=1 : normal
*/
typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned long u32;
typedef signed char s8;
typedef signed short s16;
typedef signed long s32;

unsigned long *xSourceBitmap;
int xSourceWidth, xSourceHeight;
HDC xHdcConsole;
int xColorsPerPalette, xNbPalettes;
int xTileX=8, xTileY=8;
//xUnfavorNewColorCreation: -1: dfavorise la cration de nouvelles couleurs (pourri), 0: rien, >0: calcule les diffs entre les couleurs * facteur, -2: calcule pour toute l'image (meilleur rsultat, ultra lent)
//xPostProcessingCompletePalette: post processing qui remplit les palettes inutilises avec les tiles qui le mritent. Utile si unfavorcolorcreation est >0
int xUnfavorNewColorCreation=0, xUseOctree=1, xSuppressNearColors=1;
int xPostProcessingCompletePalette=1;

XPALETTE *xPalettes;
int xUsedPalettes;
int xGblUsedColors;
__int64 xGblScore;

#include "xreduc.hpp"

/*int xLoadBitmap(char *fichier)		{
	HBITMAP hbmConv;
	BITMAP bmConv;
	HDC hdcConv;
	HDC hdcEcran;
	int x,y;
	unsigned long c;

	hdcEcran = GetDC(NULL);
	hbmConv = (HBITMAP) LoadImage(NULL, fichier, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if (!hbmConv)	{
		return 0;
	}
	GetObject(hbmConv, sizeof(bmConv), &bmConv);
	xSourceWidth = bmConv.bmWidth;
	xSourceHeight = bmConv.bmHeight;

	hdcConv = CreateCompatibleDC(hdcEcran);
	SelectObject(hdcConv, hbmConv);
	for (y=0;y<xSourceHeight;y++)
		for (x=0;x<xSourceWidth;x++)		{
			c = GetPixel(hdcConv, x, y);
			xSrc(x, y) = xColor32reduce(xColor15to32(xColor32to15(c)));
			//Transparente?
			if (c != xCouleurMasque)
				xSrc(x, y) |= 0xff000000;
		}

	DeleteObject(hbmConv);
	DeleteDC(hdcConv);
	ReleaseDC(NULL, hdcEcran);
	return 1;
}*/

void xDisplayBitmap()		{
	int x,y;
	for (y=0;y<xSourceHeight;y++)
		for (x=0;x<xSourceWidth;x++)
			SetPixel(xHdcConsole, x, y, xColor15to32(xSrc(x, y)));
}

void xDrawAColor(int x, int y, int c)			{
	int i,j;
	for (j=0;j<16;j++)
		for (i=0;i<16;i++)			{
			SetPixel(xHdcConsole, i+x, j+y, c);
		}
}

void xDisplayPalettes()			{
	int i, j;
	for (j=0;j<xNbPalettes;j++)		{
		for (i=0;i<xColorsPerPalette;i++)		{
			xDrawAColor(i*16, j*16, xColor32expand(xPalettes[j].data[i]));
		}
	}
}

void xDisplayPalette(u32 *pal)			{
	int i;
	for (i=0;i<xColorsPerPalette;i++)		{
		xDrawAColor(i*16, 0, pal[i]);
	}
}

//Calcule et renvoie le nombre de couleurs et stocke une palette ainsi qu'un tableau
//reprsentant l'image 8 bits en utilisant "nbMax" couleurs et une tolrance de
//"diffrence" units RVB.
int xCalcPalette(u32 *tableau, u8 *palette, int x0, int y0, int l, int h, int difference, int nCoulInitiales, int nbBase, int nbMax)		{
	int nbCouleurs=nCoulInitiales, coulTransparente, bestDifference, bestDiffNum;
	int x,y,i;
	u8 rouge,vert,bleu,alpha;

	coulTransparente=0;
	xGblScore = 0;

	for (y=0;y<h;y++)		{
		for (x=0;x<l;x++)		{
			//Alpha: supprimer, c'est que pour GBA
			alpha = (u8)((xSrc(x+x0, y+y0)>>24)&0xff);
			bleu = (u8)((xSrc(x+x0, y+y0)>>16)&0xff);
			vert = (u8)((xSrc(x+x0, y+y0)>>8)&0xff);
			rouge = (u8)(xSrc(x+x0, y+y0)&0xff);
			if (!(xSrc(x+x0, y+y0) & 0xff000000))		{
				tableau[l*y+x]=coulTransparente;
				continue;
			}
/*				rouge=tblCoulR[rouge];
			vert=tblCoulV[vert];
			bleu=tblCoulB[bleu];*/
			bestDifference=difference, bestDiffNum=-1;
			for (i=nbBase;i<nbCouleurs;i++)		{
				if (XCOLORPALDIFF()<=bestDifference)			{
					bestDiffNum=i;
					bestDifference=XCOLORPALDIFF();
				}
			}
			i=bestDiffNum;
			if (i==-1)		{			//La couleur n'existe pas
				i=nbCouleurs;
				palette[4*i]=rouge;
				palette[4*i+1]=vert;
				palette[4*i+2]=bleu;
				palette[4*i+3]=alpha;
				nbCouleurs++;
				if (nbCouleurs>nbMax)			{
					return -1;
				}
			}
			xGblScore += (__int64)sqrt((double)XCOLORPALDIFF());
			tableau[l*y+x]=i;
		}
	}
	return nbCouleurs;
}

int xCalcPaletteMultiple(XPALETTE *pal, u32 *tableau, u8 *palette, int l, int h, int difference, int nCoulInitiales, int nbBase, int nbMax)		{
	int nbCouleurs=nCoulInitiales, coulTransparente, bestDifference, bestDiffNum;
	int x,y,i, p,x0,y0;
	u8 rouge,vert,bleu, alpha;

	coulTransparente=0;
	xGblScore = 0;

	for (p=0;p<pal->nbAssocTiles;p++)		{
		x0 = pal->associatedTiles[p].x;
		y0 = pal->associatedTiles[p].y;
		for (y=0;y<h;y++)		{
			for (x=0;x<l;x++)		{
				//Alpha: supprimer, c'est que pour GBA
				alpha = (u8)((xSrc(x+x0, y+y0)>>24)&0xff);
				bleu = (u8)((xSrc(x+x0, y+y0)>>16)&0xff);
				vert = (u8)((xSrc(x+x0, y+y0)>>8)&0xff);
				rouge = (u8)(xSrc(x+x0, y+y0)&0xff);
				if (!(xSrc(x+x0, y+y0) & 0xff000000))		{
					tableau[l*y+x]=coulTransparente;
					continue;
				}
	/*				rouge=tblCoulR[rouge];
				vert=tblCoulV[vert];
				bleu=tblCoulB[bleu];*/
				bestDifference=difference, bestDiffNum=-1;
				for (i=nbBase;i<nbCouleurs;i++)		{
					if (XCOLORPALDIFF()<=bestDifference)			{
						bestDiffNum=i;
						bestDifference=XCOLORPALDIFF();
					}
				}
				i=bestDiffNum;
				if (i==-1)		{			//La couleur n'existe pas
					i=nbCouleurs;
					palette[4*i]=rouge;
					palette[4*i+1]=vert;
					palette[4*i+2]=bleu;
					palette[4*i+3]=alpha;
					nbCouleurs++;
					if (nbCouleurs>nbMax)			{
						return -1;
					}
				}
				xGblScore += (__int64)sqrt((double)XCOLORPALDIFF());
				tableau[l*y+x]=i;
			}
		}
	}
	return nbCouleurs;
}


void test_tablo(int x0, int y0, int l, int h, u32 *tableau, u32 *palette)		{
	int x,y;
	for (y=0;y<h;y++)
		for (x=0;x<l;x++)			{
			SetPixel(xHdcConsole, x+x0, y+y0, xColor32expand(palette[tableau[y*l+x]]));
		}
}

void xTestOptimalTilesetOnTile(int palnb, u32 *tableau, u32 *palette, int x, int y, int l, int h, int precisionMax, int nCoul)			{
	int nbCouleurs, prec, i, nCMax;
	int nCoulInitiales=1, nCoulBase=1;

	//Cre la palette
	memcpy(palette, xPalettes[palnb].data, sizeof(*palette)*xColorsPerPalette);
	nCoulInitiales = xPalettes[palnb].usedColors;
	nCoulBase = 1;

	if (xUseOctree)			{
		nbCouleurs = xReductionOctree(tableau, palette, x, y, l, h, nCoulInitiales, nCoul);
		if (nbCouleurs == 0)
			goto quandmeme;
	}
	else			{
quandmeme:
		nbCouleurs = xCalcPalette(tableau, (u8*)palette, x, y, l, h, 0, nCoulInitiales, nCoulBase, nCoul);
		prec=0;
		i=precisionMax;
		nCMax=-1;

		if (nbCouleurs==-1)		{
			//Petit algo cod  part pour trouver rapidement la meilleure prcision
			int plagemin=-1, plagemax=precisionMax;
			int numeroactuel, max;

			numeroactuel = plagemax;
			max = plagemax;
			while(plagemin+1<plagemax)		{
				nbCouleurs = xCalcPalette(tableau, (u8*)palette, x, y, l, h, numeroactuel, nCoulInitiales, nCoulBase, nCoul);
				if (nbCouleurs!=-1)			{
					plagemax = numeroactuel;
					if (numeroactuel == plagemin + 1)
						numeroactuel--;
					else
						numeroactuel = (numeroactuel + plagemin)/2;
				}
				else	{
					plagemin = numeroactuel;
					if (numeroactuel == plagemax - 1)
						numeroactuel++;
					else
						numeroactuel = (numeroactuel + plagemax)/2;
				}
			}
			prec = plagemax;

			nbCouleurs = xCalcPalette(tableau, (u8*)palette, x, y, l, h, prec, nCoulInitiales, nCoulBase, nCoul);
			if (nbCouleurs<1)		{
				printf("Impossible de convertir la bitmap car le nombre de couleurs requis ne peut tre atteint\n");
				return;
			}
		}
	}
	xGblUsedColors = nbCouleurs;
//	test_tablo(x,y, l, h, tableau, palette);
}

void xTestOptimalTilesetOnMultipleTiles(XPALETTE *p, u32 *tableau, u32 *palette, int l, int h, int precisionMax, int nCoul)			{
	int nbCouleurs, prec, i, nCMax;
	int nCoulInitiales=1, nCoulBase=1;

	//Cre la palette
	memcpy(palette, p->data, sizeof(*palette)*xColorsPerPalette);
	nCoulInitiales = 1;
	nCoulBase = 1;

	if (xUseOctree)			{
		nbCouleurs = xReductionOctreeMultiple(p, tableau, (u8*)palette, l, h, nCoulInitiales, nCoul);
		if (nbCouleurs == 0)
			goto quandmeme;
	}
	else			{
quandmeme:
		nbCouleurs = xCalcPaletteMultiple(p, tableau, (u8*)palette, l, h, 0, nCoulInitiales, nCoulBase, nCoul);
		prec=0;
		i=precisionMax;
		nCMax=-1;

		if (nbCouleurs==-1)		{
			//Petit algo cod  part pour trouver rapidement la meilleure prcision
			int plagemin=-1, plagemax=precisionMax;
			int numeroactuel, max;

			numeroactuel = plagemax;
			max = plagemax;
			while(plagemin+1<plagemax)		{
				nbCouleurs = xCalcPaletteMultiple(p, tableau, (u8*)palette, l, h, numeroactuel, nCoulInitiales, nCoulBase, nCoul);
				if (nbCouleurs!=-1)			{
					plagemax = numeroactuel;
					if (numeroactuel == plagemin + 1)
						numeroactuel--;
					else
						numeroactuel = (numeroactuel + plagemin)/2;
				}
				else	{
					plagemin = numeroactuel;
					if (numeroactuel == plagemax - 1)
						numeroactuel++;
					else
						numeroactuel = (numeroactuel + plagemax)/2;
				}
			}
			prec = plagemax;

			nbCouleurs = xCalcPaletteMultiple(p, tableau, (u8*)palette, l, h, prec, nCoulInitiales, nCoulBase, nCoul);
			if (nbCouleurs<1)		{
				printf("Impossible de convertir la bitmap car le nombre de couleurs requis ne peut tre atteint\n");
				return;
			}
		}
	}
	xGblUsedColors = nbCouleurs;
//	test_tablo(x,y, l, h, tableau, palette);
}

int xRenderPalette(u32 *tableau, u8 *palette, int x0, int y0, int l, int h, int difference, int nCoulInitiales, int nbBase, int nbMax)		{
	int nbCouleurs=nbMax, coulTransparente, bestDifference, bestDiffNum;
	int x,y,i;
	u8 rouge,vert,bleu,alpha;

	coulTransparente=0;
	xGblScore = 0;

	for (y=0;y<h;y++)		{
		for (x=0;x<l;x++)		{
			//Alpha: supprimer, c'est que pour GBA
			alpha = (u8)((xSrc(x+x0, y+y0)>>24)&0xff);
			bleu = (u8)((xSrc(x+x0, y+y0)>>16)&0xff);
			vert = (u8)((xSrc(x+x0, y+y0)>>8)&0xff);
			rouge = (u8)(xSrc(x+x0, y+y0)&0xff);
			if (!(xSrc(x+x0, y+y0) & 0xff000000))		{
				tableau[l*y+x]=coulTransparente;
				continue;
			}
			bestDifference=0, bestDiffNum=-1;
			for (i=nbBase;i<nbCouleurs;i++)		{
				if (XCOLORPALDIFF()<=bestDifference || bestDiffNum == -1)			{
					bestDiffNum=i;
					bestDifference=XCOLORPALDIFF();
				}
			}
			i=bestDiffNum;
			xGblScore += (__int64)sqrt((double)XCOLORPALDIFF());
			tableau[l*y+x]=i;
		}
	}
	return nbCouleurs;
}

int xRenderPaletteMultiple(XPALETTE *pal, u32 *tableau, u8 *palette, int l, int h, int difference, int nCoulInitiales, int nbBase, int nbMax)		{
	int nbCouleurs=nbMax, coulTransparente, bestDifference, bestDiffNum;
	int x,y,i, p, x0, y0;
	u8 rouge,vert,bleu,alpha;

	coulTransparente=0;
	xGblScore = 0;

	for (p=0;p<pal->nbAssocTiles;p++)		{
		x0 = pal->associatedTiles[p].x;
		y0 = pal->associatedTiles[p].y;
		for (y=0;y<h;y++)		{
			for (x=0;x<l;x++)		{
				//Alpha: supprimer, c'est que pour GBA
				alpha = (u8)((xSrc(x+x0, y+y0)>>24)&0xff);
				bleu = (u8)((xSrc(x+x0, y+y0)>>16)&0xff);
				vert = (u8)((xSrc(x+x0, y+y0)>>8)&0xff);
				rouge = (u8)(xSrc(x+x0, y+y0)&0xff);
				if (!(xSrc(x+x0, y+y0) & 0xff000000))		{
					tableau[l*y+x]=coulTransparente;
					continue;
				}
	/*				rouge=tblCoulR[rouge];
				vert=tblCoulV[vert];
				bleu=tblCoulB[bleu];*/
				bestDifference=0, bestDiffNum=-1;
				for (i=nbBase;i<nbCouleurs;i++)		{
					if (XCOLORPALDIFF()<=bestDifference || bestDiffNum == -1)			{
						bestDiffNum=i;
						bestDifference=XCOLORPALDIFF();
					}
				}
				i=bestDiffNum;
				xGblScore += (__int64)sqrt((double)XCOLORPALDIFF());
				tableau[l*y+x]=i;
			}
		}
	}
	return nbCouleurs;
}

void xApplyOptimalTilesetPalData(u32 *tableau, u32 *palette, int x, int y, int l, int h, int precisionMax, int nCoul)			{
	//Cre la palette
//	memcpy(palette, pal, sizeof(*palette)*xColorsPerPalette);
	xRenderPalette(tableau, (u8*)palette, x, y, l, h, 0, 2, 2, nCoul);
}

void xApplyOptimalTilesetPalDataMultiple(XPALETTE *p, u32 *tableau, u32 *palette, int l, int h, int precisionMax, int nCoul)			{
	//Cre la palette
//	memcpy(palette, pal, sizeof(*palette)*xColorsPerPalette);
	xRenderPaletteMultiple(p, tableau, (u8*)palette, l, h, 0, 1, 1, nCoul);
}

void xApplyOptimalTileset(int palnb, u32 *tableau, u32 *palette, int x, int y, int l, int h, int precisionMax, int nCoul)			{
	//Cre la palette
	memcpy(palette, xPalettes[palnb].data, sizeof(*palette)*xColorsPerPalette);
	xRenderPalette(tableau, (u8*)palette, x, y, l, h, 0, 1, 1, xPalettes[palnb].usedColors);
}

int xGetBestPaletteForTile(u32 *tableau, u32 *palette, int x, int y, int l, int h, int precisionMax, int nCoul)		{
	int i, bestPalette=-1;
	__int64 minScore;
	minScore = 0;
	for (i=0;i<xUsedPalettes;i++)		{
		xApplyOptimalTileset(i, tableau,palette, x,y, xTileX,xTileY, 250000, xColorsPerPalette);
		if (xGblScore < minScore || bestPalette == -1)			{
			bestPalette = i;
			minScore = xGblScore;
		}
	}
	return bestPalette;
}

void xAddPalette(u32 *palette, int usedColors, int tileX, int tileY)			{
	memcpy(xPalettes[xUsedPalettes].data, palette, usedColors*sizeof(*palette));
	xPalettes[xUsedPalettes].usedColors = usedColors;
	xPalettes[xUsedPalettes].associatedTiles[0].x = tileX;
	xPalettes[xUsedPalettes].associatedTiles[0].y = tileY;
	xPalettes[xUsedPalettes].nbAssocTiles = 1;
	xUsedPalettes++;
}

void xReplacePalette(XPALETTE *p, u32 *palette, int usedColors, int tileX, int tileY)			{
	memcpy(p->data, palette, usedColors*sizeof(*palette));
	p->usedColors = usedColors;
}

void xAddTileToPalette(XPALETTE *p, int x, int y)		{
	if (p->nbAssocTiles >= xMaxTilesPerPalette)			{
		Debug("FATAL ERROR: TOO MUCH TILES PER PALETTE!");
		return;
	}
	p->associatedTiles[p->nbAssocTiles].x = x;
	p->associatedTiles[p->nbAssocTiles].y = y;
	p->nbAssocTiles++;
}

void xWriteTile(unsigned long **motifs, u32 *tableau)			{
	int i,j;
	for (j=0;j<xTileY;j++)			{
		for (i=0;i<xTileX;i++)			{
			**motifs = tableau[xTileX*j+i];
			*motifs = *motifs + 1;
		}
	}
}

inline int xColorDiff(int c1, int c2)			{
	return (int)sqrt((double)(ABS((c1&0xff)-(c2&0xff))*ABS((c1&0xff)-(c2&0xff))+ABS(((c1>>8)&0xff)-((c2>>8)&0xff))*ABS(((c1>>8)&0xff)-((c2>>8)&0xff))+ABS(((c1>>16)&0xff)-((c2>>16)&0xff))*ABS(((c1>>16)&0xff)-((c2>>16)&0xff))));
}

__int64 xCalcWholeImageScore()			{
	//ATTENTION!!!!
	u32 palette[xMaxColorsPerPalette+2];
	u32 tableau[xTileMaxX*xTileMaxY];
	int x,y, pal;
	__int64 score;
	score=0;
	for (y=0;y<xSourceHeight;y+=xTileY)
		for (x=0;x<xSourceWidth;x+=xTileX)			{
			pal = xGetBestPaletteForTile(tableau,palette, x,y, xTileX,xTileY, 250000, xColorsPerPalette);
			xApplyOptimalTileset(pal, tableau,palette, x,y, xTileX,xTileY, 250000, xColorsPerPalette);
			score+=xGblScore;
		}
	return score;
}


int xTest(int precisionMax, int nCoul, unsigned long *motifs, unsigned long *map, unsigned long *syspal)			{
	//ATTENTION!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	u32 palette[xMaxColorsPerPalette+2];
	u32 tableau[xTileMaxX*xTileMaxY];
	int i,j, pal, curPal;
	int curTileX, curTileY;
	__int64 maxScore;
	int x,y, tmp;
	XPALETTE temp;
//	FILE *f, *map, *til;
	int tileNb, neededPalette;

	if ((xColorsPerPalette >= xMaxColorsPerPalette) ||
		(xNbPalettes >= xMaxNbPalettes))
		return 0;
	//Premire tape: trouver les meilleures palettes possibles
	//1-1: premire palette: la tile la plus gourmande
	maxScore = -1;
	for (y=0;y<xSourceHeight;y+=xTileY)
		for (x=0;x<xSourceWidth;x+=xTileX)			{
			xTestOptimalTilesetOnTile(0, tableau,palette, x,y, xTileX,xTileY, 250000, xColorsPerPalette);
			if (xGblScore > maxScore || maxScore == -1)
				maxScore = xGblScore, curTileX = x, curTileY = y;
		}

	xTestOptimalTilesetOnTile(0, tableau,palette, curTileX,curTileY, xTileX,xTileY, 250000, xColorsPerPalette);
	xAddPalette(palette, xGblUsedColors, curTileX, curTileY);
	printf("%i %i %i %i\n", xUsedPalettes, maxScore, curTileX, curTileY);

	while (xUsedPalettes < xNbPalettes)			{
		maxScore = -1;
		for (y=0;y<xSourceHeight;y+=xTileY)
			for (x=0;x<xSourceWidth;x+=xTileX)			{
				pal = xGetBestPaletteForTile(tableau,palette, x,y, xTileX,xTileY, 250000, xColorsPerPalette);
				xApplyOptimalTileset(pal, tableau,palette, x,y, xTileX,xTileY, 250000, xColorsPerPalette);
				if (xGblScore > maxScore || maxScore == -1)
					maxScore = xGblScore, curTileX = x, curTileY = y;
			}

		xTestOptimalTilesetOnTile(xUsedPalettes, tableau,palette, curTileX,curTileY, xTileX,xTileY, 250000, xColorsPerPalette);
		xAddPalette(palette, xGblUsedColors, curTileX, curTileY);
		if (xGblUsedColors == 0)			{
			printf("ERROR %i %i %i",pal, curTileX, curTileY);
		}
		printf("%i %i %i %i\n", xUsedPalettes, maxScore, curTileX, curTileY);
	}

	xDisplayPalettes();
/*	if (xSuppressNearColors)			{
		while(1)		{
			i=0;
			j = xGetNearColor(xPalettes[i], 100);
			memmove(xPalettes[i].data+j, xPalettes[i].data+j+1, xColorsPerPalette-xPalettes[i].usedColors-1);
		}
	}
	xDisplayPalettes();*/

	//Seconde tape: trouver quelle tile va avec quelle palette
	for (y=0;y<xSourceHeight;y+=xTileY)			{
		for (x=0;x<xSourceWidth;x+=xTileX)			{
			maxScore = -1;
			for (i=0;i<xUsedPalettes;i++)		{
				memcpy(&temp, &xPalettes[i], sizeof(temp));
				xAddTileToPalette(&temp, x, y);
				xTestOptimalTilesetOnMultipleTiles(&temp, tableau,palette, xTileX,xTileY, 250000, xColorsPerPalette);
				if (xUnfavorNewColorCreation > 0)			{
					for (tmp=0;tmp<xGblUsedColors;tmp++)		{
						if (palette[tmp] != xPalettes[i].data[tmp])
							xGblScore += xUnfavorNewColorCreation * xColorDiff(palette[tmp], xPalettes[i].data[tmp]);
					}
				}
				//Dsactiv pour test
				if (xUnfavorNewColorCreation == -1)
					xGblScore += (xGblUsedColors - xPalettes[i].usedColors)*100;
				else if (xUnfavorNewColorCreation == -2)			{
					XPALETTE temp2;
					memcpy(&temp2, &xPalettes[i], sizeof(temp2));
					xGblScore = xCalcWholeImageScore();
					memcpy(&xPalettes[i], &temp2, sizeof(temp2));
				}
				if (xGblScore < maxScore || maxScore == -1)
					maxScore = xGblScore, curTileX = x, curTileY = y, curPal = i;
			}
			i = curPal;
			xAddTileToPalette(&xPalettes[i], x, y);
			xTestOptimalTilesetOnMultipleTiles(&xPalettes[i], tableau,palette, xTileX,xTileY, 250000, xColorsPerPalette);
			xReplacePalette(&xPalettes[i], palette, xGblUsedColors, curTileX, curTileY);
			test_tablo(x,y, xTileX, xTileY, tableau, palette);
		}
	}


	xDisplayPalettes();

	/*
		POST PROCESSING DE TEST!!!!!
		Algo possible: pour chaque palette dans laquelle il manque des couleurs, on
		essaie de caser une tile qui remplira cette palette. Celle qui amliore le plus
		le score final est prise.
	*/

	if (xPostProcessingCompletePalette)		{
/*		unsigned char *used;
		used = (unsigned char*)malloc((xSourceWidth/xTileX)*(xSourceHeight/xTileY)*sizeof(char));
		memset(used, 0, (xSourceWidth/xTileX)*(xSourceHeight/xTileY)*sizeof(char));
		while(1)			{
			neededPalette = -1;
			j=0;
			for (i=0;i<xUsedPalettes;i++)			{
				if (xPalettes[i].usedColors < xColorsPerPalette)			{
					neededPalette = i;
					j += xColorsPerPalette - xPalettes[i].usedColors;
				}
			}
			//Plus de palette libre
			if (neededPalette == -1)
				break;
			printf("Free colors: %i\n", j);

			maxScore = -1;
			//Seconde tape: trouver quelle tile va avec quelle palette
			for (y=0;y<xSourceHeight;y+=xTileY)
				for (x=0;x<xSourceWidth;x+=xTileX)			{
					for (i=0;i<xUsedPalettes;i++)		{
						if (xPalettes[i].usedColors >= xColorsPerPalette)
							continue;
						pal = xGetBestPaletteForTile(tableau,palette, x,y, xTileX,xTileY, 250000, xColorsPerPalette);
						xApplyOptimalTileset(pal, tableau,palette, x,y, xTileX,xTileY, 250000, xColorsPerPalette);
						if ((xGblScore > maxScore || maxScore == -1) && !used[(y/xTileY)*(xSourceWidth/xTileX)+(x/xTileX)])
							maxScore = xGblScore, curTileX = x, curTileY = y, curPal = i;
					}
				}
			if (maxScore == -1)
				break;
			i = curPal;
			xTestOptimalTilesetOnTile(i, tableau, palette, curTileX, curTileY, xTileX,xTileY, 250000, xColorsPerPalette);
			xReplacePalette(&xPalettes[i], palette, xGblUsedColors, curTileX, curTileY);
			used[(curTileY/xTileY)*(xSourceWidth/xTileX)+(curTileX/xTileX)]=1;
//			test_tablo(curTileX,curTileY, xTileX, xTileY, tableau, palette);
		}

		free(used);
		xDisplayPalettes();*/
		u8 *used;
		int usedWidth = xSourceWidth / xTileX;
		used = (u8*)malloc(usedWidth * (xSourceHeight / xTileY));
		memset(used, 0, usedWidth * (xSourceHeight / xTileY));
		while(1)			{
			neededPalette = -1;
			j=0;
			for (i=0;i<xUsedPalettes;i++)			{
				if (xPalettes[i].usedColors < xColorsPerPalette)			{
					neededPalette = i;
					j += xColorsPerPalette - xPalettes[i].usedColors;
				}
			}
			//Plus de palette libre
			if (neededPalette == -1)
				break;
			printf("Free colors: %i\n", j);

			maxScore = -1;
			//Seconde tape: trouver quelle tile va avec quelle palette
			for (y=0;y<xSourceHeight;y+=xTileY)
				for (x=0;x<xSourceWidth;x+=xTileX)			{
					for (i=0;i<xUsedPalettes;i++)		{
						if (xPalettes[i].usedColors >= xColorsPerPalette)
							continue;
						pal = xGetBestPaletteForTile(tableau,palette, x,y, xTileX,xTileY, 250000, xColorsPerPalette);
						xApplyOptimalTileset(pal, tableau,palette, x,y, xTileX,xTileY, 250000, xColorsPerPalette);
						if ((xGblScore > maxScore || maxScore == -1) && !used[y/xTileY * usedWidth + x/xTileX])
							maxScore = xGblScore, curTileX = x, curTileY = y, curPal = i;
					}
				}
			if (maxScore == -1)
				break;
			i = curPal;
			xTestOptimalTilesetOnTile(i, tableau, palette, curTileX, curTileY, xTileX,xTileY, 250000, xColorsPerPalette);
			xReplacePalette(&xPalettes[i], palette, xGblUsedColors, curTileX, curTileY);
			used[curTileY/xTileY * usedWidth + curTileX/xTileX]=1;
//			test_tablo(curTileX,curTileY, xTileX, xTileY, tableau, palette);
		}

		free(used);
		xDisplayPalettes();
	}

	/*
		END POST PROCESSING DE TEST!!!!!
	*/

/*	til = fopen("tileset.c", "w");
	fprintf(til, "const unsigned char tileset[]=		{\n	");

	map = fopen("map.c", "w");
	fprintf(map, "const unsigned short map[]=		{\n	");*/

	tileNb = 0;
	for (y=0;y<xSourceHeight;y+=xTileY)
		for (x=0;x<xSourceWidth;x+=xTileX)			{
			pal = xGetBestPaletteForTile(tableau,palette, x,y, xTileX,xTileY, 250000, xColorsPerPalette);
			xApplyOptimalTileset(pal, tableau,palette, x,y, xTileX,xTileY, 250000, xColorsPerPalette);
			xWriteTile(&motifs, tableau);
//			map[(y/tileY)*(tailleX/tileX)+x/tileX] = tileNb|(pal<<12);
//			map[(y/xTileY)*(xSourceWidth/xTileX)+x/xTileX] = tileNb|(pal<<12);
			map[tileNb] = tileNb|(pal<<curPF->mf[ModeTexte].paletteShift);
//			fprintf(map, "0x%x, ", tileNb|(pal<<12));
			tileNb++;
			test_tablo(x,y, xTileX, xTileY, tableau, palette);
		}

	for (j=0;j<xUsedPalettes;j++)		{
		for (i=0;i<xColorsPerPalette;i++)
			*syspal++ = xPalettes[j].data[i];
	}
	RedrawWindow(gblHDlg,NULL,NULL,RDW_ERASE|RDW_INVALIDATE);
	return j*xColorsPerPalette;

/*	fseek(map, -2, SEEK_CUR);
	fprintf(map, "\n};\n\n\n");
	fclose(map);

	fseek(til, -2, SEEK_CUR);
	fprintf(til, "\n};\n\n\n");
	fclose(til);*/

/*	f = fopen("palettes.c", "w");
	fprintf(f, "const unsigned short palette[]=		{\n	");
	for (j=0;j<xUsedPalettes;j++)		{
		for (i=0;i<16;i++)
			fprintf(f, "0x%04x, ", xColor32to15(xColor32expand(xPalettes[j].data[i])));
	}
	fseek(f, -2, SEEK_CUR);
	fprintf(f, "\n};\n\n\n");
	fclose(f);*/
}


void xInitConversion()		{
	int i;
	xPalettes = new XPALETTE[xMaxNbPalettes];
	xUsedPalettes = 0;
	for (i=0;i<xNbPalettes;i++)			{
		xPalettes[i].usedColors = 1;
		xPalettes[i].nbAssocTiles = 0;
		memset(xPalettes[i].data, 0, xMaxColorsPerPalette * sizeof(u32));
		memset(xPalettes[i].associatedTiles, 0, xMaxTilesPerPalette*sizeof(POINT));
//		xPalettes[i].associatedTiles = (POINT*)malloc(xMaxTilesPerPalette*sizeof(POINT));
	}
}

void xDeinitConversion()		{
	delete[] xPalettes;
}

unsigned long *xConvertTilesetToBitmap(unsigned long *motifs, int nTiles, int tileX, int tileY)			{
	unsigned long *newmotifs;
	int i, x, y, xx, yy;
	newmotifs = (unsigned long*)malloc(nTiles*tileX*tileY*sizeof(long));
	x=y=0;
	nTiles = (nTiles*tileX*tileY)/64;
	for (i=0;i<nTiles;i++)		{
		for (yy=0;yy<8;yy++)		{
			for (xx=0;xx<8;xx++)		{
				newmotifs[tileX*(y+yy)+(x+xx)] = motifs[i*8*8+yy*8+xx];
			}
		}
		x += 8;
		if (x >= tileX)		{
			x = 0;
			y += 8;
		}
	}
	return newmotifs;
}

void xReduceBitmapColorsToPlatform(unsigned long *motifs, int tailleX, int tailleY)			{
	int i;
	unsigned char *c, r, v, b, a;
	for (i=0;i<tailleX*tailleY;i++)
	{
		c = (unsigned char*)&motifs[i];
		b = *c++;
		v = *c++;
		r = *c++;
		a = *c++;
		b = tblCoulB[b];
		v = tblCoulV[v];
		r = tblCoulR[r];
		c = (unsigned char*)&motifs[i];
		*c++ = b;
		*c++ = v;
		*c++ = r;
		*c++ = a;
	}
}

unsigned long *xConvertBitmapToTileset(unsigned long *motifs, int nTiles, int tileX, int tileY)			{
	unsigned long *newmotifs;
	int i, x, y, xx, yy;
	newmotifs = (unsigned long*)malloc(nTiles*tileX*tileY*sizeof(long));
	x=y=0;
	nTiles = (nTiles*tileX*tileY)/64;
	for (i=0;i<nTiles;i++)		{
		for (yy=0;yy<8;yy++)		{
			for (xx=0;xx<8;xx++)		{
				newmotifs[i*8*8+yy*8+xx] = motifs[tileX*(y+yy)+(x+xx)];
			}
		}
		x += 8;
		if (x >= tileX)		{
			x = 0;
			y += 8;
		}
	}
	return newmotifs;
}

void xInvertBGR32(unsigned long *motifs, int size)		{
	while (size--)		{
		*motifs = ((((*motifs)>>24)&0xff)<<24) | (((*motifs)>>16)&0xff) | ((((*motifs)>>8)&0xff)<<8) | (((*motifs)&0xff)<<16);
		motifs++;
	}
}
