#include "main.h"

//Variables de conversion. Je programme vraiment comme un boucher, c'est incroyable!
BOOL bGenereMap=TRUE, bOptimiseTileset=TRUE, bUtilTileset=-1;
int utilPalette=-1;

#include "reduction.hpp"

BOOL ConvertitBitmap(ELEMENT *els,int nCoul)		{
	int i, nbCouleurs, nEcrits=0, nCMax, prec, nCoulInitiales, nCoulBase;
	unsigned long *tableau;
	unsigned char *palette;

//	MessageBox(NULL,elements[nE].nom_palette,elements[nE].nom_base,0);

	tableau=(unsigned long*)malloc(tailleX*tailleY*sizeof(long));
	palette=(unsigned char*)malloc((curPF->nbMaxColors+1)*4);

	tailleVoulueX=tailleVoulueY=0;

	if (curPF->pfList[curCMode].bUsePalettes)			{
		if (utilPalette>=0)			{
			nCoulInitiales=LitPalette(palette, &els[1], TRUE, FALSE) - 1;
			if (optimisePal)
				nCoulBase=0;
			else
				nCoulBase=nCoulInitiales;
		}
		else
			nCoulInitiales=nCoulBase=0;

		if (curPF->pfList[curCMode].bFirstColorTransparent)
			memmove(palette,palette+4,nCoulInitiales*4);
	/*	for (i=0;i<nCoulInitiales;i++)			{
			palette[4*i]/=MULTB;
			palette[4*i+1]/=MULTV;
			palette[4*i+2]/=MULTR;
		}*/

		if (modeConversion==0)			{
			//Cre la palette
			nbCouleurs=CalcPaletteBmp8(tableau,palette,tailleY,tailleX,0,nCoulInitiales,nCoulBase,nCoul);
			prec=0;
			i=precisionMax;
			nCMax=-1;

			if (nbCouleurs==-1)		{
				if (messages)		{
					CacheTravail();
					if (MessageBox(gblHDlg,"La bitmap contient plus de couleurs que le nombre demand.\nUn filtre va lui tre appliqu, cependant ceci peut durer long...","Question",MB_ICONINFORMATION | MB_OKCANCEL)==IDCANCEL)
						return 0;
					AffTravail();
				}
				while(1)		{
					nbCouleurs=CalcPaletteBmp8(tableau,palette,tailleY,tailleX,i,nCoulInitiales,nCoulBase,nCoul);
					if (nbCouleurs>nCMax)		{
						nCMax=nbCouleurs;
						prec=i;
					}
					if (nbCouleurs==-1)		{
						break;
					}
					if (i<=0)
						break;
					i--;
				}
				nbCouleurs=CalcPaletteBmp8(tableau,palette,tailleY,tailleX,prec,nCoulInitiales,nCoulBase,nCoul);
				if (nbCouleurs<1)		{
					CacheTravail();
					MessageBox(gblHDlg,"Impossible de convertir la bitmap car le nombre de couleurs requis ne peut tre atteint","Oups...",MB_ICONERROR);
					return 0;
				}
			}
		}
		else if (modeConversion==1)		{
			nbCouleurs=ReductionHalftone(tableau,palette,tailleY,tailleX);
		}
		else if (modeConversion==2)		{
			nbCouleurs=ReductionOctree(tableau,palette,tailleY,tailleX,nCoulInitiales,nCoul-1);
			if (nbCouleurs<1)
				return 0;
		}

		//Support couleur transparente
		if (curPF->pfList[curCMode].bFirstColorTransparent)		{
			memmove(palette+4,palette,nbCouleurs*4);
			palette[0]=bleuZero;
			palette[1]=vertZero;
			palette[2]=rougeZero;
			palette[3]=0;
			nbCouleurs++;
		}
		//Fin support
	}
	else		{
		CreeTableauConversion(tableau,palette, tailleY, tailleX);
	}

/*	if (curPF->pfList[curCMode].bUsePalettes && !curPF->pfList[curCMode].bFirstColorTransparent)			{
		for (i=0;i<tailleX*tailleY;i++)		{
			if (tableau[i] > 0)
				tableau[i]--;
		}
	}*/
	curPF->fctBitmapWrite(PL_STD, &curCMode, &els[0], &els[1], tableau, palette, tailleX, tailleY);
	if (curPF->pfList[curCMode].bUsePalettes)			{
		curPF->fctPaletteWrite(PL_STD, &curCMode, &els[1], palette, nbCouleurs);
	}
	free(tableau);
	free(palette);
	return 1;
}


//Convertit une bitmap et crit une liste de mosaques, une palette et une map
//Nota bene: ici dans:
// -els[0] se trouve le fichier de base (mosaque)
// -els[1] se trouve la palette
// -els[2] se trouve la map

int ConvertitTiles(ELEMENT *els,int nCoul)		{
	int i,j, nE=nbreElements-2, nbCouleurs, nEcrits=0, nCMax, prec;
	int nCoulInitiales, nCoulBase, tileBase;
	unsigned long *tableau;
	unsigned char *palette;
	unsigned long *motifs;
	BOOL bUsePalettes;
	MAP *map;
	//Attention: c'est pour a que tileX et tileY doivent tre strictement infrieurs ou gaux  64
	unsigned long motif_temp[64*64];
	int nTiles, x,y,k, xx, yy;
	int HUHU, bPaletteIntacte = 0;

	HUHU = (curPF->pfList[curCMode].bUsePalettes == 2) && (nCoul>curPF->pfList[curCMode].nColorsPerPalette);
	if (tailleVoulueX==0)
		tailleVoulueX=tailleX;
	if (tailleVoulueY==0)
		tailleVoulueY=tailleY;

	//Mal  la tte. Pas envie de chercher un algo pour calculer.
	while (tailleVoulueX%tileX != 0)
		tailleVoulueX++;
	while (tailleVoulueY%tileY != 0)
		tailleVoulueY++;

	//Alloue la mmoire (une belle somme mine de rien)
	tableau=(unsigned long*)malloc(tailleVoulueX*tailleVoulueY*sizeof(long));
	palette=(unsigned char*)malloc((curPF->nbMaxColors+100)*4);
	motifs=(unsigned long*)malloc(tileX*tileY*TILEMAX*sizeof(long));
	map=(MAP*)malloc((tailleVoulueX/tileX)*(tailleVoulueY/tileY)*sizeof(MAP));
	if (!tableau || !palette || !motifs || !map)
		return 0;
	//Ncessaire si on commence  la tile n2 (premire tile toujours transparente)
	memset(motifs, 0, tileX*tileY*TILEMAX*sizeof(long));

	bUsePalettes = (curPF->pfList[curCMode].bUsePalettes && !HUHU);
	//Gestion des palettes, sauf si on est en mode 16 bits
	if (bUsePalettes)			{
		if (utilPalette>=0)			{
			nCoulInitiales=LitPalette(palette, &els[1], TRUE, FALSE) /*-1*/;
			if (optimisePal /*&& !b16coul*/)
				nCoulBase=0;
			else		{
				nCoulBase=nCoulInitiales;
				// Si on a dsactiv l'optimisation des palettes (!upal=...), on va simplement concatner  la palette existante
				if (curPF->pfList[curCMode].bAllowUnoptimizedPal)		{
//					nCoulInitiales+=16-((nCoulInitiales)%16);
//					nCoul=nCoulInitiales+15;
					// Arrondit la palette au nombre de couleurs qu'elle contient normalement
					if (nCoulInitiales % curPF->pfList[curCMode].nColorsPerPalette)
						nCoulInitiales += curPF->pfList[curCMode].nColorsPerPalette - (nCoulInitiales % curPF->pfList[curCMode].nColorsPerPalette);
					nCoul=nCoulInitiales+curPF->pfList[curCMode].nColorsPerPalette /*-1*/;
				}
			}
		}
		else
			nCoulInitiales=nCoulBase=0;

		if (gdipPalettesIdentical(palette, nCoulInitiales, nCoul))
			bPaletteIntacte = 1;
		else
			bPaletteIntacte = 0;

		// Supprime ventuellement la premire couleur (transparente)
		if (curPF->pfList[curCMode].bFirstColorTransparent && !bPaletteIntacte)		{
			memmove(palette,palette+4,nCoulInitiales*4);
//			nCoulInitiales = max(nCoulInitiales - 1, 0);
			// Fait pour corriger le problme du nCoulInitiales < nCoulBase qui n'est pas permis (cf CalcPalette)
			nCoulInitiales = max(nCoulInitiales - 1, nCoulBase);
		}

/*		for (i=0;i<nCoulInitiales;i++)			{
			palette[4*i]/=MULTB;
			palette[4*i+1]/=MULTV;
			palette[4*i+2]/=MULTR;
		}*/

		//Dj une palette charge?
		if (bPaletteIntacte)			{
			nbCouleurs = gdipCalcPalette(tableau,palette,tailleY,tailleX,nCoulInitiales,nCoulBase,nCoul);
		}
		else if (modeConversion==0)			{
			//Cre la palette
			nbCouleurs=CalcPalette(tableau,palette,tailleY,tailleX,0,nCoulInitiales,nCoulBase,nCoul);
			prec=0;
			i=precisionMax;
			nCMax=-1;

			if (nbCouleurs==-1)		{
				if (messages)		{
					CacheTravail();
					if (MessageBox(gblHDlg,"La bitmap contient plus de couleurs que le nombre demand.\nUn filtre va lui tre appliqu (ne vous inquitez pas ce sera bien mieux qu'avec Paint ;)\nCependant ceci peut durer long... trs long!","Coucou :D",MB_ICONINFORMATION|MB_OKCANCEL)==IDCANCEL)
						return 0;
					AffTravail();
				}

				//Petit algo cod  part pour trouver rapidement la meilleure prcision
				int plagemin=-1, plagemax=precisionMax;
				int numeroactuel, max;

				numeroactuel = plagemax;
				max = plagemax;
				while(plagemin+1<plagemax)		{
					nbCouleurs=CalcPalette(tableau,palette,tailleY,tailleX,numeroactuel,nCoulInitiales,nCoulBase,nCoul);
					if (nbCouleurs!=-1)			{
						plagemax = numeroactuel;
						if (numeroactuel == plagemin + 1)
							numeroactuel--;
						else
							numeroactuel = (numeroactuel + plagemin)/2;
					}
					else	{
						plagemin = numeroactuel;
						if (numeroactuel == plagemax - 1)
							numeroactuel++;
						else
							numeroactuel = (numeroactuel + plagemax)/2;
					}
				}
				prec = plagemax;

/*				while(1)		{
					nbCouleurs=CalcPalette(tableau,palette,tailleY,tailleX,i,nCoulInitiales,nCoulBase,nCoul);
					if (nbCouleurs>nCMax)		{
						nCMax=nbCouleurs;
						prec=i;
					}
					if (nbCouleurs==-1)		{
						break;
					}
					if (i<=0)
						break;
					i--;
				}*/
				nbCouleurs=CalcPalette(tableau,palette,tailleY,tailleX,prec,nCoulInitiales,nCoulBase,nCoul);
				if (nbCouleurs<1)		{
					CacheTravail();
					MessageBox(gblHDlg,"Impossible de convertir la bitmap car le nombre de couleurs requis ne peut tre atteint","Oups...",MB_ICONERROR);
					return 0;
				}
			}
		}
		else if (modeConversion==1)		{
			nbCouleurs=ReductionHalftone(tableau,palette,tailleY,tailleX);
		}
		else if (modeConversion==2)		{
			nbCouleurs=ReductionOctree(tableau,palette,tailleY,tailleX,nCoulInitiales,nCoul-1);
			if (nbCouleurs<1)
				return 0;
		}
	}
	else	{
		CreeTableauConversion(tableau,palette, tailleY, tailleX);
	}

	tailleX=tailleVoulueX;
	tailleY=tailleVoulueY;

	i=tileX;
	j=tileY;
	//Cre le tileset
	if (bUtilTileset>=0)			{
		nTiles = LitTileset(NULL, &motifs, &els[0], 1);
		nTiles /= ((i / 8) * (j / 8));
		//Premire tile prise en compte (pour optimisation)
		if (optimiseTil)
			tileBase=0;
		else
			tileBase=nTiles;
	}
	else		{
		if (gbPremTileTransparente)
			nTiles=1;
		else
			nTiles=0;
		tileBase = 0;
	}
	tileX=i;
	tileY=j;

	if (bUsePalettes && curPF->pfList[curCMode].bFirstColorTransparent && !bPaletteIntacte)			{
//		if (utilPalette<0)		{
			memmove(palette+4,palette,nbCouleurs*4);
			palette[0]=bleuZero;
			palette[1]=vertZero;
			palette[2]=rougeZero;
			palette[3]=0;
			nbCouleurs++;
//		}
	}

	for (j=0;j<tailleY;j+=tileY)		{
		for (i=0;i<tailleX;i+=tileX)		{

			for (yy=0;yy<tileY;yy+=8)		{
				for (xx=0;xx<tileX;xx+=8)		{
					for (y=0;y<8;y++)
						for (x=0;x<8;x++)		{
								motif_temp[y*8+x+yy*tileX+xx*8]=tableau[(j+y+yy)*tailleX+(x+i+xx)];
						}
				}
			}

			//Optimisation du tileset?
			if (bOptimiseTileset)		{
				//Recherche d'une mosaque identique
				for (k=tileBase;k<nTiles;k++)		{
					if (!memcmp(motifs+tileX*tileY*k,motif_temp,tileX*tileY*sizeof(long)))
						break;
				}
			}
			else
				k=nTiles;

			//Pas trouv
			if (k==nTiles)		{
				//Et l s'il est vraiment trop lev
				if ((tileX/8)*(tileY/8)*nTiles>=TILEMAX-1)		{
					CacheTravail();
					MessageBox(gblHDlg,"Impossible de convertir car le nombre de mosaques est beaucoup trop lev...","Convertisseur de mosaques",MB_ICONERROR);
					return 0;
				}
				memcpy(motifs+tileX*tileY*nTiles,motif_temp,tileX*tileY*sizeof(long));
				if (ModeTexte)
					map[(j/tileY)*(tailleX/tileX)+i/tileX]=nTiles;
				else
					map[(j/tileY)*(tailleX/tileX)+i/tileX]=nTiles&0xff;
				nTiles++;
			}
			else		{
				if (ModeTexte)
					map[(j/tileY)*(tailleX/tileX)+i/tileX]=k;
				else
					map[(j/tileY)*(tailleX/tileX)+i/tileX]=k&0xff;
			}
		}
	}

	//Si la mmoire GBA est pleine... Je lance cet avertissement  la fin pour viter que
	//l'utilisateur reoive ce message et directement  la suite le deuxime indiquant
	//qu'il a dpass la mmoire du convertisseur lorsque c'est le cas.
/*	if (nTiles*(tileX/8)*(tileY/8)>(ModeTexte?1024:256))		{
		if (messages)		{
			CacheTravail();
			if (MessageBox(gblHDlg,"La bitmap contient plus de mosaques qu'il n'est disponible sur GBA (1024 mosaques pour le mode texte et 256 pour le mode rotation).\nLe rsultat risque de ne ressembler  rien. Vous tes prvenu!","Convertisseur de mosaques",MB_ICONEXCLAMATION|MB_OKCANCEL)==IDCANCEL)
				return 0;
			AffTravail();
		}
	}*/

	//HUHU ^^
	if (HUHU)			{
		extern int premCouleur;		// 1 si transparence, 0 sinon
		unsigned long *nouveauTableau, *tilemap;

		premCouleur = COLOR_ADD;
		tilemap = (unsigned long*)malloc(nTiles*sizeof(long));	
		xHdcConsole = GetDC(gblHDlg);
		nouveauTableau = xConvertTilesetToBitmap(motifs, nTiles, tileX, tileY);
		xInvertBGR32(nouveauTableau, nTiles*tileX*tileY);
		xSourceBitmap = nouveauTableau;
		xSourceWidth = tileX;
		xSourceHeight = tileY*nTiles;
//		xReduceBitmapColorsToPlatform(nouveauTableau, xSourceWidth, xSourceHeight);

		xNbPalettes = ((nCoul+curPF->pfList[curCMode].nColorsPerPalette-1)/curPF->pfList[curCMode].nColorsPerPalette);
		xColorsPerPalette = curPF->pfList[curCMode].nColorsPerPalette;
		xTileX = tileX;
		xTileY = tileY;
		xInitConversion();
//		xDisplayBitmap();
 		nbCouleurs = xTest(25000, xColorsPerPalette, motifs, tilemap, (u32*)palette);
		ReleaseDC(gblHDlg, xHdcConsole);
		free(nouveauTableau);
		//Convertit motifs et libre l'ancien
		nouveauTableau = motifs;
		motifs = xConvertBitmapToTileset(motifs, nTiles, tileX, tileY);
		xInvertBGR32((unsigned long*)palette, nbCouleurs);
		free(nouveauTableau);
		//IMPORTANT: UTILISER LA MAP EN SORTIE (tilemap) POUR LE RENDU!!!
		for (j=0;j<tailleY;j+=tileY)		{
			for (i=0;i<tailleX;i+=tileX)		{
				map[(j/tileY)*(tailleX/tileX)+i/tileX] = tilemap[map[(j/tileY)*(tailleX/tileX)+i/tileX]];
			}
		}
		free(tilemap);
		xDeinitConversion();
		if (nbCouleurs <= 0)
			return 0;
	}

	//Ecrit la map
	if (bGenereMap)			{
		tailleX/=tileX;
		tailleY/=tileY;
		curPF->fctMapWrite(PL_STD, &curCMode, &els[2], &els[0], &els[1], map, tailleX, tailleY, tileX, tileY);
	}
	//EndIf bGenereMap

/*	if (curPF->pfList[curCMode].bUsePalettes && !curPF->pfList[curCMode].bFirstColorTransparent)			{
		for (i=0;i<nTiles*tileX*tileY;i++)		{
			if (motifs[i] > 0)
				motifs[i]--;
		}
	}*/

	//Ecrit le tileset
	curPF->fctTilesetWrite(PL_STD, &curCMode, &els[0], &els[1], motifs, palette, nTiles, tileX, tileY);

	if (curPF->pfList[curCMode].bUsePalettes)			{
		curPF->fctPaletteWrite(PL_STD, &curCMode, &els[1], palette, nbCouleurs);
	}

	free(tableau);
	free(palette);
	free(motifs);
	free(map);
	return 1;
}

void CreeMap(const char *nom)		{
	FILE *f;
	if (!(f=fopen(nom,"r")))			{
		MessageBox(gblHDlg,"Le fichier n'existe pas encore",nom,MB_ICONINFORMATION);
//		fopen(nom,"w");
//		fclose(f);
	}
}

