#include "main.h"

int LARG_BUF=1280, HAUT_BUF=1024;
int LARG=1280, HAUT=1024;
int CLIP_X0=0, CLIP_Y0=0, CLIP_X1=LARG, CLIP_Y1=HAUT;
unsigned long *Bits;
BITMAPINFOHEADER BIH;
HBITMAP hbm;

int CreeDIB(HDC hdc, int cx, int cy, int ibitcount, HBITMAP *hbm, void **bits) 
{
   // Create a BITMAPINFOHEADER structure to describe the DIB.
   int iSize = sizeof(BITMAPINFOHEADER);

   ASSERT((ibitcount == 8) || (ibitcount == 16) || (ibitcount == 24) || (ibitcount == 32)) ;
   if (cx <= 0 || cy <= 0)
	   return 0;
   memset(&BIH, 0, iSize);

   // Fill in the header info. 
   BIH.biSize = iSize;
   BIH.biWidth = cx;
   BIH.biHeight = cy;
   BIH.biPlanes = 1;
   BIH.biBitCount = ibitcount;
   BIH.biCompression = BI_RGB;

   // Create a new device context.

   // Create the DIB section.
   *hbm = CreateDIBSection(hdc,
               (BITMAPINFO*) &BIH,
                             DIB_PAL_COLORS,
                             (void**)bits,
                             NULL,
                             0);

/*    ASSERT(*hbm);
    ASSERT(*bits);*/

    // Select the new bitmap into the buffer DC.
    if (*hbm && *bits)
    {
        SelectObject(hdc,*hbm);
		return 1;
    }
	else	{
		return 0;
	}
}


void ZoneEcran(int x0,int y0,int x1,int y1)		{
	CLIP_X0=x0, CLIP_Y0=y0, CLIP_X1=x1, CLIP_Y1=y1;
}

void ColoreCadre(int x0, int y0, int l, int h, int couleur);

void GetRealXY(int *xdst, int *ydst)			{
	int x,y;
	x=*xdst, y=*ydst;
	//ATTENTION: /3 car 24 bits!
	if (DIMENSION_MAX!=0 && (unsigned)(x*y)>=DIMENSION_MAX/4)			{
		bRedimDIBOverflow = x*y*4;
		double dRapport;
		dRapport = x/y;
		x = (int)(sqrt((float)(DIMENSION_MAX/4))*sqrt(dRapport));
		y = (int)(sqrt((float)(DIMENSION_MAX/4))/sqrt(dRapport));
	}
	*xdst=x, *ydst=y;
}

CVideoBuffer *currentlyUsedVideoBuffer = NULL;

//Constructor
CVideoBuffer::CVideoBuffer()
{
	m_hdc = NULL;
	m_bpp = 32;
}

//bpp: profondeur par pixel
void CVideoBuffer::Create(int x, int y, int bpp)
{
	m_bpp = bpp;
	//Pas dj cr...
	if (!m_hdc)			{
		HDC hdcEcran;
		hdcEcran = GetDC(NULL);
		m_hdc = CreateCompatibleDC(hdcEcran);
		Resize(x, y);
		ReleaseDC(NULL, hdcEcran);
	}
	else
		Resize(x, y);
}

void CVideoBuffer::Use()
{
	BIH = m_BIH;
	hbm = m_hbm;
	LARG_BUF = m_LARG_BUF;
	HAUT_BUF = m_HAUT_BUF;
	LARG = m_LARG;
	HAUT = m_HAUT;
	CLIP_X0 = 0;
	CLIP_X1 = m_LARG;
	CLIP_Y0 = 0;
	CLIP_Y1 = m_HAUT;
	Bits = m_Bits;
	currentlyUsedVideoBuffer = this;
}

void CVideoBuffer::Update()
{
	if (currentlyUsedVideoBuffer == this)
		Use();
}

//bpp: profondeur par pixel
void CVideoBuffer::Create(int bpp)
{
	Create(1, 1, bpp);
}

void CVideoBuffer::Destroy()
{
}

void CVideoBuffer::Resize(int x, int y, int useMaxSize)
{
	int ancX = m_LARG, ancY = m_HAUT;
	HBITMAP hbm3 = m_hbm;
	unsigned long *BitsTemp;

	bRedimDIBOverflow = FALSE;
	if (!useMaxSize)
		GetRealXY(&x, &y);

	if (m_LARG==x && m_HAUT==y)
		return;
	m_LARG = x;
	m_HAUT = y;
	if (m_LARG%4==0)
		m_LARG_BUF = m_LARG;
	else
		m_LARG_BUF = m_LARG + (4 - m_LARG % 4);
	m_HAUT_BUF = m_HAUT;
	//Cre une bitmap utilisable par mon systme graphique (graphlib)
	if (CreeDIB(m_hdc, m_LARG_BUF, m_HAUT_BUF, m_bpp, &m_hbm, (void**)&BitsTemp))		{
		//Ouvre une "fentre" graphique (pas Window!) pour y dessiner
		ZoneEcran(0, 0, m_LARG, m_HAUT);
		DeleteObject(hbm3);
		m_Bits = BitsTemp;
	}
	else	{
		if (ancX<x || ancY<y)
			bRedimDIBOverflow = x*y*4;
		m_LARG = ancX;
		m_HAUT = ancY;
		if (m_LARG%4 == 0)
			m_LARG_BUF = m_LARG;
		else
			m_LARG_BUF = m_LARG + (4 - m_LARG % 4);
		m_HAUT_BUF = m_HAUT;
		m_hbm = hbm3;
	}
	Update();
}

CVideoBuffer vbApercu, vbEditeur, vbSpecimen;
CVideoBuffer vbConv;			//Temporaire

//Colle une image sur un objet CVideoBuffer
//Ne peut fonctionner que pour vbApercu  cause de hbmConv
int VideoBufferPasteImage(CVideoBuffer &v, const char *fichier, int *dx, int *dy, int donotdelete)	{
	char tempname[MAX_PATH];
	strcpy(tempname, fichier);
	_strlwr(tempname);
	if (!bGdiPlusEnabled)			{
		MessageBox(gblHDlg, "Dsol, mais il vous faut GDIPlus.dll pour faire des conversions.", "Erreur", MB_ICONERROR);
		return 0;
/*		//Sans GDI+
		hbmConv = (HBITMAP) LoadImage(NULL, fichier, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
		if (!hbmConv)	{
			return 0;
		}
		GetObject(hbmConv, sizeof(bmConv), &bmConv);
		*dx=bmConv.bmWidth;
		*dy=bmConv.bmHeight;

		hdcConv = CreateCompatibleDC(v.m_hdc);
		
		SelectObject(hdcConv, hbmConv);
		v.Resize(*dx, *dy, TRUE);*/
	}
	else		{
		//Avec GDI+
//		hdcConv = CreateCompatibleDC(v.m_hdc);
		if (!GDIPLUS_DrawImage(fichier, dx, dy))		{
			vbConv.Destroy();
			return 0;
		}
	}

	vbConv.Use();
//	gdipImageKeying(*dx, *dy);
	if (!donotdelete || (modeConversion==0 || modeConversion==2 || !curPF->pfList[curCMode].bUsePalettes))		{
		BitBlt(v.m_hdc, 0, 0, *dx, *dy, vbConv.m_hdc, 0, 0, SRCCOPY);
		vbConv.Destroy();
	}
	v.Use();
	return 1;
}

/*
	DESSIN
*/
//Colore un cadre sans transparence
void ColoreCadre(int x0, int y0, int l, int h, int couleur)	{
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF, *ptr;
	register int x, y;

	ClipRect;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			*ptr++ = couleur;
		}
	}
}

void SpritePalSansMasque_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF, *ptr;

	ClipSprite8;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			*ptr++ = *sprite++;
		}
		sprite+=a;
	}

}

//bUsePal: permet de forcer la palette
void SpritePalSansMasque(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int bUsePal)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF, *ptr;

	//Pas la bonne foncion qui est appele?
	if ((!curPF->pfList[curCMode].bUsePalettes || bUsePal == 0) && bUsePal != 1)		{
		SpritePalSansMasque_32(x0, y0, l, h, sprite, palette);
		return;
	}
	ClipSprite8;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			*ptr++ = palette[*sprite++];
		}
		sprite+=a;
	}
}


void SpritePalMiroirSansMasque_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF, *ptr;

	ClipSprite8;

	if (!MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			for (x=0;x<l;x++)	{
				*ptr++=*sprite++;
			}
			sprite+=a;
		}
	}
	else if (MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			ptr += l-1;
			for (x=0;x<l;x++)	{
				*ptr--=*sprite++;
			}
			sprite+=a;
		}
	}
	else if (!MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			for (x=0;x<l;x++)	{
				*ptr++=*sprite++;
			}
			sprite+=a;
		}
	}
	else if (MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			ptr += l-1;
			for (x=0;x<l;x++)	{
				*ptr--=*sprite++;
			}
			sprite+=a;
		}
	}
}

void SpritePalMiroirSansMasque(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF, *ptr;

	//Pas la bonne foncion qui est appele?
	if (!curPF->pfList[curCMode].bUsePalettes)		{
		SpritePalMiroirSansMasque_32(x0, y0, l, h, sprite, palette, MH, MV, couleurs);
		return;
	}
	ClipSprite8;

	if (!MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			for (x=0;x<l;x++)	{
				*ptr++=palette[(*sprite++)&couleurs];
			}
			sprite+=a;
		}
	}
	else if (MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			ptr += l-1;
			for (x=0;x<l;x++)	{
				*ptr--=palette[(*sprite++)&couleurs];
			}
			sprite+=a;
		}
	}
	else if (!MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			for (x=0;x<l;x++)	{
				*ptr++=palette[(*sprite++)&couleurs];
			}
			sprite+=a;
		}
	}
	else if (MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			ptr += l-1;
			for (x=0;x<l;x++)	{
				*ptr--=palette[(*sprite++)&couleurs];
			}
			sprite+=a;
		}
	}
}


void TransSpritePalMiroirSansMasque_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs, register int niveau)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF;
	register unsigned char *ptr, *pal, nv=255-niveau;

	ClipSprite8;

	if (!MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			for (x=0;x<l;x++)	{
				pal=(unsigned char*)sprite;
				sprite++;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}
	else if (MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			ptr+=4*l+4;
			for (x=0;x<l;x++)	{
				ptr-=8;
				pal=(unsigned char*)sprite;
				sprite++;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}
	else if (!MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			for (x=0;x<l;x++)	{
				pal=(unsigned char*)sprite;
				sprite++;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}
	else if (MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			ptr+=4*l+4;
			for (x=0;x<l;x++)	{
				ptr-=8;
				pal=(unsigned char*)sprite;
				sprite++;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}
}

void TransSpritePalMiroirSansMasque(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs, register int niveau)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF;
	register unsigned char *ptr, *pal, nv=255-niveau;

	//Opaque
	if (niveau >= 256)		{
		SpritePalMiroirSansMasque(x0, y0, l, h, sprite, palette, MH, MV, couleurs);
		return;
	}
	//Pas la bonne foncion qui est appele?
	if (!curPF->pfList[curCMode].bUsePalettes)		{
		TransSpritePalMiroirSansMasque_32(x0, y0, l, h, sprite, palette, MH, MV, couleurs, niveau);
		return;
	}
	ClipSprite8;

	if (!MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			for (x=0;x<l;x++)	{
				pal=(unsigned char*)(palette+((*sprite++)&couleurs));
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}
	else if (MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			ptr+=4*l+4;
			for (x=0;x<l;x++)	{
				ptr-=8;
				pal=(unsigned char*)(palette+((*sprite++)&couleurs));
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}
	else if (!MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			for (x=0;x<l;x++)	{
				pal=(unsigned char*)(palette+((*sprite++)&couleurs));
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}
	else if (MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			ptr+=4*l+4;
			for (x=0;x<l;x++)	{
				ptr-=8;
				pal=(unsigned char*)(palette+((*sprite++)&couleurs));
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}
}


void SpritePalMiroir_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF, *ptr;

	ClipSprite8;

	if (!MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			for (x=0;x<l;x++)	{
				if (!(*sprite&0xff000000))		{
					sprite++, ptr++;
					continue;
				}
				*ptr++=*sprite++;
			}
			sprite+=a;
		}
	}
	else if (MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			ptr += l-1;
			for (x=0;x<l;x++)	{
				if (!(*sprite&0xff000000))		{
					sprite++, ptr--;
					continue;
				}
				*ptr--=*sprite++;
			}
			sprite+=a;
		}
	}
	else if (!MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			for (x=0;x<l;x++)	{
				if (!(*sprite&0xff000000))		{
					sprite++, ptr++;
					continue;
				}
				*ptr++=*sprite++;
			}
			sprite+=a;
		}
	}
	else if (MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			ptr += l-1;
			for (x=0;x<l;x++)	{
				if (!(*sprite&0xff000000))		{
					sprite++, ptr--;
					continue;
				}
				*ptr--=*sprite++;
			}
			sprite+=a;
		}
	}
}


void SpritePalMiroir(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF, *ptr;

	//Pas la bonne foncion qui est appele?
	if (!curPF->pfList[curCMode].bUsePalettes)		{
		SpritePalMiroir_32(x0, y0, l, h, sprite, palette, MH, MV, couleurs);
		return;
	}
	ClipSprite8;

	if (!MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			for (x=0;x<l;x++)	{
				if (*sprite)
					*ptr++=palette[(*sprite++)&couleurs];
				else	{
					sprite++, ptr++;
					continue;
				}
			}
			sprite+=a;
		}
	}
	else if (MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			ptr += l-1;
			for (x=0;x<l;x++)	{
				if (*sprite)
					*ptr--=palette[(*sprite++)&couleurs];
				else	{
					sprite++, ptr--;
					continue;
				}
			}
			sprite+=a;
		}
	}
	else if (!MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			for (x=0;x<l;x++)	{
				if (*sprite)
					*ptr++=palette[(*sprite++)&couleurs];
				else	{
					sprite++, ptr++;
					continue;
				}
			}
			sprite+=a;
		}
	}
	else if (MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
			ptr += l-1;
			for (x=0;x<l;x++)	{
				if (*sprite)
					*ptr--=palette[(*sprite++)&couleurs];
				else	{
					sprite++, ptr--;
					continue;
				}
			}
			sprite+=a;
		}
	}
}



void TransSpritePalMiroir_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs, register int niveau)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF;
	register unsigned char *ptr, *pal, nv=255-niveau;

	ClipSprite8;

	if (!MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			for (x=0;x<l;x++)	{
				if (*sprite&0xff000000)		{
					pal=(unsigned char*)sprite;
					sprite++;
				}
				else	{
					sprite++, ptr+=4;
					continue;
				}
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}
	else if (MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			ptr+=4*l+4;
			for (x=0;x<l;x++)	{
				ptr-=8;
				if (*sprite&0xff000000)		{
					pal=(unsigned char*)sprite;
					sprite++;
				}
				else	{
					sprite++, ptr+=4;
					continue;
				}
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}
	else if (!MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			for (x=0;x<l;x++)	{
				if (*sprite&0xff000000)		{
					pal=(unsigned char*)sprite;
					sprite++;
				}
				else	{
					sprite++, ptr+=4;
					continue;
				}
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}
	else if (MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			ptr+=4*l+4;
			for (x=0;x<l;x++)	{
				ptr-=8;
				if (*sprite&0xff000000)		{
					pal=(unsigned char*)sprite;
					sprite++;
				}
				else	{
					sprite++, ptr+=4;
					continue;
				}
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}

}


void TransSpritePalMiroir(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs, register int niveau)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF;
	register unsigned char *ptr, *pal, nv=255-niveau;

	//Pas d'alpha...
	if (niveau >= 256)		{
		SpritePalMiroir(x0, y0, l, h, sprite, palette, MH, MV, couleurs);
		return;
	}
	//Pas la bonne foncion qui est appele?
	if (!curPF->pfList[curCMode].bUsePalettes)		{
		TransSpritePalMiroir_32(x0, y0, l, h, sprite, palette, MH, MV, couleurs, niveau);
		return;
	}
	ClipSprite8;

	if (!MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			for (x=0;x<l;x++)	{
				if (*sprite)
					pal=(unsigned char*)(palette+((*sprite++)&couleurs));
				else	{
					sprite++;
					ptr+=4;
					continue;
				}
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}
	else if (MH && !MV)		{
		for (y=y0;y<y0+h;y++)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			ptr+=4*l+4;
			for (x=0;x<l;x++)	{
				ptr-=8;
				if (*sprite)
					pal=(unsigned char*)(palette+((*sprite++)&couleurs));
				else	{
					sprite++;
					ptr+=4;
					continue;
				}
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}
	else if (!MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			for (x=0;x<l;x++)	{
				if (*sprite)
					pal=(unsigned char*)(palette+((*sprite++)&couleurs));
				else	{
					sprite++;
					ptr+=4;
					continue;
				}
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			}
			sprite+=a;
		}
	}
	else if (MH && MV)		{
		for (y=y0+h-1;y>=y0;y--)	{
			ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
			ptr+=4*l+4;
			for (x=0;x<l;x++)	{
				ptr-=8;
				if (*sprite)
					pal=(unsigned char*)(palette+((*sprite++)&couleurs));
				else	{
					sprite++;
					ptr+=4;
					continue;
				}
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
				ptr++;
			}
			sprite+=a;
		}
	}

}


void SpritePal_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF, *ptr;

	ClipSprite8;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (*sprite)
				*ptr++=*sprite++;
			else	{
				sprite++, ptr++;
				continue;
			}
		}
		sprite+=a;
	}

}


void SpritePal(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF, *ptr;

	//Pas la bonne foncion qui est appele?
	if (!curPF->pfList[curCMode].bUsePalettes)		{
		SpritePal_32(x0, y0, l, h, sprite, palette);
		return;
	}
	ClipSprite8;

	for (y=y0;y<y0+h;y++)	{
		ptr=bits-LARG_BUF*y-(LARG_BUF-x0);
		for (x=0;x<l;x++)	{
			if (*sprite)
				*ptr++=palette[*sprite++];
			else	{
				sprite++, ptr++;
				continue;
			}
		}
		sprite+=a;
	}

}

void TransCadre(int x0, int y0, int l, int h, int couleur, register int niveau)	{
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF;
	register unsigned char *ptr;
	int x, y;
	unsigned char rouge=couleur&0x000000ff, vert=(couleur&0x0000ff00)>>8, bleu=(couleur&0x00ff0000)>>16;
	int nv=niveau-255, factb=bleu*niveau, factv=vert*niveau, factr=rouge*niveau;

	ClipRect;

	for (y=y0;y<y0+h;y++)	{
		ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
		for (x=0;x<l;x++)	{
			*ptr++=(factb-nv*(*ptr))>>8;
			*ptr++=(factv-nv*(*ptr))>>8;
			*ptr++=(factr-nv*(*ptr))>>8;
			ptr++;
		}
	}
}

void TransSprite(int x0, int y0, int l, int h, register unsigned long *sprite, register int niveau)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF;
	register unsigned char *ptr, nv=255-niveau, *pal;

	ClipSprite;

	for (y=y0;y<y0+h;y++)	{
		ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
		for (x=0;x<l;x++)	{
			if (*sprite==0xfe)		{
				sprite++;
				ptr+=4;
				continue;
			}
			pal = (unsigned char*)sprite;
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			ptr++;
			sprite++;
		}
		sprite+=a;
	}

}

void TransSpritePalSansMasque_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, register int niveau)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF;
	register unsigned char *ptr, nv=255-niveau, *pal;

	ClipSprite8;

	for (y=y0;y<y0+h;y++)	{
		ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
		for (x=0;x<l;x++)	{
			pal = (unsigned char*)sprite;
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			ptr++;
			sprite++;
		}
		sprite+=a;
	}
}

void TransSpritePalSansMasque(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, register int niveau)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF;
	register unsigned char *ptr, nv=255-niveau, *pal;

	//Pas la bonne foncion qui est appele?
	if (!curPF->pfList[curCMode].bUsePalettes)		{
		TransSpritePalSansMasque_32(x0, y0, l, h, sprite, palette, niveau);
		return;
	}
	ClipSprite8;

	for (y=y0;y<y0+h;y++)	{
		ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
		for (x=0;x<l;x++)	{
			pal=(unsigned char*)(palette+(*sprite++));
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			ptr++;
		}
		sprite+=a;
	}
}

void TransSpritePal_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, register int niveau)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF;
	register unsigned char *ptr, nv=255-niveau, *pal;

	ClipSprite8;

	for (y=y0;y<y0+h;y++)	{
		ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
		for (x=0;x<l;x++)	{
			if (*sprite&0xff000000)		{
				pal=(unsigned char*)sprite;
				sprite++;
			}
			else	{
				sprite++;
				ptr+=4;
				continue;
			}
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			ptr++;
		}
		sprite+=a;
	}

}

void TransSpritePal(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, register int niveau)		{
	int x, y, a=0;
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF;
	register unsigned char *ptr, nv=255-niveau, *pal;

	//Pas la bonne foncion qui est appele?
	if (!curPF->pfList[curCMode].bUsePalettes)		{
		TransSpritePal_32(x0, y0, l, h, sprite, palette, niveau);
		return;
	}
	ClipSprite8;

	for (y=y0;y<y0+h;y++)	{
		ptr=(unsigned char*)(bits-LARG_BUF*y-(LARG_BUF-x0));
		for (x=0;x<l;x++)	{
			if (*sprite)
				pal=(unsigned char*)(palette+(*sprite++));
			else	{
				sprite++;
				ptr+=4;
				continue;
			}
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			*(ptr++)=((*ptr)*nv+niveau*(*pal++))>>8;
			ptr++;
		}
		sprite+=a;
	}

}

/*
	FxRect

	Dessine un rectangle avec la possibilit d'appliquer les effets suivants:
	-FX_OPAQUE, FX_ADD, FX_SOUS, FX_MASQUE, FX_TRANS, FX_XOR
*/

void TransRect(int x0, int y0, int l, int h, int couleur, register int niveau)		{
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF;
	register unsigned char *ptr;
	register int x, y;
	register unsigned char rouge=couleur&0x000000ff, vert=(couleur&0x0000ff00)>>8, bleu=(couleur&0x00ff0000)>>16;
	int yBase=y0+CLIP_Y0, xBase=x0+CLIP_X0, lBase=l, hBase=h;
	int nv=niveau-255, factb=bleu*niveau, factv=vert*niveau, factr=rouge*niveau;

	ClipRect;

	for (y=0;y<hBase;y+=hBase-1)		{
		if (yBase+y>=CLIP_Y0 && yBase+y<CLIP_Y1)		{
			ptr=(unsigned char*)(bits-LARG_BUF*(yBase+y+1)+x0+1);
			for (x=2;x<l;x++)	{
				*ptr++=(factb-nv*(*ptr))>>8;
				*ptr++=(factv-nv*(*ptr))>>8;
				*ptr++=(factr-nv*(*ptr))>>8;
				ptr++;
			}
		}
		if (hBase<=1)	break;
	}
	for (x=0;x<lBase;x+=lBase-1)		{
		if (xBase+x>=CLIP_X0 && xBase+x<CLIP_X1)		{
			ptr=(unsigned char*)(bits-LARG_BUF*(y0+1)+(xBase+x));
			for (y=0;y<h;y++)	{
				*ptr++=(factb-nv*(*ptr))>>8;
				*ptr++=(factv-nv*(*ptr))>>8;
				*ptr++=(factr-nv*(*ptr))>>8;
				ptr++;
				ptr-=LARG_BUF*4+4;
			}
		}
		if (lBase<=1)	break;
	}
}


void TransRectFond(int x0, int y0, int l, int h, int couleur, register int niveau)		{
	register unsigned long *bits=Bits+LARG_BUF*HAUT_BUF;
	register unsigned char *ptr;
	register int x, y;
	register unsigned char rouge=couleur&0x000000ff, vert=(couleur&0x0000ff00)>>8, bleu=(couleur&0x00ff0000)>>16;
	int yBase=y0+CLIP_Y0, xBase=x0+CLIP_X0, lBase=l, hBase=h;
	int nv=niveau-255, factb=bleu*niveau, factv=vert*niveau, factr=rouge*niveau;

	ClipRect;

	for (y=hBase-1;y<hBase;y+=hBase-1)		{
		if (yBase+y>=CLIP_Y0 && yBase+y<CLIP_Y1)		{
			ptr=(unsigned char*)(bits-LARG_BUF*(yBase+y+1)+x0);
			for (x=1;x<l;x++)	{
				*ptr++=(factb-nv*(*ptr))>>8;
				*ptr++=(factv-nv*(*ptr))>>8;
				*ptr++=(factr-nv*(*ptr))>>8;
				ptr++;
			}
		}
		if (hBase<=1)	break;
	}
	for (x=lBase-1;x<lBase;x+=lBase-1)		{
		if (xBase+x>=CLIP_X0 && xBase+x<CLIP_X1)		{
			ptr=(unsigned char*)(bits-LARG_BUF*(y0+1)+(xBase+x));
			for (y=0;y<h;y++)	{
				*ptr++=(factb-nv*(*ptr))>>8;
				*ptr++=(factv-nv*(*ptr))>>8;
				*ptr++=(factr-nv*(*ptr))>>8;
				ptr++;
				ptr-=LARG_BUF*4+4;
			}
		}
		if (lBase<=1)	break;
	}
}
