#include "main.h"

int LitPalette(unsigned char *palette, ELEMENT *e, int original, int wantCMode)		{
	int nc, i, cmodesave;
	cmodesave = curCMode;
	nc = curPF->fctPaletteRead(PL_STD, &curCMode, palette, e);
	PF_PIXELFORMAT *pf = curPF->pfList[curCMode].pixel;
	//Original=TRUE permet de laisser la palette telle quelle (pas recolore)
	if (!original)			{
		//Recolore la palette au pixelformat correspondant
		for (i=0;i<nc*4;)			{
			if (pf->bwidth > 0)
				palette[i]*=255/((1<<curPF->pfList[curCMode].pixel->bwidth)-1);
			if (pf->vwidth > 0)
				palette[i+1]*=255/((1<<curPF->pfList[curCMode].pixel->vwidth)-1);
			if (pf->rwidth > 0)
				palette[i+2]*=255/((1<<curPF->pfList[curCMode].pixel->rwidth)-1);
			if (pf->awidth > 0)
				palette[i+3]*=255/((1<<curPF->pfList[curCMode].pixel->awidth)-1);
			i+=4;
		}
	}
	if (!wantCMode)
		curCMode = cmodesave;
	gblNbCouleurs = nc;
	return nc;
}


int LitTileset(unsigned char *palette,unsigned long **motiv, ELEMENT *e, int original)		{
	return curPF->fctTilesetRead(PL_STD, &curCMode, palette, motiv, e, original);
}

int LitBitmap(unsigned char *palette,unsigned long **motiv, ELEMENT *e, int original)		{
	return curPF->fctBitmapRead(PL_STD, &curCMode, palette, motiv, e, original);
}

void DessinePalette(unsigned char *palette, int nbCoul)		{
	int x,y,i;

	i=nbCoul / gnPaletteWidth;
	if (nbCoul % gnPaletteWidth)
		i++;
	vbApercu.Resize(gnPaletteWidth, i, FALSE);
	vbApercu.Use();

	ColoreCadre(0, 0, LARG, HAUT, cFond);
	i=0;
	for (y=0;y<HAUT;y++)		{
		for (x=0;x<gnPaletteWidth;x++)		{
			if (i>=nbCoul)
				goto fin;
			DessPix(x,y,RGB(palette[4*i],palette[4*i+1],palette[4*i+2]));
			i++;
		}
	}
fin:
	tailleX=gnPaletteWidth * 16;
	if (x<gnPaletteWidth)
		y++;
	tailleY=y * 16;
}

void DessineTileset(unsigned long *palette,unsigned long *motifs)			{
	int x,y,i, xx, yy;

	taille/=(tileX*tileY)/64;
	//Calcule la hauteur du tileset
	i = taille / (gnTilesetWidth/tileX);
	if (taille % (gnTilesetWidth / tileX) > 0)
		i++;
	i *= tileY;

/*	i = tileY*(taille/(256/tileX));
	i=taille/32;
	if (taille%32)
		i++;*/
	vbApercu.Resize(gnTilesetWidth, i, FALSE);
	vbApercu.Use();

	ColoreCadre(0,0,LARG,HAUT,cFond);
//	palette[0] = cFond;

	i=0;
	for (y=0;y<HAUT;y+=tileY)		{
		//257 => jusqu' 256 slt
		for (x=0;x<=gnTilesetWidth-tileX;x+=tileX)		{
			for (yy=0;yy<tileX;yy+=8)
				for (xx=0;xx<tileX;xx+=8)
					SpritePalSansMasque(x+xx,y+yy,8,8,motifs+(i*tileX*tileY)+64*(tileX/8)*(yy/8)+64*(xx/8),palette);
//			ColoreCadre(x,y,16,16,RGB(255,0,0));
			i++;
			if (i>=taille)
				goto fin;
		}
	}
fin:
	tailleX=gnTilesetWidth;
	tailleY=y+tileY;
}

void DessineBitmap(unsigned long *palette, unsigned long *motifs, int tX, int tY)			{
	int x,y,i;
//	EffaceEcran();
//	RedimDIB(256,1024);

	vbApercu.Resize(tX,tY,FALSE);
	vbApercu.Use();
	
	ColoreCadre(0,0,LARG,HAUT,cFond);
	palette[0]=cFond;

	for (y=0;y<tY;y++)		{
		for (x=0;x<tX;x++)		{
			i = motifs[tX*y+x];
			if (curPF->pfList[curCMode].bUsePalettes)
				i = palette[i];
			if (i & 0xff000000)
				DessPix(x,y,i);
		}
	}
}

/*
	Applique la couleur de fond  toute couleur transparente.
	Ncessite les variables globales suivantes:
		- gblNbCouleurs
		- tileX / tileY
		- taille
*/
void RendTilesetTransparent(unsigned long *palette, unsigned long *motifs)
{
	int i;
	if (!palette || !motifs)
		return;
	//Mode 32 bits
	if (!curPF->pfList[curCMode].bUsePalettes)		{
		for (i=0;i<taille*tileX*tileY;i++)		{
			if (!(*motifs&0xff000000))
				*motifs = /*0xff000000 | */cFond;
			motifs++;
		}
	}
	else	{
		//Mode palette
		for (i=0;i<gblNbCouleurs;i++)		{
			if (!(*palette&0xff000000))
				*palette = /*0xff000000 | */cFond;
			palette++;
		}
	}
}

//Types de variables: voir types_objets dans le fichier "definitions.h"
/*
void *variables[][3]=	{
	//Rajoutez vos variables selon le format suivant (entiers seulement)
	//{"nom (dans le fichier)", &variable (pointeur sur la variable int), (void*)type (TYPE_ENTIER seulement)},
};
*/

char *ProchArgEntier(char *ptr)		{
	int compteParentheses=0;

	while(1)		{
		if (*ptr==0)
			break;
		if (*ptr=='(')
			compteParentheses++;
		if (compteParentheses==0)		{
			if (*ptr==',' || *ptr==' ' || *ptr==')')		{
				ptr++;
				break;
			}
		}
		if (*ptr==')')
			compteParentheses--;
		ptr++;
	}
	while(*ptr==' ' || *ptr=='	')
		ptr++;
	return ptr;
}

int EstUnNombre(char *valeur)			{
	BOOL bHexa=FALSE;
	if (*valeur==0)
		return FALSE;
	if (*valeur=='0')		{
		valeur++;
		if (*valeur=='x')
			valeur++, bHexa=TRUE;
		else if (*valeur=='b')
			valeur++;
		else
			return FALSE;
	}
	while(*valeur)		{
		//Digit hexa?
		if ((*valeur>='A' && *valeur<='F') || (*valeur>='a' && *valeur<='f'))		{
			if (!bHexa)
				return FALSE;
			else		{
				//En mode hexa -> ok
				valeur++;
				continue;
			}
		}
		if (*valeur<'0' || *valeur>'9')
			return FALSE;
		valeur++;
	}
	return TRUE;
}

int GetEntier(char *valeur)		{
	int r,v,b;

	if (*valeur<'0' || *valeur>'9')		{
		if (*valeur=='t' || *valeur=='v')
			return 1;
		else if (*valeur=='f')
			return 0;
		else if (!strncmp(valeur,"rgb",3))		{
			valeur+=3;
			while(*valeur!='(' && *valeur)	valeur++;
			if (!(*valeur))
				return 0;
			valeur++;
			r=GetEntier(valeur);
			valeur=ProchArgEntier(valeur);
			v=atoi(valeur);
			valeur=ProchArgEntier(valeur);
			b=GetEntier(valeur);
			return RGB(r,v,b);
		}
		return 0;
	}
	if (*valeur=='0')		{
		valeur++;
		if (*valeur=='x')
			return atox(valeur+1);
		else if (*valeur=='b')		{
			return atob(valeur+1);
		}
		else
			return atoi(valeur-1);
	}
	return atoi(valeur);
}
/*
void AnalyseVariables(char *ptr)		{
	char *variable, *valeur;
	int Continue, i, type;

refait:
	while(*ptr==' ')	ptr++;
	if (*ptr==0 || *ptr=='\n')
		return;
	variable=ptr;
	while(*ptr && *ptr!='=')	ptr++;
	if (!(*ptr))
		return;
	*ptr++=0;
	valeur=ptr;
	while(*ptr && *ptr!='\n' && *ptr!=' ')	ptr++;
	if (!(*ptr))
		return;
	if (*ptr==' ')
		Continue=TRUE;
	else
		Continue=FALSE;
	*ptr++=0;


	for (i=0;i<sizeof(variables)/sizeof(variables[0]);i++)		{
		if (!strcmp(variable,(const char*)variables[i][0]))		{
			type=(int)variables[i][2];
			if (type==TYPE_ENTIER)
				*(int*)variables[i][1]=GetEntier(valeur);
		}
	}

	if (Continue)
		goto refait;
}

void InitVariables()		{
	//Mettez ici les variables  initialiser
}*/


int LitMap(unsigned long *palette, unsigned long **motifs, MAP **umap, int i)		{
#pragma message ("CAST_PALETTE_8BITS")
	return curPF->fctMapRead(PL_STD, &curCMode, (u8*)palette, motifs, umap, &elements[i]);
}

int CalcSdSize(SD_PARAMS *p)			{
	if (p->sdNumParams<=0)
		return sizeof(SPRITE_DEF);
	else		{
		int i, r;
		r=0;
		for (i=0;i<p->sdNumParams;i++)		{
			r += p->sdTaillesParam[i];
		}
		return sizeof(SPRITE_DEF)+r;
	}
}

BOOL AppliqueSdModele(char *nomModele)			{
	int i;
	for (i=0;i<sdNbreModeles;i++)			{
		if (!strcmp(sdParams[i].sdNomModele, nomModele))
			break;
	}
	if (i>=sdNbreModeles)
		return FALSE;
	else			{
		sdParams[i].sizeofSD=CalcSdSize(&sdParams[i]);
		gblSdModele = i;
		return TRUE;
	}
}

int LitChaineTypes(int j, char *bloc, char *chaine, FILE *f, SPRITE_DEF *sd, int bPasErreur, char *fin_ligne, int taille_totale);

int LitListe(unsigned char *palette,unsigned long **motifs, MAP **umap, int i)		{
	return curPF->fctListRead(PL_STD, &curCMode, palette, motifs, umap, &elements[i]);
}

void DessineTile(int x, int y, PARAM *p, unsigned short tile, int alpha)		{
	unsigned long *pal;
	int nc;
	int xx, yy, addx, addy, mulx, muly;
	unsigned long *pdata;
	int tileInfos, MH, MV;
	bool noMask = !curPF->pfList[p->curCMode].bFirstColorTransparent;

	//Opaque
	if (!alpha)
		alpha = 256;

	if (p->emul_gba)			{
		tileInfos = tile;
		//16x16 => *4, 8x8 => *1
		tile &= curPF->mf[p->ModeTexte].tileMask;
		if (tile >= p->taille)
			return;
		tile *= (p->tileX * p->tileY) >> 6;
	}
	else	{
		tileInfos = 0;
		if (tile >= p->taille)
			return;
		tile *= (p->tileX * p->tileY) >> 6;
	}

	//Palette
	if (curPF->pfList[p->curCMode].bUsePalettes == 2)				//Mode GBA spcial (4 bits pour le n de palette)
		pal = p->gblPal+(((tileInfos&curPF->mf[p->ModeTexte].paletteMask)>>curPF->mf[p->ModeTexte].paletteShift)*curPF->pfList[p->curCMode].nColorsPerPalette), nc = curPF->pfList[p->curCMode].nColorsPerPalette-1;
	else
		pal = p->gblPal, nc = curPF->pfList[p->curCMode].nbCouleursMax-1;

	//Miroirs
	MH = tileInfos & curPF->mf[p->ModeTexte].hMirrorMask;
	MV = tileInfos & curPF->mf[p->ModeTexte].vMirrorMask;
	//64 * long par tile
	pdata = p->gblMotifs + (tile << 6);
	//Positions
	addx = MH?(p->tileX-8):0, mulx = MH?(-1):1;
	addy = MV?(p->tileY-8):0, muly = MV?(-1):1;
	for (yy=0; yy<p->tileY; yy+=8)
		for (xx=0; xx<p->tileX; xx+=8)		{
			if (noMask)
				TransSpritePalMiroirSansMasque(x+xx*mulx+addx,y+yy*muly+addy, 8,8, pdata, pal, MH, MV, nc, alpha);
			else
				TransSpritePalMiroir(x+xx*mulx+addx,y+yy*muly+addy, 8,8, pdata, pal, MH, MV, nc, alpha);
			pdata += 8 * 8;
		}
}

void DessineMap(unsigned long *palette, unsigned long *motifs, MAP *map)			{
	int x,y,i;
	PARAM p;

	i=0;
//	palette[0] = cFond;

	p.gblMap=map;
	p.gblMotifs=motifs;
	p.gblPal=palette;
	p.curCMode=curCMode;
	p.ModeTexte=ModeTexte;
	p.tileX = tileX;
	p.tileY = tileY;
	p.emul_gba = sys_emul_gba;
	p.taille = taille;

//	mX=scrlX%tileX;
//	mY=scrlY%tileY;

	vbApercu.Resize(tailleX*tileX,tailleY*tileY,FALSE);
	vbApercu.Use();
	ColoreCadre(0, 0, LARG, HAUT, cFond);

	if (sys_emul_gba)
		gbatilmask = 1023;
	else
		gbatilmask = 0xffffffff;
	for (y=0;y<tailleY;y++)		{
		for (x=0;x<tailleX;x++)		{
			if (x>=LARG/tileX)
				break;
			i=map[tailleX*y+x]+blocBase;
			i&=gfxmask;
			//Motif non-valide (ne devrait pas arriver)
//			if (!emul_gba)		{
				if ((i&gbatilmask)>=taille || i<0)
					continue;
//			}
			if (!Editer)		{
				DessineTile(x*tileX,y*tileY,&p, i, 0);
			}
//			ColoreCadre(x,y,16,16,RGB(255,0,0));
		}
		if (y>=HAUT/tileY)
			break;
	}
	tailleX*=tileX;
	tailleY*=tileY;
}
