// GBAEdit.cpp : Defines the entry point for the application.
//

#define GBA_GRAPHICS_VERSION "1.00a (build 0.05)"

#define _CRT_SECURE_NO_DEPRECATE
#define WINVER 0x500

#include "main.h"
#include "supportDpi.h"

#define EffaceEcran()	memset(Bits,0,LARG_BUF*HAUT_BUF*3)

//Ouah! Des variables globales avant mme les includes! Qui dit mieux?
HWND gblHDlg = NULL;
int Editer=FALSE, Quitter=FALSE;
float dpiScaleX = 1;
float dpiScaleY = 1;

// Devrait inclure a...
void InitScaling() {
	HMODULE hUser32 = LoadLibrary("user32.dll");
	typedef BOOL (*SetProcessDPIAwareFunc)();
	SetProcessDPIAwareFunc setDPIAware =
	   (SetProcessDPIAwareFunc)GetProcAddress(hUser32, "SetProcessDPIAware");
	if (setDPIAware)
		setDPIAware();
	FreeLibrary(hUser32);

	HDC screen = GetDC(0);
	dpiScaleX = GetDeviceCaps(screen, LOGPIXELSX) / 96.f;
	dpiScaleY = GetDeviceCaps(screen, LOGPIXELSY) / 96.f;
	ReleaseDC(0, screen);
}

//Prototypes de certaines fonctions.
LRESULT CALLBACK Boite(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void Conversions();
void DessinePalette(unsigned char *palette, int nbCoul);

void FichierProjetActif(char *fichier)		{
	strcpy(fichierProjet, fichier);
	GetFullPathName(fichierProjet, sizeof(str), str, NULL);
	strcpy(fichierProjet, str);
	JusteChemin(str);
	SetCurrentDirectory(str);
}

HWND hSplash;

LRESULT CALLBACK ProcSplash(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			HMONITOR hMonitor;
			MONITORINFO mi;
			RECT rtDesktop;

			//Pour placer correctement, comme un menu
			hMonitor = MonitorFromWindow(hDlg, MONITOR_DEFAULTTONEAREST);
			mi.cbSize = sizeof(mi);
			GetMonitorInfo(hMonitor, &mi);
			//Ecran complet (avec HWND_TOPMOST)
			rtDesktop = mi.rcMonitor;
			SetWindowPos(hDlg, HWND_TOPMOST, (rtDesktop.right - rtDesktop.left - 480) / 2,
				(rtDesktop.bottom - rtDesktop.top - 272) / 2, 480, 272, 0);
//			SetTimer(hDlg, 189, 200, NULL);
			SetTimer(hDlg, 190, 3000, NULL);
			sprintf(str, "%s\\neoflash.png", cExePath);
			if (!gdipDisplayImage(NULL, str))		{
				DestroyWindow(hDlg);
			}
			return TRUE;

		case WM_TIMER:
/*			if (wParam == 189)			{
				KillTimer(hDlg, 189);
				AnimateWindow(hDlg, 150, AW_BLEND);
			}
			else			{*/
//				AnimateWindow(hDlg, 150, AW_BLEND|AW_HIDE);
				DestroyWindow(hDlg);
//			}
			break;

		case WM_PAINT:
			HDC hdc;
			BeginPaint(hDlg,NULL);
			hdc = GetDC(hDlg);
			sprintf(str, "%s\\neoflash.png", cExePath);
			if (bGdiPlusEnabled)
				gdipDisplayImage(hdc, str);
			ReleaseDC(hDlg, hdc);
			EndPaint(hDlg,NULL);
			break;

		case WM_COMMAND:

			//Bouton ok
/*			if (LOWORD(wParam) == IDOK) 
			{
				return TRUE;
			}

			//Bouton annuler
			if (LOWORD(wParam) == IDCANCEL)
			{
				EndDialog(hDlg, IDCANCEL);
				return TRUE;
			}*/

			break;
	}

    return FALSE;
}


HACCEL hAccelTable, hAccelEdit;

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	MSG msg;
	HWND hWnd;
	HMENU hMenu;
	LPSTR cmdLine;

 	// TODO: Place code here.
	nbreElements=0;
	editeurOuvert=0;
	hInst=hInstance;
	bGdiPlusDemarre=0;

	char *c;
	GetModuleFileName(0, cExePath, 300);
	c = cExePath + strlen(cExePath);
	while (c > cExePath && *c != '\\')
		c--;
	*c = 0;

	hChargement=CreateDialog(hInst,(LPCTSTR)IDD_CHARGEMENT,NULL,NULL);
	SetWindowPos(hChargement,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);

	GetCurrentDirectory(sizeof(cInitialDir), cInitialDir);
	cmdLine = GetCommandLine();
	strcpy(cInitialDir, cmdLine);
	if (cInitialDir[0]=='\"')			{
		memmove(cInitialDir, cInitialDir+1, sizeof(cInitialDir)-1);
/*		//-> dernier guillemet
		for (i=0; cInitialDir[i]!='\"' && cInitialDir[i];)
			i++;
		cInitialDir[i]=0;
		//Saute les espaces
		while(cInitialDir[i]!=';' && cInitialDir[i])
			i++;
		if (cInitialDir[i]==';')			{
			i++;
			ExecScript(NULL, NULL, cInitialDir+i);
		}*/
	}
	GetNomDossier(cInitialDir);

	//Recherche si GDIPLUS existe
	char tempbufr[1024], *nomcourt;
	if (SearchPath(NULL, "gdiplus.dll", NULL, sizeof(tempbufr), tempbufr, &nomcourt))
		bGdiPlusEnabled=1;
	else
		bGdiPlusEnabled=0;

	//Initialisation des globales
			CopieX=CopieY=0;
			profondeurSel=1;
			CopieSpec=0;
			blocBase=0;
			tileX=tileY=8;
			blocCopie=0;
			messages=0;
			proprePalette=1;
			fondTransparent=0;
			nuances=255;
			format_appliquer[0]=0;
			editTiming=10;
			nomsBits=NULL;
			bitsActives=NULL;
			nElementSelectionne=-1;
			bEtatDupliqueElement=0;
			gblHDlg = NULL;
			//256 pixels de large par dfaut
			gnTilesetWidth = 256; gnPaletteWidth = 16;
			gbPremTileTransparente = 0;
			//Important: DlgExec stocke un static char *contenu!
			bInviteScriptContenuSauve=0;
			InitPlateformes();
			DefPlateforme(&plateformes[0]);
			curCMode = curPF->pfDefaut;
			CreeCouleurs();

	sdParams=(SD_PARAMS*)malloc(sizeof(SD_PARAMS)*MAX_SD_MODELES);
	memset(sdParams, 0, sizeof(SD_PARAMS)*MAX_SD_MODELES);
	strcpy(sdParams[0].sdNomModele, "Default");
	sdNbreModeles=1;
	sdParams[0].sizeofSD=sizeof(SPRITE_DEF);

	elements = (ELEMENT*)malloc(sizeof(ELEMENT)*MAXEL);

	notification=1;
	if (*lpCmdLine=='\"')		{
		LPSTR temp;
		memmove(lpCmdLine,lpCmdLine+1,strlen(lpCmdLine)-1);
		lpCmdLine[strlen(lpCmdLine)-1]=0;
		temp = lpCmdLine;
		while (*temp && *temp!='\"')
			temp++;
		if (*temp)		{
			*temp = 0;
			strcpy(fichierProjet,lpCmdLine);
			lpCmdLine = temp + 1;
		}
		else		{
			strcpy(fichierProjet,lpCmdLine);
			lpCmdLine = temp;
		}
	}
	else if (*lpCmdLine && *lpCmdLine!='-')			{
		LPSTR temp;
		temp = lpCmdLine;
		while (*temp && *temp!=' ')
			temp++;
		if (*temp)		{
			*temp = 0;
			strcpy(fichierProjet,lpCmdLine);
			lpCmdLine = temp + 1;
		}
		else		{
			strcpy(fichierProjet,lpCmdLine);
			lpCmdLine = temp;
		}
	}
	else
		strcpy(fichierProjet,"projet.pgg");
//		strcpy(fichierProjet,"");
	GetFullPathName(fichierProjet, sizeof(str), str, NULL);
	strcpy(fichierProjet, str);
	JusteChemin(str);
	SetCurrentDirectory(str);

	nb_sections=0;
	LitFormat(&formats[0]);
	strcpy(formats[0].nom,"Standard");
	nb_sections++;

	DefFormat(&formats[0]);

//	LitFiltre();

	memset(dossierParDefaut,0,sizeof(dossierParDefaut));

	InitCommonControls();
	hfCourier=CreateFont(14, 0, 0, 0, 0, 0, 0, 0, ANSI_CHARSET, 0, 0, 0, VARIABLE_PITCH | FF_DONTCARE, "Courier new"); 
	strcpy(fichierConfigAOuvrir,"script.spt");
	strcpy(fichierAide,"lisezmoi.htm");
	ChargeProjet(fichierProjet);
	FichierProjetActif(fichierProjet);
	CopieSymTable();

	//Cration des buffers vido
	vbApercu.Create(32);

	while(*lpCmdLine == ' ' || *lpCmdLine == '	')
		lpCmdLine++;
	if (*lpCmdLine=='-')		{
		char *suite;
		do		{
			suite=lpCmdLine;
			while(*suite!=':' && *suite)			{
				if (*suite=='\"')		{
					suite++;
					while(*suite!='\"' && *suite)
						suite++;
					if (*suite)
						suite++;
				}
				else
					suite++;
			}
			if (*suite==':')
				*suite++=0;
			FctConv(lpCmdLine);
			lpCmdLine=suite;
		} while(*suite);
		SauveProjet(fichierProjet);
		return 0;
	}
	else if (*lpCmdLine)		{
		ExecScript(NULL, NULL, lpCmdLine);
		SauveProjet(fichierProjet);
		return 0;
	}

	InitScaling();
	hAccelTable=LoadAccelerators(hInstance,(LPCTSTR)IDR_ACCELERATOR1);
	hAccelEdit=LoadAccelerators(hInstance,(LPCTSTR)IDR_ACCELERATOR2);

	hSplash=CreateDialog(hInst,(LPCTSTR)IDD_SPLASH,NULL,(DLGPROC)ProcSplash);

	hWnd=CreateDialog(hInstance,(LPCTSTR)IDD_BOITE,NULL,(DLGPROC)Boite);
	
	hMenu=GetSubMenu(GetMenu(hWnd),4);
	hProcedures=hMenu;
	DeleteMenu(hMenu,0,MF_BYPOSITION);
	AjouteProcedures(fichierConfigAOuvrir,hMenu);

	tooltip_CreateTooltip();

	Quitter=FALSE;
	while (GetMessage(&msg, NULL, 0, 0)/* && !Quitter*/)
	{
		if (!TranslateAccelerator(hWnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return 0;
}

HWND MyCreateWindowFen(const char *type, const char *text, int style, int x, int y, int sx, int sy, HWND hDlg) {
	x = POSX_FEN(x), y = POSY_FEN(y);
	sx = SIZEX_FEN(sx), sy = SIZEY_FEN(sy);
	HWND hWnd = CreateWindow(type, text, style, x, y, sx, sy, hDlg, NULL, hInst, NULL);
	if (hWnd)
		SendMessage(hWnd, WM_SETFONT, (WPARAM)hFonte, MAKELPARAM(1, 0));
	return hWnd;
}

HWND MyCreateWindow(const char *type, const char *text, int style, int x, int y, int sx, int sy, HWND hDlg) {
	x = SIZEX_FEN(x), y = SIZEX_FEN(y);
	sx = SIZEX_FEN(sx), sy = SIZEY_FEN(sy);
	HWND hWnd = CreateWindow(type, text, style, x, y, sx, sy, hDlg, NULL, hInst, NULL);
	if (hWnd)
		SendMessage(hWnd, WM_SETFONT, (WPARAM)hFonte, MAKELPARAM(1, 0));
	return hWnd;
}

//Attention! Dessine la fentre principale avec son contenu dynamique  droite
//hItem contient l'lment slectionn dans l'arbre du projet
void DessFenetre(HWND hDlg, HANDLE hItem)		{
	RECT rect;
	unsigned long *palette;
	unsigned long *motifs;
	MAP *map;
	char str[100];
	int i, ancselection, nCoul;
	HWND hBoutonsCopy[NBRE_BOUTONS_DYNA];

	if (g_majListeEnCours)
		return;
	//Redimensionne la DIB
//	RedimDIB(1024,1024);

	bRedimDIBOverflow = FALSE;
	memcpy(hBoutonsCopy, hBoutonsDyna, sizeof(hBoutonsCopy));
	//On les met  zro, comme a on est sr que si on les dtruit  nouveau, Windows ne fera pas n'importe quoi...
	memset(hBoutonsDyna, 0, sizeof(hBoutonsDyna));
//	FenInvisible();

	//Cration d'un rectangle
	rect.left=POSX_FEN(0);
	rect.top=POSY_FEN(0);
	rect.bottom=POSX_FEN(0);
	rect.right=POSY_FEN(0);
	//Notez l'idiotie de ces 4 lignes de code

	//Sauvegarde de la slection (si une bitmap a t dessin directement sur la fentre
	//il faudra ensuite l'effacer compltement)
	ancselection=selection;

	//Le dossier Mosaques a t slectionn.
	if (hItem==htvMosaiques)		{
		//C'est moi ou bien il fait chaud tout  coup par ici...
		//Bon ben tout a a cre les contrles de la page de droite, met leur texte et
		//leur polices aux valeurs voulues...

		//Slection est une variable globale de rfrence pour savoir o on en est.
		selection=SEL_MOSAIQUES;
		//cTitre est la chane du titre  dessiner dans le rectangle style Final Fantasy 7
		strcpy(cTitre, "Rcuprer les mosaques");
		//Cre les contrles de base pour l'entre d'un fichier
		CreeEntreeFichier(hDlg);
		//Sauf que l a ne suffit pas...
		SetWindowText(hStatic02,"Destination pour les mosaques");
		hStatic03 = MyCreateWindowFen("Static", "Destination pour la palette",WS_CHILD | WS_VISIBLE,
			0, 80, 300, 18, hDlg);
		hTexte03=MyCreateWindowFen ("Edit", "",WS_BORDER | WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_TABSTOP,
			0, 95, 300, 18, hDlg);
		hBoutonParcourir3=MyCreateWindowFen("Button", "Parcourir...",WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			310, 95, 70, 18, hDlg);
		hStatic04=MyCreateWindowFen("Static", "Destination pour la map",WS_CHILD | WS_VISIBLE,
			0, 120, 300, 18, hDlg);
		hTexte04=MyCreateWindowFen("Edit", "",WS_BORDER | WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_TABSTOP,
			0, 135, 300, 18, hDlg);
		hBoutonParcourir4=MyCreateWindowFen("Button", "Parcourir...",WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			310, 135, 70, 18, hDlg);
		hStatic07=MyCreateWindowFen("Static", "Type de map",WS_CHILD | WS_VISIBLE,
			0, 165, 120, 18, hDlg);
		hComboTypeMap=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP,
			0, 183, 120, 180, hDlg);
		SendMessage(hComboTypeMap,CB_ADDSTRING,0,(LPARAM)"Rotation (8 bits)");
		SendMessage(hComboTypeMap,CB_ADDSTRING,0,(LPARAM)"Texte (16 bits)");
#ifdef SUPPORT_MAPS_32_BITS
		SendMessage(hComboTypeMap,CB_ADDSTRING,0,(LPARAM)"Etendue (32 bits)");
#endif
		SendMessage(hComboTypeMap,CB_SETCURSEL,1,0);

		hCheckPal=MyCreateWindowFen("Button", "Palette existante",WS_CHILD | WS_VISIBLE | BS_AUTO3STATE,
			150, 168, 100, 18, hDlg);
		hComboPalette=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP | WS_DISABLED,
			262, 165, 120, 180, hDlg);

		if (CalcNombreObjets(TYPE_PALETTE)==0)
			EnableWindow(hCheckPal,FALSE);

		hCheckTileset=MyCreateWindowFen("Button", "Tileset existant",WS_CHILD | WS_VISIBLE | BS_AUTO3STATE,
			150, 190, 100, 18, hDlg);
		hComboTileset=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP | WS_DISABLED,
			262, 187, 120, 180, hDlg);

		if (CalcNombreObjets(TYPE_MOSAIQUE)==0)
			EnableWindow(hCheckTileset,FALSE);

		hCheckMap=MyCreateWindowFen("Button", "Gnrer une map",WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX,
			150, 212, 102, 18, hDlg);
		SendMessage(hCheckMap,BM_SETCHECK,TRUE,0);

		hStatic05=MyCreateWindowFen("Static", "Couleurs / max.",WS_CHILD | ES_AUTOHSCROLL | WS_VISIBLE,
			150, 238, 130, 18, hDlg);

		sprintf(str, "%i", curPF->pfList[curPF->pfDefaut].nbCouleursDefaut);
		hTexte05=MyCreateWindowFen("Edit", str,WS_BORDER | WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			350, 236, 30, 18, hDlg);

		hStatic06=MyCreateWindowFen("Static", "Taille de la map",WS_CHILD | ES_AUTOHSCROLL | WS_VISIBLE,
			0, 212, 150, 18, hDlg);

		hComboTaille=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | (curPF->useUnoptimizedMapFormat?0:WS_DISABLED) | CBS_DROPDOWNLIST | WS_TABSTOP,
			0, 230, 120, 180, hDlg);

		hCheckOptimise=MyCreateWindowFen("Button", "Tileset optimis",WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX,
			0, 270, 102, 18, hDlg);
		SendMessage(hCheckOptimise,BM_SETCHECK,TRUE,0);

		hComboTileBits=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP,
			240, 236, 100, 180, hDlg);
		for (i=0;i<curPF->pfNumber;i++)
			SendMessage(hComboTileBits,CB_ADDSTRING,0,(LPARAM)curPF->pfList[i].name);
		SendMessage(hComboTileBits,CB_SETCURSEL,curPF->pfDefaut,0);

		hComboTiles=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP,
			105, 269, 80, 180, hDlg);
		hBoutonConfigure = MyCreateWindowFen("Button", "Plus...", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			230, 296, 70, 20, hDlg);
		hBoutonOk=MyCreateWindowFen("Button", "Ok!",WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			310, 296, 70, 20, hDlg);
		//Ca va vous tenez le coup?

		//Remplit les zones de liste avec les palettes et les jeux de mosaques disponibles
		AjouteTypes();
		AjoutePalettesTilesets();
		AjouteTaillesBlocs();
		SendMessage(hComboTiles,CB_SETCURSEL,0,0);
		EnableWindow(hBoutonConfigure, fctPluginConfigureIsEnabled(curPF, 0x2000|selection, curPF->pfDefaut));
	}
	//Le dossier Sprites a t slectionn
	else if (hItem==htvListes)		{
		selection=SEL_LISTES;
		if (CalcNombreObjets(TYPE_MOSAIQUE)==0)			{			//Nombre de tilesets insuffisant
			strcpy(cTitre, "Il faut au moins un jeu de mosaques pour cela!");
		}
		else		{
			strcpy(cTitre, "Crer une nouvelle liste d'objets");

			hStatic01=MyCreateWindowFen("Static", "Fichier  crer",WS_CHILD | WS_VISIBLE,
				0, 0, 300, 18, hDlg);
			hTexte01=MyCreateWindowFen("Edit", "",WS_BORDER | WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_TABSTOP,
				0, 15, 300, 18, hDlg);
			hBoutonParcourir=MyCreateWindowFen("Button", "Parcourir...",WS_CHILD | WS_VISIBLE | WS_TABSTOP,
				310, 15, 70, 18, hDlg);
			hStatic04=MyCreateWindowFen("Static", "Tileset  utiliser",WS_CHILD | ES_AUTOHSCROLL | WS_VISIBLE,
				0, 79, 95, 18, hDlg);
			hComboTileset=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP,
				0, 95, 120, 180, hDlg);
			hStatic05=MyCreateWindowFen("Static", "Modle  utiliser",WS_CHILD | ES_AUTOHSCROLL | WS_VISIBLE,
				130, 79, 95, 18, hDlg);
			hComboModeles=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP,
				130, 95, 120, 180, hDlg);
			hStatic06=MyCreateWindowFen("Static", "Taille des blocs",WS_CHILD | ES_AUTOHSCROLL | WS_VISIBLE,
				260, 79, 95, 18, hDlg);
			hComboTiles=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP,
				260, 95, 120, 180, hDlg);

			AjouteTilesets();
			AjouteModeles();
			AjouteTaillesBlocs();
			SendMessage(hComboTiles,CB_SETCURSEL,1,0);

			hBoutonConfigure = MyCreateWindowFen("Button", "Plus...", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
				230, 296, 70, 20, hDlg);
			hBoutonOk=MyCreateWindowFen("Button", "Ok!",WS_CHILD | WS_VISIBLE | WS_TABSTOP,
				310, 296, 70, 20, hDlg);
			EnableWindow(hBoutonConfigure, fctPluginConfigureIsEnabled(curPF, 0x2000|selection, -1));
		}
	}
	//Dossier Cartes/Bitmaps
	else if (hItem==htvBitmaps)		{
		selection=SEL_BITMAPS;
		strcpy(cTitre, "Crer une image simple");
		CreeEntreeFichier(hDlg);

		//Bon ben l c'est plus ou moins toujours le mme principe hein...
		SetWindowText(hStatic02,"Destination pour la bitmap");
		hStatic03=MyCreateWindowFen("Static", "Destination pour la palette",WS_CHILD | ES_AUTOHSCROLL | WS_VISIBLE,
			0, 80, 300, 18, hDlg);
		hTexte03=MyCreateWindowFen("Edit", "",WS_BORDER | ES_AUTOHSCROLL | WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			0,95,300,18, hDlg);
		hBoutonParcourir3=MyCreateWindowFen("Button", "Parcourir...",WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			310,95,70,18, hDlg);
		hStatic05=MyCreateWindowFen("Static", "Couleurs / max.",WS_CHILD | ES_AUTOHSCROLL | WS_VISIBLE,
			0,168,130,18, hDlg);

		sprintf(str, "%i", curPF->pfList[curPF->pfDefaut].nbCouleursDefaut);
		hTexte05=MyCreateWindowFen("Edit", str,WS_BORDER | WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			200,167,30,18, hDlg);
		hComboTileBits=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP,
			90,166,100,180, hDlg);
		for (i=0;i<curPF->pfNumber;i++)
			SendMessage(hComboTileBits,CB_ADDSTRING,0,(LPARAM)curPF->pfList[i].name);
		SendMessage(hComboTileBits,CB_SETCURSEL,curPF->pfDefaut,0);

		hCheckPal=MyCreateWindowFen("Button", "Palette existante",WS_CHILD | WS_VISIBLE | BS_AUTO3STATE,
			0,138,100,18, hDlg);
		hComboPalette=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP | WS_DISABLED,
			112,138,120,180, hDlg);
		if (CalcNombreObjets(TYPE_PALETTE)==0)
			EnableWindow(hCheckPal,FALSE);

		AjoutePalettesTilesets();

		hBoutonConfigure = MyCreateWindowFen("Button", "Plus...", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			230,296,70,20, hDlg);
		hBoutonOk=MyCreateWindowFen("Button", "Ok!",WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			310,296,70,20, hDlg);
		EnableWindow(hBoutonConfigure, fctPluginConfigureIsEnabled(curPF, 0x2000|selection, curPF->pfDefaut));
	}
	//Cartes
	else if (hItem==htvCartes)		{
		selection=SEL_CARTES;

		if (CalcNombreObjets(TYPE_MOSAIQUE)==0)			{			//Nombre de tilesets insuffisant
			strcpy(cTitre, "Il faut au moins un jeu de mosaques et une palette pour cela!");
		}
		else		{
			strcpy(cTitre, "Crer un nouveau tableau  utiliser comme carte gante");

			hStatic01=MyCreateWindowFen("Static", "Fichier  crer",WS_CHILD | WS_VISIBLE,
				0,0,300,18, hDlg);
			hTexte01=MyCreateWindowFen("Edit", "",WS_BORDER | WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_TABSTOP,
				0,15,300,18, hDlg);
			hBoutonParcourir=MyCreateWindowFen("Button", "Parcourir...",WS_CHILD | WS_VISIBLE | WS_TABSTOP,
				310,15,70,18, hDlg);

			//Contrles supplmentaires  crer
			hStatic02=MyCreateWindowFen("Static", "Taille du tableau (l,h [blocs])",WS_CHILD | ES_AUTOHSCROLL | WS_VISIBLE,
				0,50,300,18, hDlg);
			hTexte02=MyCreateWindowFen("Edit", "1",WS_BORDER | WS_CHILD | WS_VISIBLE | WS_TABSTOP,
				165,48,28,18, hDlg);
			hTexte03=MyCreateWindowFen("Edit", "1",WS_BORDER | WS_CHILD | WS_VISIBLE | WS_TABSTOP,
				200,48,28,18, hDlg);
			hStatic04=MyCreateWindowFen("Static", "Tileset  utiliser",WS_CHILD | ES_AUTOHSCROLL | WS_VISIBLE,
				0,125,95,18, hDlg);
			hComboTileset=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP,
				0,143,120,180, hDlg);
			hStatic05=MyCreateWindowFen("Static", "Palette  utiliser",WS_CHILD | ES_AUTOHSCROLL | WS_VISIBLE,
				130,125,95,18, hDlg);
			hComboPalette=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP,
				130,143,120,180, hDlg);
			hStatic06=MyCreateWindowFen("Static", "Taille des blocs",WS_CHILD | ES_AUTOHSCROLL | WS_VISIBLE,
				260,125,95,18, hDlg);
			hComboTiles=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP,
				260,143,120,180, hDlg);
			hStatic07=MyCreateWindowFen("Static", "Type de map",WS_CHILD | WS_VISIBLE,
				0,77,120,18, hDlg);
			hComboTypeMap=MyCreateWindowFen("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP,
				0,95,120,180, hDlg);
			SendMessage(hComboTypeMap,CB_ADDSTRING,0,(LPARAM)"Rotation (8 bits)");
			SendMessage(hComboTypeMap,CB_ADDSTRING,0,(LPARAM)"Texte (16 bits)");
	#ifdef SUPPORT_MAPS_32_BITS
			SendMessage(hComboTypeMap,CB_ADDSTRING,0,(LPARAM)"Etendue (32 bits)");
	#endif
			SendMessage(hComboTypeMap,CB_SETCURSEL,1,0);

			AjoutePalettesTilesets();
			AjouteTaillesBlocs();
			SendMessage(hComboTiles,CB_SETCURSEL,1,0);

			hBoutonConfigure = MyCreateWindowFen("Button", "Plus...", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
				230,296,70,20, hDlg);
			hBoutonOk = MyCreateWindowFen("Button", "Ok!",WS_CHILD | WS_VISIBLE | WS_TABSTOP,
				310,296,70,20, hDlg);
			EnableWindow(hBoutonConfigure, fctPluginConfigureIsEnabled(curPF, 0x2000|selection, -1));
		}
	}
	//Dossier Palettes.
	else if (hItem==htvPalettes)		{
		selection=SEL_PALETTES;
		strcpy(cTitre, "Les palettes sont gnres avec les conversions d'images");
		InvalidateRect(hDlg,&rect,0);
	}
	//Ce n'est pas un dossier mais certainement un lment du projet.
	else	{
		//L on vrifie si le handle est l'un des lments du projet
		for (i=0;i<nbreElements;i++)		{
			if (elements[i].hti==hItem)
				break;
		}
		//Pas trouv. Normalement a ne devrait pas arriver mais on ne sait jamais...
		if (i==nbreElements)		{
			selection=SEL_AUCUNE;
			strcpy(cTitre, "Erreur interne!");
			InvalidateRect(hDlg,&rect,0);
		}
		else	{
			int type;
//			FenVisible();
			//Affiche cela
			TravailEnCours();
			if (elements[i].type&TYPE_DOSSIER)
				type=-1;
			else
				type=((elements[i].type)&MASQUE_TYPE);
			nElementSelectionne = i;

			if (type==TYPE_BITMAP)		{
				selection=SEL_BITMAP;
				strcpy(cTitre, (char*)elements[i].nom_fichier);
				palette=(u32*)malloc(sizeof(u32)*curPF->nbMaxColors);
				motifs=NULL;
				//Lecture 8 bits (va galement charger une palette)
				//TEMPORAIREMENT COMMENTE
				if (!LitBitmap((u8*)palette, &motifs, &elements[i], 0))
					goto pasbon;
				DessineBitmap((u32*)palette, motifs, tailleX, tailleY);
				//Affiche la taille de l'image.
				sprintf(str,"Taille: %ix%i",tailleX,tailleY);
				hStatic03=MyCreateWindowFen("Static", str,WS_CHILD | WS_VISIBLE,
					0,300,230,18, hDlg);
				//Invalide l'affichage ('faudra le redessiner ensuite)
				InvalidateRect(hDlg,&rect,0);
			}
			//Une palette est slectionne
			else if (type==TYPE_PALETTE)		{
				selection=SEL_PALETTE;
				strcpy(cTitre, (char*)elements[i].nom_fichier);
				palette=(u32*)malloc(sizeof(u32)*curPF->nbMaxColors);
				//Les rsultats lus sont stocks dans vbApercu.m_hdc qui contient une DIB
				nCoul=LitPalette((u8*)palette, &elements[i], FALSE, TRUE);
				if (!nCoul)
					goto pasbon;
				//LitPalette sert  charger la palette. DessinePalette la dessine.
				DessinePalette((u8*)palette,nCoul);
				//Affiche le nombre de couleurs
				sprintf(str,"%i couleurs",nCoul);
				hStatic03=MyCreateWindowFen("Static", str,WS_CHILD | WS_VISIBLE,
					0,300,230,18, hDlg);
				free(palette);

				//Pour les options avances
				hBoutonConfigure = MyCreateWindowFen("Button", "Options", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
					300,0,70,20, hDlg);

				//Invalide l'affichage
				InvalidateRect(hDlg,&rect,0);
			}
			//Une mosaque est slectionne
			else if (type==TYPE_MOSAIQUE)		{
				selection=SEL_MOSAIQUE;
				strcpy(cTitre, (char*)elements[i].nom_fichier);
				palette=(u32*)malloc(sizeof(u32)*curPF->nbMaxColors);
//				motifs=(unsigned char*)malloc(tileX*tileY*TILEMAX);
				motifs=NULL;

				//Lecture du tileset (va galement charger une palette)
				if (!LitTileset((u8*)palette, &motifs, &elements[i], 0))
					goto pasbon;
				if (motifs && curPF->pfList[curCMode].bFirstColorTransparent)
					RendTilesetTransparent(palette, motifs);

				DessineTileset(palette,motifs);
				//Affiche le nombre de mosaques calcul
				sprintf(str,"%i mosaques",taille);
				hStatic03=MyCreateWindowFen("Static", str,WS_CHILD | WS_VISIBLE,
					0,300,230,18, hDlg);
				free(palette);
				if (motifs)
					free(motifs);

				//Pour les options avances
				hBoutonConfigure = MyCreateWindowFen("Button", "Options", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
					300,0,70,20, hDlg);

				//Invalide l'affichage ('faudra le redessiner ensuite)
				InvalidateRect(hDlg,&rect,0);
			}
			//Une carte est slectionne
			else if (type==TYPE_CARTE)		{
				selection=SEL_CARTE;
				strcpy(cTitre, (char*)elements[i].nom_fichier);

				if (editeurOuvert)
					Editer=0;

				if (!Editer)		{
					palette=(u32*)malloc(sizeof(u32)*curPF->nbMaxColors);
//					motifs=(unsigned char*)malloc(tileX*tileY*TILEMAX);
					motifs=NULL;

					//Lecture de la map (va galement charger une palette et un tileset)
					map=NULL;
					if (!LitMap(palette,&motifs,&map,i))		{
						Editer=0;
						goto pasbon;
					}
					if (motifs)
						RendTilesetTransparent(palette, motifs);

					//Affiche la taille de l'image.
					sprintf(str,"Taille: %ix%i blocs",tailleX,tailleY);
					hStatic03=MyCreateWindowFen("Static", str,WS_CHILD | WS_VISIBLE,
						0,300,230,18, hDlg);

					//Dessine la map
//					EffaceEcran(Bits2);
					ColoreCadre(0,0,LARG,HAUT,cFond);
					DessineMap(palette,motifs,map);

					//Cre le bouton diteur.
					hBoutonOk=MyCreateWindowFen("Button", "diter",WS_CHILD | WS_VISIBLE,
						310,296,70,20, hDlg);

					//Cre le bouton Effacer.
					char nom_fichier[MAX_PATH];
					//Efface le fichier .spt de config de l'diteur de maps
					GetNomFichierConfigMap(nom_fichier, elements[nElementSelectionne].nom_fichier);
					hBoutonReinit=MyCreateWindowFen("Button", "Config.",WS_CHILD | WS_VISIBLE,
						230,296,70,20, hDlg);
					if (!FichierExiste(nom_fichier))
						EnableWindow(hBoutonReinit, FALSE);
				}

				if (Editer)		{
					HWND hWnd;
					MSG msg;

					Editer=0;
					gblPal=NULL;
					gblMotifs=NULL;
					gblMap=NULL;
					num_edit=i;
//					FenMAJ();
//					DialogBox(hInst,(LPCTSTR)IDD_EDITEUR,hDlg,(DLGPROC)DlgEditeur);

					hWnd=CreateDialog(hInst,(LPCTSTR)IDD_EDITEUR,hDlg,(DLGPROC)DlgEditeur);
					while (GetMessage(&msg, NULL, 0, 0) && !Quitter)
					{
						if (!TranslateAccelerator(hWnd, hAccelEdit, &msg))
						{
							TranslateMessage(&msg);
							DispatchMessage(&msg);
						}
					}
					SetFocus(hDlg);

//					free(gblMap);
				}
				else		{
					if (map)
						free(map);
					if (palette)
						free(palette);
					if (motifs)
						free(motifs);
				}

				//Invalide l'affichage
				InvalidateRect(hDlg,&rect,0);
			}
			//Une liste est slectionne
			else if (type==TYPE_LISTE)		{
				selection=-1;
				strcpy(cTitre, (char*)elements[i].nom_fichier);
				InvalidateRect(hDlg,&rect,0);
				goto pasbon;
			}
			else		{
				selection=-1;
				sprintf(cTitre,"Rpertoire personnel %s",elements[i].nom_court);
				InvalidateRect(hDlg,&rect,0);
				goto pasbon;
			}

			GereBarresDefil(hDlg);
			goto __termine;
pasbon:
			tailleX = tailleY = 0;
__termine:
			TravailTermine();
		}
	}
	bImageTropGrosse = bRedimDIBOverflow;
	//Dtruit les anciens contrles
	for (i=0;i<NBRE_BOUTONS_DYNA;i++)
		DestroyWindow(hBoutonsCopy[i]);
	FenMAJ();
}

char *CreeNomRelatif(char *nom_srce)		{
	char tampon[MAX_PATH];
	int i,j;
	GetCurrentDirectory(MAX_PATH,tampon);
	j=strlen(tampon);
	if (strncmp(nom_srce,tampon,j)==0)	{
		strcpy(nom_srce,nom_srce+j+1);
		return nom_srce;
	}
	for (i=j-1;i>=0;i--)		{
		if (tampon[i]=='\\')
			break;
	}
	if (i<=0)		{
		return nom_srce;
	}
	if (tampon[i-1]==':')		{
		return nom_srce;
	}
	tampon[i]=0;
	j=i;
	if (strncmp(nom_srce,tampon,j)!=0)	{
		return nom_srce;
	}
	memmove(nom_srce+3,nom_srce+j+1,MAX_PATH-j-1);
	nom_srce[0]='.';
	nom_srce[1]='.';
	nom_srce[2]='\\';
	return nom_srce;
}


//Le bouton cliqu est inconnu au bataillon (il s'agit gnralement d'un bouton dynamique)
//Cette fonction leur donne une raison d'exister. ;)
void GereBoutonInconnu(HWND hDlg, HWND hCtrl)		{
	//Noms de fichiers (nan sincrement?)
	char nom_srce[MAX_PATH], nom_dest[MAX_PATH], nom_court[MAX_PATH],
		str[100];						//Sans oublier la fameuse 'str', grave en moi, qui est utilise comme chane temporaire ou pour sprintf, etc. :)
	int nCoul,i,j;
	//Variables temporaires
	ELEMENT els[10];					//Elments  passer aux fonctions de conversion
	HTREEITEM hti;
	int noModele;
	unsigned long *map;

	optimiseTil=optimisePal=FALSE;

	if (hCtrl == hBoutonConfigure)
	{
		if (selection == SEL_MOSAIQUE)			{
			PluginPropertiesWindow::hParent = hBoutonConfigure;
			PluginPropertiesWindow::Create(0, NULL, 125, 30, (DLGPROC)DlgOptionsTileset);
			hti=TreeView_GetSelection(hArbre);
			DessFenetre(gblHDlg,hti);
		}
		else if (selection == SEL_PALETTE)			{
			PluginPropertiesWindow::hParent = hBoutonConfigure;
			PluginPropertiesWindow::Create(0, NULL, 125, 30, (DLGPROC)DlgOptionsPalette);
			hti=TreeView_GetSelection(hArbre);
			DessFenetre(gblHDlg,hti);
		}
		else	{
			int cmode = -1;
			PluginPropertiesWindow::hParent = hBoutonConfigure;
			if (curPF->fctPluginConfigure)
				curPF->fctPluginConfigure(0x2000, &cmode);
		}
	}

	if (selection==SEL_CARTES)		{
		if (hCtrl==hBoutonParcourir)		{
			memset(nom_srce,0,sizeof(nom_srce));
			if (SauveFichier(nom_srce,"\1Fichiers code C\0*.c\0\0"))		{
				AjouteExtension(nom_srce, map_def_ext);
				SetWindowText(hTexte01,CreeNomRelatif(nom_srce));
			}
		}
	}
	else if (selection==SEL_LISTES)		{
		if (hCtrl==hBoutonParcourir)		{
			memset(nom_srce,0,sizeof(nom_srce));
			if (SauveFichier(nom_srce,"\1Fichiers code C\0*.c\0\0"))		{
				AjouteExtension(nom_srce, lst_def_ext);
				SetWindowText(hTexte01, CreeNomRelatif(nom_srce));
			}
		}
	}
	else if (selection==SEL_BITMAPS || selection==SEL_MOSAIQUES)		{
		//Bouton parcourir n1
		if (hCtrl==hBoutonParcourir)		{
			char *chneOfn;
			memset(nom_srce,0,sizeof(nom_srce));
			if (bGdiPlusEnabled)
				chneOfn="\1Fichiers image (.bmp, .png, .jpg, .gif, .tif)\0*.bmp;*.png;*.jpg;*.gif;*.tif\0\0";
			else
				chneOfn="\1Fichiers bitmap\0*.bmp\0\0";
			if (SauveFichier(nom_srce, chneOfn))		{
				CreeNomRelatif(nom_srce);
				SetWindowText(hTexte01,nom_srce);

				//On va parcourir la chane depuis la fin  la recherche du . de l'extension
				for (i=strlen(nom_srce)-1;i>=0;i--)
					if (nom_srce[i]=='.')	{			//Il est l!
						nom_srce[i]=0;					//Maintenant c'est la fin de la chane
						break;							//La boucle est termine
					}

				//Ici le but est de complter automatiquement les autres noms de fichiers
				// partir du fichier source en utilisant les extensions prvues.
				strcpy(nom_dest,nom_srce);
				if (selection==SEL_BITMAPS)		{			//Bitmap: 2 paramtres
					strcat(nom_dest,bmp_def_ext);
					SetWindowText(hTexte02,nom_dest);
					strcpy(nom_dest,nom_srce);
					strcat(nom_dest,pal_def_ext);
					SetWindowText(hTexte03,nom_dest);
				}
				else if (selection==SEL_MOSAIQUES)		{	//Mode de mosaques: 3 paramtres
					strcat(nom_dest,til_def_ext);
					SetWindowText(hTexte02,nom_dest);
					strcpy(nom_dest,nom_srce);
					strcat(nom_dest,pal_def_ext);
					SetWindowText(hTexte03,nom_dest);
					strcpy(nom_dest,nom_srce);
					strcat(nom_dest,map_def_ext);
					SetWindowText(hTexte04,nom_dest);
				}
			}
		}
		//Bouton parcourir n2
		else if (hCtrl==hBoutonParcourir2)		{
			memset(nom_srce,0,sizeof(nom_srce));
			if (SauveFichier(nom_srce,"\1Fichiers code C\0*.c\0\0"))		{
				CreeNomRelatif(nom_srce);
				SetWindowText(hTexte02,nom_srce);

				//Ici le but est de complter automatiquement les autres noms de fichiers
				// partir du fichier source en utilisant les extensions prvues.
				for (i=0;i<(signed)strlen(nom_srce);i++)
					if (nom_srce[i]=='.')	{			//Il est l!
						nom_srce[i]=0;					//Maintenant c'est la fin de la chane
						break;
					}
				strcpy(nom_dest,nom_srce);
				if (selection==SEL_BITMAPS)		{			//Bitmap: 2 paramtres
					strcat(nom_dest,pal_def_ext);
					SetWindowText(hTexte03,nom_dest);
				}
				else if (selection==SEL_MOSAIQUES)		{	//Mode de mosaques: 3 paramtres
					strcat(nom_dest,pal_def_ext);
					SetWindowText(hTexte03,nom_dest);
					strcpy(nom_dest,nom_srce);
					strcat(nom_dest,map_def_ext);
					SetWindowText(hTexte04,nom_dest);
				}
			}
		}
		//Bouton parcourir n3
		else if (hCtrl==hBoutonParcourir3)		{
			memset(nom_srce,0,sizeof(nom_srce));
			if (SauveFichier(nom_srce,"\1Fichiers code C\0*.c\0\0"))
				SetWindowText(hTexte03,CreeNomRelatif(nom_srce));
		}
		//Bouton parcourir n4 ^^
		else if (hCtrl==hBoutonParcourir4)		{
			memset(nom_srce,0,sizeof(nom_srce));
			if (SauveFichier(nom_srce,"\1Fichiers code C\0*.c\0\0"))
				SetWindowText(hTexte04,CreeNomRelatif(nom_srce));
		}
	}

	if (hCtrl==hBoutonReinit)		{
		int choix;
		RECT rect;
		HMENU hmenu;

		if (selection==SEL_CARTE)		{
			char nom_fichier[MAX_PATH];
			//Dtermine le fichier .spt de config de l'diteur de maps
			GetNomFichierConfigMap(nom_fichier, elements[nElementSelectionne].nom_fichier);

			hmenu=CreatePopupMenu();
			AppendMenu(hmenu,MF_STRING, OM_OUVRIR, "Ouvrir");
			AppendMenu(hmenu,MF_STRING, OM_SUPPRIMER, "Supprimer");
			GetWindowRect(hCtrl, &rect);
			choix=TrackPopupMenu(hmenu,TPM_LEFTALIGN | TPM_RETURNCMD | TPM_RIGHTBUTTON, rect.left, rect.bottom, 0, hDlg, NULL);
			DestroyMenu(hmenu);

			if (choix == OM_OUVRIR)		{
				sprintf(str,"notepad \"%s\"", nom_fichier);
				WinExec(str, 1);
			}
			else if (choix == OM_SUPPRIMER)		{
				EffaceVersCorbeille(nom_fichier);
				EnableWindow(hBoutonReinit, FALSE);
			}
		}
	}
	//Bouton ok/diter
	else if (hCtrl==hBoutonOk)		{
		AnnuleNomVar();						//Le nom doit tre redfini  chaque fois sinon ce sera celui par dfaut
		TravailEnCours();
		if (selection==SEL_CARTE)		{
			Editer=TRUE;
			hti=TreeView_GetSelection(hArbre);
			DessFenetre(gblHDlg,hti);
//			DessFenetre(gblHDlg,hti);
		}
		else if (selection==SEL_CARTES)		{
			GetWindowText(hTexte01,nom_dest,MAX_PATH);

			strcpy(els[0].nom_base,nom_dest);
			strcpy(els[0].nom_fichier,nom_dest);

			faitNomCourt(nom_dest,nom_court);
			strcpy(els[0].nom_court,nom_court);

			els[0].type=TYPE_CARTE;

			GetWindowText(hTexte02,str,MAX_PATH);
			tailleX=atoi(str);
			GetWindowText(hTexte03,str,MAX_PATH);
			tailleY=atoi(str);

			i=SendMessage(hComboTypeMap,CB_GETCURSEL,0,0);
			ModeTexte=i;

			i=SendMessage(hComboPalette,CB_GETCURSEL,0,0);
			i=TrouveNiemeElement(TYPE_PALETTE,i+1);
			utilPalette=i;

			i=SendMessage(hComboTileset,CB_GETCURSEL,0,0);
			i=TrouveNiemeElement(TYPE_MOSAIQUE,i+1);
			bUtilTileset=i;

			LitComboTiles();

			map = (unsigned long*)malloc(tailleX * tailleY * sizeof(long));
			memset(map, 0, tailleX * tailleY * sizeof(long));
			if (curPF->fctInitConversion)
				curPF->fctInitConversion(2, NULL);
			if (curPF->fctMapWrite(PL_EMPTY, &curCMode, &els[0], &elements[bUtilTileset], &elements[utilPalette], map, tailleX, tailleY, tileX, tileY))			{
				AjouteAuProjet(els[0]);
			}
			free(map);
/*			else		{
				CacheTravail();
				MessageBox(gblHDlg,"Impossible d'crire le fichier spcifi.\nVrifiez que le nom est correct et que vous avez les droits d'accs suffisants",nom_dest,MB_ICONERROR);
			}*/
		}
		else if (selection==SEL_LISTES)		{
			GetWindowText(hTexte01,nom_dest,MAX_PATH);

			strcpy(els[0].nom_base,nom_dest);
			strcpy(els[0].nom_fichier,nom_dest);

			faitNomCourt(nom_dest,nom_court);
			strcpy(els[0].nom_court,nom_court);

			els[0].type=TYPE_LISTE;

			i=SendMessage(hComboTileset,CB_GETCURSEL,0,0);
			i=TrouveNiemeElement(TYPE_MOSAIQUE,i+1);
			bUtilTileset=i;

			LitComboTiles();

			noModele = SendMessage(hComboModeles,CB_GETCURSEL,0,0);

			SPRITE_LISTE sl;
			sl.nbSprites = 0;
			sl.sd = NULL;
			sl.sizeofSD = sdParams[gblSdModele].sizeofSD;
			if (curPF->fctInitConversion)
				curPF->fctInitConversion(2, NULL);
			if (curPF->fctListWrite(PL_EMPTY, &curCMode, &els[0], &elements[bUtilTileset], NULL, &sl, typesd, NULL, &sdParams[noModele], tileX, tileY))			{
				AjouteAuProjet(els[0]);
			}
/*			else		{
				CacheTravail();
				MessageBox(gblHDlg,"Impossible d'crire le fichier spcifi.\nVrifiez que le nom est correct et que vous avez les droits d'accs suffisants",nom_dest,MB_ICONERROR);
			}*/
		}
/*		else if (selection==SEL_BITMAPS16)		{
			GetWindowText(hTexte01,nom_srce,MAX_PATH);
			GetWindowText(hTexte02,nom_dest,MAX_PATH);

			strcpy(els[0].nom_base,nom_srce);
			strcpy(els[0].nom_fichier,nom_dest);

			faitNomCourt(nom_dest,nom_court);
			strcpy(els[0].nom_court,nom_court);

			els[0].type=TYPE_BITMAP16;

			if (PasteImage(els[0].nom_base,&tailleX,&tailleY,0))		{
				if (ConvertitBmp16(els))		{					//Si la conversion a russi
					AjouteAuProjet(els[0]);
				}
			}
		}
		else if (selection==SEL_BITMAPS8)		{
			GetWindowText(hTexte05,str,100);
			nCoul=atoi(str);
			if (nCoul<1 || nCoul>255)	{
				CacheTravail();
				MessageBox(gblHDlg,"Le nombre de couleurs entr n'est pas valide (1<=n<=255)","Oups...",MB_ICONERROR);
			}
			else	{
				j=SendMessage(hCheckPal,BM_GETCHECK,0,0);
				if (j!=BST_UNCHECKED)		{
					i=SendMessage(hComboPalette,CB_GETCURSEL,0,0);
					i=TrouveNiemeElement(TYPE_PALETTE,i+1);
					utilPalette=i;
					if (j==BST_CHECKED)
						optimisePal=TRUE;
					else
						optimisePal=FALSE;
				}
				else
					utilPalette=-1;

				GetWindowText(hTexte01,nom_srce,MAX_PATH);
				GetWindowText(hTexte02,nom_dest,MAX_PATH);
				strcpy(els[0].nom_base,nom_srce);
				strcpy(els[0].nom_fichier,nom_dest);

				faitNomCourt(nom_dest,nom_court);
				strcpy(els[0].nom_court,nom_court);
				els[0].type=TYPE_BITMAP8;

				if (PasteImage(els[0].nom_base,&tailleX,&tailleY,1))		{
					if (utilPalette>=0)
						strcpy(nom_dest,elements[utilPalette].nom_fichier);
					else
						GetWindowText(hTexte03,nom_dest,MAX_PATH);

					strcpy(els[1].nom_base,nom_srce);
					strcpy(els[1].nom_fichier,nom_dest);

					faitNomCourt(nom_dest,nom_court);

					strcpy(els[1].nom_court,nom_court);
					els[1].type=TYPE_PALETTE;

					if (ConvertitBmp8(els,nCoul))			{

						AjouteAuProjet(els[0]);
						AjouteAuProjet(els[1]);
					}
//					strcpy(elements[nbreElements-1].nom_palette,nom_dest);
				}
				else		{
					CacheTravail();
					MessageBox(gblHDlg,"Impossible de charger le fichier bitmap spcifi","Erreur",MB_ICONERROR);
				}
			}
		}*/
		else if (selection==SEL_BITMAPS)		{
			curCMode = SendMessage(hComboTileBits,CB_GETCURSEL,0,0);
			InitConversion();

			GetWindowText(hTexte05,str,100);
			nCoul=atoi(str);
			if ((nCoul<1 || nCoul>curPF->pfList[curCMode].nbCouleursMax) && curPF->pfList[curCMode].bUsePalettes)	{
				CacheTravail();
				MessageBox(gblHDlg,"Le nombre de couleurs entr n'est pas valide.","Oups...",MB_ICONERROR);
			}
			else	{
				j=SendMessage(hCheckPal,BM_GETCHECK,0,0);
				if (j!=BST_UNCHECKED)		{
					i=SendMessage(hComboPalette,CB_GETCURSEL,0,0);
					i=TrouveNiemeElement(TYPE_PALETTE,i+1);
					utilPalette=i;
					if (j==BST_CHECKED)
						optimisePal=TRUE;
					else
						optimisePal=FALSE;
				}
				else
					utilPalette=-1;

				GetWindowText(hTexte01,nom_srce,MAX_PATH);
				GetWindowText(hTexte02,nom_dest,MAX_PATH);
				strcpy(els[0].nom_base,nom_srce);
				strcpy(els[0].nom_fichier,nom_dest);

				faitNomCourt(nom_dest,nom_court);
				strcpy(els[0].nom_court,nom_court);
				els[0].type=TYPE_BITMAP;

				if (VideoBufferPasteImage(vbApercu, els[0].nom_base,&tailleX,&tailleY,1))		{
					if (utilPalette>=0)
						strcpy(nom_dest,elements[utilPalette].nom_fichier);
					else
						GetWindowText(hTexte03,nom_dest,MAX_PATH);

					strcpy(els[1].nom_base,nom_srce);
					strcpy(els[1].nom_fichier,nom_dest);

					faitNomCourt(nom_dest,nom_court);

					strcpy(els[1].nom_court,nom_court);
					els[1].type=TYPE_PALETTE;

					if (curPF->fctInitConversion)
						curPF->fctInitConversion(2, NULL);
					if (ConvertitBitmap(els,nCoul))			{
/*						if (utilPalette>=0)
							EffaceElement(utilPalette);*/

						AjouteAuProjet(els[0]);
						AjouteAuProjet(els[1]);
					}
//					strcpy(elements[nbreElements-1].nom_palette,nom_dest);
				}
				else		{
					CacheTravail();
					MessageBox(gblHDlg,"Impossible de charger le fichier bitmap spcifi","Erreur",MB_ICONERROR);
				}
			}
		}
		else if (selection==SEL_MOSAIQUES)		{
//			MessageBox(hDlg,"C'est marqu que ce n'est pas implment (a signifie que ce n'est pas disponible pour le moment).\nJe ferai de mon mieux pour que a le soit le plus rapidement possible... :-)","Secrtaire blonde dtecte!",MB_ICONEXCLAMATION);
			GetWindowText(hTexte01,nom_srce,MAX_PATH);

			//On va questionner le bouton radio "Mode texte".
			j=SendMessage(hComboTypeMap,CB_GETCURSEL,0,0);
			ModeTexte=j;

			//Mode 16 couleurs... (16 palettes de 16)
//			j=SendMessage(hCheck16,BM_GETCHECK,0,0);
			curCMode = SendMessage(hComboTileBits,CB_GETCURSEL,0,0);
			InitConversion();

			//Gnrer une map?
			if (SendMessage(hCheckMap,BM_GETCHECK,0,0)==BST_CHECKED)
				bGenereMap=TRUE;
			//Si ce n'est pas lui qui est slectionn alors c'est le mode rotation
			else
				bGenereMap=FALSE;

			//Optimiser le tileset?
			if (SendMessage(hCheckOptimise,BM_GETCHECK,0,0)==BST_CHECKED)
				bOptimiseTileset=TRUE;
			//Si ce n'est pas lui qui est slectionn alors c'est le mode rotation
			else
				bOptimiseTileset=FALSE;

			j=SendMessage(hCheckPal,BM_GETCHECK,0,0);
			if (j!=BST_UNCHECKED)		{
				i=SendMessage(hComboPalette,CB_GETCURSEL,0,0);
				i=TrouveNiemeElement(TYPE_PALETTE,i+1);
				utilPalette=i;
				if (j==BST_CHECKED)
					optimisePal=TRUE;
				else
					optimisePal=FALSE;
			}
			else
				utilPalette=-1;

			j=SendMessage(hCheckTileset,BM_GETCHECK,0,0);
			if (j!=BST_UNCHECKED)		{
				i=SendMessage(hComboTileset,CB_GETCURSEL,0,0);
				i=TrouveNiemeElement(TYPE_MOSAIQUE,i+1);
				bUtilTileset=i;
				if (j==BST_CHECKED)
					optimiseTil=TRUE;
				else
					optimiseTil=FALSE;
			}
			else
				bUtilTileset=-1;

			i=SendMessage(hComboTaille,CB_GETCURSEL,0,0);

			if (i==0)
				tailleVoulueX=tailleVoulueY=0;
			else if (i==1)
				tailleVoulueX=tailleVoulueY=128;
			else if (i==2)
				tailleVoulueX=tailleVoulueY=256;
			else if (i==3)
				tailleVoulueX=tailleVoulueY=512;
			else if (i==4)
				tailleVoulueX=tailleVoulueY=1024;

			GetWindowText(hTexte05,str,100);
			nCoul=atoi(str);

			LitComboTiles();

			if ((nCoul<1 || nCoul>curPF->pfList[curCMode].nbCouleursMax) && curPF->pfList[curCMode].bUsePalettes)	{
				CacheTravail();
				MessageBox(gblHDlg,"Le nombre de couleurs entr n'est pas valide.","Oups...",MB_ICONERROR);
			}
			else	{
				if (bUtilTileset>=0)
					strcpy(nom_dest,elements[bUtilTileset].nom_fichier);
				else
					GetWindowText(hTexte02,nom_dest,MAX_PATH);


				strcpy(els[0].nom_base,nom_srce);
				strcpy(els[0].nom_fichier,nom_dest);

				faitNomCourt(nom_dest,nom_court);
				strcpy(els[0].nom_court,nom_court);

				if (VideoBufferPasteImage(vbApercu, els[0].nom_base,&tailleX,&tailleY,1))		{
					if (tailleVoulueX==0 && tailleVoulueY==0 && (tailleX%tileX || tailleY%tileY))		{
						CacheTravail();
						if (MessageBox(NULL,"Les dimensions de la bitmap (hauteur et largeur) devraient tre multiples de 8.\nLes bords seront complts par la couleur 0...","Oups",MB_ICONEXCLAMATION|MB_OKCANCEL)==IDCANCEL)
							goto perdu;
						AffTravail();
					}

					if (utilPalette>=0)
						strcpy(nom_dest,elements[utilPalette].nom_fichier);
					else
						GetWindowText(hTexte03,nom_dest,MAX_PATH);

					strcpy(els[1].nom_base,nom_srce);
					strcpy(els[1].nom_fichier,nom_dest);

					faitNomCourt(nom_dest,nom_court);
					strcpy(els[1].nom_court,nom_court);

					GetWindowText(hTexte04,nom_dest,MAX_PATH);

					strcpy(els[2].nom_base,nom_srce);
					strcpy(els[2].nom_fichier,nom_dest);

					faitNomCourt(nom_dest,nom_court);
					strcpy(els[2].nom_court,nom_court);

					els[0].type=TYPE_MOSAIQUE;
					els[1].type=TYPE_PALETTE;
					els[2].type=TYPE_CARTE;

					if (curPF->fctInitConversion)
						curPF->fctInitConversion(2, NULL);
					if (ConvertitTiles(els,nCoul))			{
/*						if (utilPalette>=0)
							EffaceElement(utilPalette);

						if (bUtilTileset>=0)
							EffaceElement(bUtilTileset);*/

						AjouteAuProjet(els[0]);
						if (curPF->pfList[curCMode].bUsePalettes)		//Ajoute la palette
							AjouteAuProjet(els[1]);
						if (bGenereMap)
							AjouteAuProjet(els[2]);
					}
				}				//Fin if image colle
			}					//Fin if nCoul valide
		}						//Fin if selection mosaques
perdu:
		TravailTermine();
	}
}

#include <shellapi.h>

void MajBoutons(HWND hBt)		{
	int i;
	if (!hBt)
		return;
	if (hBt==hCheckPal)			{
		//La case est-elle coche? 
		i=SendMessage(hCheckPal,BM_GETCHECK,0,0);
		//Activer ou dsactiver le contrle en fonction de la valeur de la case
		if (i!=BST_UNCHECKED && IsWindowEnabled(hCheckPal))		{
			EnableWindow(hComboPalette,TRUE);
			EnableWindow(hTexte03,FALSE);
			EnableWindow(hBoutonParcourir3,FALSE);
		}
		else		{
			EnableWindow(hComboPalette,FALSE);
			EnableWindow(hTexte03,TRUE);
			EnableWindow(hBoutonParcourir3,TRUE);
		}
	}
	else if (hBt==hCheckTileset)			{
		//La case est-elle coche? 
		i=SendMessage(hCheckTileset,BM_GETCHECK,0,0);
		//Activer ou dsactiver le contrle en fonction de la valeur de la case
		if (i!=BST_UNCHECKED)		{
			EnableWindow(hComboTileset,TRUE);
			EnableWindow(hTexte02,FALSE);
			EnableWindow(hBoutonParcourir2,FALSE);
		}
		else		{
			EnableWindow(hComboTileset,FALSE);
			EnableWindow(hTexte02,TRUE);
			EnableWindow(hBoutonParcourir2,TRUE);
		}
	}
	else if (hBt==hCheckMap)			{
		//La case est-elle coche? 
		i=SendMessage(hCheckMap,BM_GETCHECK,0,0);
		//Activer ou dsactiver le contrle en fonction de la valeur de la case
		if (i==BST_CHECKED)		{
			EnableWindow(hTexte04,TRUE);
			EnableWindow(hBoutonParcourir4,TRUE);
			EnableWindow(hComboTypeMap,TRUE);
			if (curPF->useUnoptimizedMapFormat)
				EnableWindow(hComboTaille,TRUE);
		}
		else		{
			EnableWindow(hTexte04,FALSE);
			EnableWindow(hComboTypeMap,FALSE);
			EnableWindow(hBoutonParcourir4,FALSE);
			if (curPF->useUnoptimizedMapFormat)
				EnableWindow(hComboTaille,FALSE);
		}
	}
	else if (hBt == hComboTiles)		{
		i=SendMessage(hComboTiles,CB_GETCURSEL,0,0);
		if (i==3)	{		//Case Personnalis
			if (DialogBox(hInst,(LPCTSTR)IDD_TILES,gblHDlg,(DLGPROC)DlgTiles)==IDCANCEL)
				SendMessage(hComboTiles,CB_SETCURSEL,lastComboTileSizeValue,0);
		}
		else
			lastComboTileSizeValue=i;
	}
	else if (hBt == hComboTileBits)		{
		i=SendMessage(hComboTileBits,CB_GETCURSEL,0,0);
		//Met le bon nombre de couleurs en fonction du mode
		if (curPF->pfList[i].bUsePalettes)			{
			sprintf(str, "%i", curPF->pfList[i].nbCouleursDefaut);
			SetWindowText(hTexte05, str);
			EnableWindow(hTexte05, TRUE);
			EnableWindow(hCheckPal, TRUE);
			EnableWindow(hTexte03, TRUE);
			EnableWindow(hBoutonParcourir3, TRUE);
			MajBoutons(hCheckPal);
		}
		else			{
			EnableWindow(hCheckPal, FALSE);
			MajBoutons(hCheckPal);
			EnableWindow(hTexte03, FALSE);
			EnableWindow(hBoutonParcourir3, FALSE);
			EnableWindow(hTexte05, FALSE);
		}
	}
	i=SendMessage(hComboTileBits,CB_GETCURSEL,0,0);
	EnableWindow(hBoutonConfigure, fctPluginConfigureIsEnabled(curPF, 0x2000|selection, i));
/*	else if (hBt==hRadioRotation)
		SendMessage(hRadioTexte,BM_SETCHECK,0,0);
	else if (hBt==hRadioTexte)
		SendMessage(hRadioRotation,BM_SETCHECK,0,0);*/
}

//Remplace tous les pixels d'une couleur par une autre
void AnalyseImage(int x, int y, int tX, int tY, unsigned int couleursrc, unsigned int couleurdst)			{
	int i,j;
	unsigned char r,v,b;

	for (j=y;j<y+tY;j++)
		for (i=x;i<x+tX;i++)			{
			LitPixRVB(i,j,&r,&v,&b);
			if (RGB(r,v,b)==couleursrc)
				DessPix(i,j,couleurdst);
		}
}

void SauveBmpPressePapiers()		{
	HDC hdcTemp;
	HBITMAP hbmTemp;
	int x,y, c;
	HDC hdcEcran;			//Releas

	hdcEcran=GetDC(NULL);
	hdcTemp=CreateCompatibleDC(hdcEcran);
	//A remplacer par les tailles max. du buffer
//	x=tailleX>DIMENSION_MAX?DIMENSION_MAX:tailleX;
//	y=tailleY>DIMENSION_MAX?DIMENSION_MAX:tailleY;
	x=LARG;
	y=HAUT;

//	AnalyseImage(scrollX,scrollY,x,y,cFond,RGB(rougeMasque,vertMasque,bleuMasque));
	AnalyseImage(0,0,x,y,RGBA_BGRA(cFond),RGB(bleuMasque,vertMasque,rougeMasque));
	hbmTemp=CreateCompatibleBitmap(hdcEcran,x,y);
//	hbmTemp = CreateBitmap(x, y, 1, 32, NULL);
	SelectObject(hdcTemp,hbmTemp);
	BitBlt(hdcTemp,0,0,x,y, vbApercu.m_hdc, 0,0,SRCCOPY);
	OpenClipboard(GetFocus());
	EmptyClipboard();
	SetClipboardData(CF_BITMAP,hbmTemp);
	CloseClipboard();

//	AnalyseImage(scrollX,scrollY,x,y,RGB(rougeMasque,vertMasque,bleuMasque),cFond);
	AnalyseImage(0,0,x,y,RGB(rougeMasque,vertMasque,bleuMasque),cFond);

	c = GetPixel(hdcTemp, 0,0);
	SetPixel(hdcTemp, 0,0, RGB(1,0,254));
	if (GetPixel(hdcTemp, 0,0) != RGB(1,0,254))		{
		MessageBox(gblHDlg, "Pour un rsultat optimal, vous devriez paramtrer les couleurs de votre cran en 24 ou 32 bits. Le mode actuel n'est pas assez prcis pour stocker l'image et des informations comme la couleur transparente ont t perdues.\nSi cela ne fonctionne toujours pas, utilisez la fonction exporter l'image.", "Attention", MB_ICONEXCLAMATION);
	}
	SetPixel(hdcTemp, 0,0, c);
	DeleteObject(hbmTemp);
	DeleteDC(hdcTemp);
	ReleaseDC(NULL,hdcEcran);
}

void SauveBmpDisque()		{
	int x,y;
	char nom_srce[MAX_PATH];

	memset(nom_srce, 0, sizeof(nom_srce));
//	if (SauveFichier(str,"\1Fichiers image (.bmp, .png, .jpg, .gif, .tif)\0*.bmp;*.jpg;*.gif;*.tif\0\0"))		{
	if (SauveFichier(nom_srce, "\5Fichiers image (.bmp, .png, .jpg, .gif, .tif)\0*.bmp;*.png;*.jpg;*.gif;*.tif\0\0"))		{
		//A remplacer par les tailles max. du buffer
	//	x=tailleX>DIMENSION_MAX?DIMENSION_MAX:tailleX;
	//	y=tailleY>DIMENSION_MAX?DIMENSION_MAX:tailleY;
		x=LARG;
		y=HAUT;

		AnalyseImage(0,0,x,y,RGBA_BGRA(cFond),RGB(bleuMasque,vertMasque,rougeMasque));
		GDIPLUS_SaveToDisk(vbApercu.m_hdc, x,y, nom_srce);
		AnalyseImage(0,0,x,y,RGB(rougeMasque,vertMasque,bleuMasque),cFond);
	}
}

void MainTree_ClearLastHti(HTREEITEM lastSelectedHti)		{
	TVITEM tvi;
	if (lastSelectedHti)		{
		//Un lment tait slectionn -> on le dselectionne
		tvi.hItem = lastSelectedHti;
		tvi.mask = TVIF_STATE;
		tvi.stateMask = TVIS_DROPHILITED|TVIS_BOLD;
		tvi.state = 0;
		TreeView_SetItem(hArbre, &tvi); 
	}
}

void MainTree_DropTargetHti(HTREEITEM hti)		{
	TVITEM tvi;
	tvi.hItem = hti;
	tvi.mask = TVIF_STATE;
	tvi.stateMask = TVIS_DROPHILITED|TVIS_BOLD;
	tvi.state = TVIS_DROPHILITED|TVIS_BOLD;
//  tvi.iImage = g_nClosed; 
//  tvi.iSelectedImage = g_nClosed; 
	TreeView_SetItem(hArbre, &tvi);
}

void VerifFichierProjetExiste(char *str)			{
	if (!fichierProjet[0])
		DemandeSauveProjet(str);
	else
		strcpy(str, fichierProjet);
}

// "Handler" pour la bote de dialogue
LRESULT CALLBACK Boite(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	LPNMHDR pnmh;
	LPNMTREEVIEW pnmtv;
	HDC hdcEcran, hdcFenetre;
	int i,j,r,v,b;
	static int posX=0, posY=0;
	char str[1000];
	int sCode, nPos;
	NMTVDISPINFO *ptvdi;
	HTREEITEM hti;
	ELEMENT el;
	TVHITTESTINFO thti;
	static int dragDrop=-1;
	static HTREEITEM lastSelectedHti=NULL;
	POINT point;
	FILE *f;

	switch (message)
	{
		//Initialisation de la bote de dialogue.
		//Cre les HDCs, les initialise, met toutes les choses  jour, etc.
		case WM_INITDIALOG:
/*			HIMAGELIST himl;
			if ((himl = ImageList_Create(0, 0, 
					FALSE, NUM_BITMAPS, 0)) == NULL) 
					return FALSE; */
//			ShowWindow(hDlg,SW_SHOW);
			memset(hBoutonsDyna, 0, sizeof(hBoutonsDyna));
			hFonte=(HFONT)SendMessage(hDlg,WM_GETFONT,0,0);
			MajListe(hDlg);
			hdcEcran=GetDC(NULL);
			hdcImage1=CreateCompatibleDC(hdcEcran);
			hbm1=CreateCompatibleBitmap(hdcEcran,380,16);
			SelectObject(hdcImage1,hbm1);
			dragDrop=-1;

			//Dessine le dgrad  trois coins
			hdcFenetre=GetDC(hDlg);
			//Il y a deux mthodes ;)
/*			for (j=0;j<16;j++)		{
				for (i=0;i<380;i++)		{
					SetPixel(hdcImage,i,j,RVB(2*i/3-(10*j),2*(380-i)/5,10*j+54));
				}
			}*/
			//Voil la deuxime
			for (j=0;j<16;j++)		{
				for (i=0;i<380;i++)		{
//					SetPixel(hdcImage1,i,j,RVB(25*(8-j)+i/12,20*(-7+j)+i/10,3*i/5));
					SetPixel(hdcImage1,i,j,RVB(3*i/5,20*(8-j)+i/12,25*(-7+j)+i/12));
//					SetPixel(hdcImage1,i,j,RVB(20*(8-j)+i/12,2*i/5,25*(-7+j)+i/12));
				}
			}
			//Dessine le bord arrondi
			j=GetPixel(hdcFenetre, POS_FEN(0, 0));
			cFond=RGBA_BGRA(j)|0xff000000;					//Sauver la couleur de fond
			DessineBlocArrondi();

			strcpy(cTitre, "Bienvenue! Slectionnez un lment...");

//			TreeView_SelectItem(hArbre,NULL);
/*			hdcEdit=CreateCompatibleDC(hdcEcran);
			CreeDIB(hdcEdit,LARG_BUF,HAUT_BUF,32,&hbmEdit,(void**)&Bits3);

			hdcSpec=CreateCompatibleDC(hdcEcran);
			CreeDIB(hdcSpec,LARG_BUF,HAUT_BUF,32,&hbmSpec,(void**)&Bits4);*/

			hdcImage3=CreateCompatibleDC(hdcEcran);
			hbm1=CreateCompatibleBitmap(hdcEcran,SIZE_FEN(380,16));
			SelectObject(hdcImage3,hbm1);

			gblHDlg=hDlg;
			hArbre=GetDlgItem(hDlg,IDC_PROJET);
//			TreeView_SelectItem(hArbre,NULL);

//			TravailTermine();
			lastComboTileSizeValue = 1;

			gblHDlg=hDlg;
			OuvreFichierConfig(fichierConfigAOuvrir,"onstart");
			if (arretdurgence==2 || !retourScript)
				SendMessage(hDlg,WM_CLOSE,0,0);
			else		{
//				FenVisible();
//				ShowWindow(hDlg,SW_SHOW);
//				FenMAJ();
				SetFocus(hDlg);
			}
			if (format_appliquer[0])
				ChoisitFormat(format_appliquer);
			if (modele_appliquer[0])
				ChoisitModele(modele_appliquer);
			DestroyWindow(hChargement);
			messages=1;

			ReleaseDC(hDlg,hdcFenetre);
			ReleaseDC(NULL,hdcEcran);

			// Redimensionne la fentre pour que tout soit toujours visible
			RECT rect;
			GetWindowRect(hDlg, &rect);
			rect.right = POSX_FEN(390) + rect.left;
			rect.bottom = POSY_FEN(326) + rect.top;
			AdjustWindowRect(&rect, GetWindowLong(hDlg, GWL_STYLE), TRUE);
			MoveWindow(hDlg, rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, TRUE);
			return TRUE;

		case WM_DROPFILES:
			HDROP hDrop;
			hDrop=(HDROP)wParam;
			j=DragQueryFile(hDrop,(UINT)-1,NULL,0);
			for (i=0;i<j;i++)		{
				DragQueryFile(hDrop,i,str,sizeof(str));
				ImporteFichier(str);
			}
			break;

		//La souris a t dplace
		case WM_MOUSEMOVE:
			if (dragDrop!=-1)			{
				RECT rtArbre;
				//Drag and drop en cours
				GetCursorPos(&point);
				GetWindowRect(hArbre, &rtArbre);
				if (!PtInRect(&rtArbre, point))			{
					SetCursor(LoadCursor(NULL, IDC_NO));
					MainTree_ClearLastHti(lastSelectedHti);
					lastSelectedHti = 0;
					break;
				}
				else		{
					ScreenToClient(hArbre,&point);
					thti.pt.x=point.x;
					thti.pt.y=point.y;
					hti=TreeView_HitTest(hArbre,&thti);
					if (!hti)			{
					}
					else if (lastSelectedHti == 0)
						SetCursor(LoadCursor(NULL, IDC_UPARROW));
					for (i=0;i<nbreElements;i++)
						if (elements[i].hti==hti)
							break;
					if (i<nbreElements)		{					//Pas un des dossiers de base
						//Pas un dossier -> lment parent
						if (!(elements[i].type&TYPE_DOSSIER))		{
							hti = TreeView_GetParent(hArbre, hti);
							for (i=0;i<nbreElements;i++)
								if (elements[i].hti==hti)
									break;
						}
					}
				}
				//Efface le dernier lment slectionn
				if (lastSelectedHti!=hti)
					MainTree_ClearLastHti(lastSelectedHti);
				lastSelectedHti=hti;
				MainTree_DropTargetHti(hti);
			}
			else		{
				//Code normal
				posX=LOWORD(lParam);
				posY=HIWORD(lParam);

				if (posX<POSX_FEN(0) || posY<POSY_FEN(0) ||
					posX>=POSX_FEN(0)+256 || posY>=POSY_FEN(0)+256)
					break;

				hdcFenetre=GetDC(hDlg);
				SelectObject(hdcFenetre,hfCourier);

				if (selection==SEL_PALETTE)		{
//					i=(tailleX/16)*((posY-BASEFEN_Y+scrollY)/16)+(posX-BASEFEN_X+scrollX)/16;
//					j=(posY-BASEFEN_Y)/16;
					i=(int)(((posX-POSX_FEN(0))/dpiScaleX+scrollX)/16);
					j=(int)(((posY-POSY_FEN(0))/dpiScaleY+scrollY)/16);
					if (i>=0 && i<gnPaletteWidth && j>=0 && j<tailleY)		{
						SetBkColor(hdcFenetre,RGBA_BGRA(cFond));
						SetTextColor(hdcFenetre,RGBA_BGRA(cFond)^0xffffff);
						r=v=b=0;
						LitPixRVB(i,j,(UCHAR*)&r,(UCHAR*)&v,(UCHAR*)&b);
						if (RGB(r,v,b)!=(unsigned int)RGBA_BGRA(cFond))		{
							sprintf(str,"Idx: %02X hex", i + j * gnPaletteWidth);
							TextOut(hdcFenetre,POS_FEN(290, 130),str,strlen(str));
							sprintf(str,"%03i,%03i,%03i",r/MULTR,v/MULTV,b/MULTB);
							TextOut(hdcFenetre,POS_FEN(290, 150),str,strlen(str));
						}
					}
				}
				else if (selection==SEL_MOSAIQUE || selection==SEL_CARTE)		{
					int bBlit = FALSE;
					i=(int)(((posX-POSX_FEN(0))/dpiScaleX+scrollX)/tileX);
					j=(int)(((posY-POSY_FEN(0))/dpiScaleY+scrollY)/tileY);
					if (i>=0 && i<tailleX/tileX && j>=0 && j<tailleY/tileY)				{
						SetBkColor(hdcFenetre,RGBA_BGRA(cFond));
						SetTextColor(hdcFenetre,RGBA_BGRA(cFond)^0xffffff);
						if (selection==SEL_MOSAIQUE)		{
							if (i+(tailleX/tileX)*j < taille)		{
								sprintf(str,"%03i  ", i+(tailleX/tileX)*j);
								TextOut(hdcFenetre,POS_FEN(322, 146),str,strlen(str));
								bBlit = TRUE;
							}
						}
						else	{
							sprintf(str,"%02i,%02i  ",i,j);
							TextOut(hdcFenetre,POS_FEN(316, 146),str,strlen(str));
							bBlit = TRUE;
						}
						if (bBlit)
							StretchBlt(hdcFenetre,POS_FEN(302, 78), SIZE_FEN(64, 64), vbApercu.m_hdc, tileX*i,tileY*j,tileX,tileY,SRCCOPY);
					}
				}

			ReleaseDC(hDlg,hdcFenetre);
			}
			break;
		//Ce message est envoy chaque fois que l'application doit tre redessine.
		case WM_PAINT:
			//Signale  Windows qu'on commence
			BeginPaint(hDlg,NULL);
			//Rcupre le HDC du dialogue.
			hdcFenetre=GetDC(hDlg);
			//Rcupre la couleur de fond
			//HACK!!!! Puisque les couleurs sur GBA sont des multiples de 8 (256 -> 32), il faut que la couleur de fond soit distingable. Avec a elle sera impaire et donc forcment diffrente.
			i=GetPixel(hdcFenetre,0,0)|1;
			//La couleur de fond a chang?
			if (i!=cFond && i!=CLR_INVALID)		{
				cFond=RGBA_BGRA(i);					//Sauver la couleur de fond
				DessineBlocArrondi();
			}
			//Dessine le titre
			DessTitre(hdcFenetre,cTitre);
			//Si la slection reprsente une image, on va l'afficher
			if (selection==SEL_BITMAP || selection==SEL_PALETTE || selection==SEL_CARTE || selection==SEL_MOSAIQUE)		{
				//L'image est stocke dans vbApercu->m_hdc (qui contient une DIB)
				i=tailleX>256?256:tailleX;
				j=tailleY>256?256:tailleY;
				if (selection==SEL_PALETTE)
					StretchBlt(hdcFenetre, POS_FEN(0, 0), SIZE_FEN(i, j), vbApercu.m_hdc,scrollX/16,scrollY/16,i/16,j/16,SRCCOPY);
				else
					StretchBlt(hdcFenetre, POS_FEN(0, 0), SIZE_FEN(i, j), vbApercu.m_hdc,scrollX,scrollY, i, j, SRCCOPY);
			}
			ReleaseDC(hDlg,hdcFenetre);
			//Signale  Windows qu'on a fini.
			EndPaint(hDlg,NULL);
//			return TRUE;
			break;

		case WM_VSCROLL:
			sCode = (int) LOWORD(wParam); // scroll bar value 
			nPos = (short int) HIWORD(wParam);  // scroll box position 

			//Vrifie ce qu'il s'est pass et modifie la variable en fonction de a
			if (sCode==SB_LINEUP)
				scrollY-=32;
			if (sCode==SB_LINEDOWN)
				scrollY+=32;
			if (sCode==SB_PAGEUP)
				scrollY-=192;
			if (sCode==SB_PAGEDOWN)
				scrollY+=192;
			if (sCode==SB_BOTTOM)
				scrollY=32767;
			if (sCode==SB_TOP)
				scrollY=0;
			if (sCode==SB_THUMBTRACK || sCode==SB_THUMBPOSITION)
				scrollY=nPos;

			//Remet la position dans la gamme possible
			if (scrollY>tailleY-256)
				scrollY=tailleY-256;
			if (scrollY<0)
				scrollY=0;

			//Met  jour la barre.
			SetScrollPos(hStatic05,SB_CTL,scrollY,TRUE);
			//Rcupre le HDC du dialogue.
			hdcFenetre=GetDC(hDlg);
			//Dessine la nouvelle image
			i=tailleX>256?256:tailleX;
			j=tailleY>256?256:tailleY;
			if (selection==SEL_PALETTE)
				StretchBlt(hdcFenetre, POS_FEN(0, 0), SIZE_FEN(i,j),vbApercu.m_hdc,scrollX/16,scrollY/16,i/16,j/16,SRCCOPY);
			else
				StretchBlt(hdcFenetre,POS_FEN(0,0), SIZE_FEN(i,j),vbApercu.m_hdc,scrollX,scrollY,i,j,SRCCOPY);
			ReleaseDC(hDlg,hdcFenetre);
			break;

		case WM_HSCROLL:
			sCode = (int) LOWORD(wParam); // scroll bar value 
			nPos = (short int) HIWORD(wParam);  // scroll box position 

			//Vrifie ce qu'il s'est pass et modifie la variable en fonction de a
			if (sCode==SB_LINEUP)
				scrollX-=32;
			if (sCode==SB_LINEDOWN)
				scrollX+=32;
			if (sCode==SB_PAGEUP)
				scrollX-=192;
			if (sCode==SB_PAGEDOWN)
				scrollX+=192;
			if (sCode==SB_BOTTOM)
				scrollX=32767;
			if (sCode==SB_TOP)
				scrollX=0;
			if (sCode==SB_THUMBTRACK || sCode==SB_THUMBPOSITION)
				scrollX=nPos;

			//Remet la position dans la gamme possible
			if (scrollX>tailleX-256)
				scrollX=tailleX-256;
			if (scrollX<0)
				scrollX=0;

			//Met  jour la barre.
			SetScrollPos(hStatic04,SB_CTL,scrollX,TRUE);
			//Rcupre le HDC du dialogue.
			hdcFenetre=GetDC(hDlg);
			//Dessine la nouvelle image
			i=tailleX>256?256:tailleX;
			j=tailleY>256?256:tailleY;
			if (selection==SEL_PALETTE)
				StretchBlt(hdcFenetre,POS_FEN(0, 0), SIZE_FEN(i, j),vbApercu.m_hdc,scrollX/16,scrollY/16,i/16,j/16,SRCCOPY);
			else
				StretchBlt(hdcFenetre, POS_FEN(0, 0), SIZE_FEN(i, j),vbApercu.m_hdc,scrollX,scrollY,i,j,SRCCOPY);
			ReleaseDC(hDlg,hdcFenetre);
			break;

		//Fin d'un drag-drop
		case WM_LBUTTONUP:
			if (dragDrop!=-1)			{
				RECT rtArbre;
				MainTree_ClearLastHti(lastSelectedHti);
				lastSelectedHti = 0;
				ReleaseCapture();
				GetCursorPos(&point);
				GetWindowRect(hArbre, &rtArbre);
				//En dehors de la zone => ne fait rien
				if (!PtInRect(&rtArbre, point))		{
					dragDrop = -1;
					break;
				}
				ScreenToClient(hArbre,&point);
				thti.pt.x=point.x;
				thti.pt.y=point.y;
				hti=TreeView_HitTest(hArbre,&thti);
				SetCursor(LoadCursor(NULL, IDC_ARROW));
				if (!hti || hti==elements[dragDrop].hti)			{
					//Replace  la racine
					CopieElement(el,elements[dragDrop]);
					el.hti=NULL;
					el.type&=~DANS_DOSSIER;
					strcpy(el.dossier, "");
					CopieElement(elements[dragDrop], el);
					MajListe(hDlg);
					dragDrop = -1;
					break;
				}

				if (elements[dragDrop].type & TYPE_DOSSIER)			{
					for (i=0;i<nbreElements;i++)
						if (elements[i].hti==hti)
							break;
					if (i<nbreElements)		{					//Pas un des dossiers de base
						//Pas un dossier -> lment parent
						if (!(elements[i].type&TYPE_DOSSIER))		{
							hti = TreeView_GetParent(hArbre, hti);
							for (i=0;i<nbreElements;i++)
								if (elements[i].hti==hti)
									break;
						}
					}
					if (i==nbreElements)		{					//Un des dossiers de base -> replace l'lment dans son lieu d'origine
						for (i=1;i<nbreDossiersBase;i++)		{
							if (*typesHTI[i].hti == hti)
								break;
						}
						if (i<nbreDossiersBase)			{
							CopieElement(el,elements[dragDrop]);
							el.hti=NULL;
							if (!strcmp(el.dossier, typesHTI[i].nom))			{	//Dj le mme dossier => sort (racine)
								el.type&=~DANS_DOSSIER;
								strcpy(el.dossier, "");
							}
							else		{
								el.type|=DANS_DOSSIER;
								strcpy(el.dossier, typesHTI[i].nom);
							}
							CopieElement(elements[dragDrop], el);
							MajListe(hDlg);
						}
					}
					else if (!(elements[i].type&TYPE_DOSSIER))		{		//Pas un dossier -> impossible
						dragDrop = -1;
						break;
					}
					else		{									//Dans un dossier -> dplacement
						//Code rcursif pour viter qu'un dossier soit plac dans un sous-dossier de lui-mme
						int k;
						k=i;
						j=i;
redo:
						if (!strcmp(elements[j].nom_court, elements[dragDrop].nom_court))			{
							dragDrop = -1;
							MessageBox(hDlg, "Vous ne pouvez pas dplacer un rpertoire dans l'un de ses sous-rpertoires!", "Erreur", MB_ICONERROR);
							break;
						}
						for (j=0;j<nbreElements;j++)		{
							if (elements[j].type & TYPE_DOSSIER && !strcmp(elements[j].nom_court, elements[k].dossier))			{
								k=j;
								goto redo;
							}
						}
						//End Code
						if (j>=nbreElements)		{
							CopieElement(el,elements[dragDrop]);
							el.type|=DANS_DOSSIER;
							el.hti=NULL;
							strcpy(el.dossier,elements[i].nom_court);
							CopieElement(elements[dragDrop], el);
							MajListe(hDlg);
							TreeView_EnsureVisible(hArbre, elements[dragDrop].hti);
						}
					}
				}
				else			{
					//Elment normal
					for (i=0;i<nbreElements;i++)
						if (elements[i].hti==hti)
							break;
					if (i<nbreElements)		{					//Pas un des dossiers de base
						//Pas un dossier -> lment parent
						if (!(elements[i].type&TYPE_DOSSIER))		{
							hti = TreeView_GetParent(hArbre, hti);
							for (i=0;i<nbreElements;i++)
								if (elements[i].hti==hti)
									break;
						}
					}
					if (i==nbreElements)		{					//Un des dossiers de base -> replace l'lment dans son lieu d'origine
						CopieElement(el,elements[dragDrop]);
						if (!(el.type&DANS_DOSSIER) && !dejaAvertiElementDossierBase)
							MessageBox(hDlg, "L'lment se trouve dj dans le dossier par dfaut pour ce type de fichier. Vous ne pouvez pas placer un lment dans un autre dossier de base que celui d'origine (par exemple une Carte dans le dossier Mosaques).", "Note", MB_ICONINFORMATION);
						dejaAvertiElementDossierBase=1;
						el.type&=(~DANS_DOSSIER);
						el.hti=NULL;
						strcpy(el.dossier, "");
						EffaceElement(dragDrop);
						AjouteAuProjet(el);
					}
					else if (!(elements[i].type&TYPE_DOSSIER))		{		//Pas un dossier -> impossible
						dragDrop = -1;
						break;
					}
					else		{									//Dans un dossier -> dplacement
						CopieElement(el,elements[dragDrop]);
						el.type|=DANS_DOSSIER;
						el.hti=NULL;
						strcpy(el.dossier,elements[i].nom_court);
						EffaceElement(dragDrop);
						AjouteAuProjet(el);
		/*				elements[dragDrop].type|=DANS_DOSSIER;
						strcpy(elements[dragDrop].dossier,elements[i].nom_court);
						MajListe(hDlg);*/
					}
				}
				dragDrop = -1;
			}
			break;

		//Message de notification
		case WM_NOTIFY:
			pnmh = (LPNMHDR) lParam;
			//Si a vient pas de l'arbre -> poubelle
			if (wParam==IDC_PROJET)		{
				//Quel code?
				switch (pnmh->code)		{
					case TVN_BEGINDRAG:
						pnmtv = (LPNMTREEVIEW) lParam;
						hti=pnmtv->itemNew.hItem;
						SetCursor(LoadCursor(NULL, IDC_UPARROW));
						if (!hti)
							break;
						for (i=0;i<nbreElements;i++)
							if (elements[i].hti==hti)
								break;
						if (i==nbreElements)
							break;
//						if (elements[i].type&TYPE_DOSSIER)
//							break;
						dragDrop=i;
					    SetCapture(GetParent(hTV)); 
						break;

					case TVN_BEGINLABELEDIT:
						HWND hEdit;
						ptvdi=(LPNMTVDISPINFO) lParam;
						hti=ptvdi->item.hItem;
/*						TVITEM tvi;
						tvi.hItem = hti;
						tvi.mask = TVIF_TEXT;
						tvi.pszText = "HELLO";
						TreeView_SetItem(hArbre, &tvi); */
						for (i=0;i<nbreElements;i++)
							if (elements[i].hti==hti)
								break;
						if (i==nbreElements)		{
							TreeView_EndEditLabelNow(hArbre,TRUE);
							break;
						}
/*						else if (elements[i].type&TYPE_DOSSIER)			{
							TreeView_EndEditLabelNow(hArbre,TRUE);
							break;
						}*/
						//Remet le nom complet dans l'editbox
						hEdit = TreeView_GetEditControl(hArbre);
						SetWindowText(hEdit, elements[i].nom_court);
						return FALSE;

					case TVN_ENDLABELEDIT:
						ptvdi=(LPNMTVDISPINFO) lParam;
						hti=ptvdi->item.hItem;
						for (i=0;i<nbreElements;i++)
							if (elements[i].hti==hti)
								break;
						if (i==nbreElements)		{
							goto erreur;
						}
						else		{
							if (elements[i].type & TYPE_DOSSIER)		{
								if (!ptvdi->item.pszText || !(*ptvdi->item.pszText))
									goto erreur;
								CopieElement(el, elements[i]);
								if (strlen(ptvdi->item.pszText)>=sizeof(elements->nom_court)-1)
									ptvdi->item.pszText[sizeof(elements->nom_court)-1]=0;
								strcpy(el.nom_court,ptvdi->item.pszText);
								//Remplace le dossier de tout ceux qui l'utilisent
								for (j=0;j<nbreElements;j++)		{
									//Etait dans ce dossier?
									if (!strcmp(elements[j].dossier, elements[i].nom_court))
										strcpy(elements[j].dossier, el.nom_court);
								}
								CopieElement(elements[i], el);
								MajListe(hDlg);
								TreeView_SelectItem(hArbre,elements[i].hti);
							}
							else	{
								if (!ptvdi->item.pszText || !(*ptvdi->item.pszText))			{
									if (bEtatDupliqueElement)
										EffaceElement(i);
									goto erreur;
								}
								CopieElement(el,elements[i]);
								EffaceElement(i);
								if (strlen(ptvdi->item.pszText)>=sizeof(elements->nom_court)-1)
									ptvdi->item.pszText[sizeof(elements->nom_court)-1]=0;
								strcpy(el.nom_court,ptvdi->item.pszText);
								if (bEtatDupliqueElement)		{
									char extension[MAX_PATH], dossier[MAX_PATH];
									strcpy(dossier, el.nom_fichier);
									GetNomDossier(dossier);
									strcpy(extension, GetWideExtension(el.nom_fichier));
									//Ne pas traduire
									sprintf(el.nom_fichier, "%s%s%s%s%s", dossier, dossier[0]?"\\":"", el.nom_court, extension[0]?".":"",extension);
									//Traduction possible
									// Copie le fichier et met  jour les rfrences vers le reffile
									if (CopyFile(elements[bEtatDupliqueElement-1].nom_fichier, el.nom_fichier, TRUE))
										refFile::reworkSection(refFile::copySection, elements[bEtatDupliqueElement-1].nom_fichier, el.nom_fichier);
								}
								AjouteAuProjet(el);
								bEtatDupliqueElement=0;
								TreeView_SelectItem(hArbre,elements[nbreElements-1].hti);
							}
						}
erreur:
						bEtatDupliqueElement=0;
						break;
					case TVN_KEYDOWN:
						NMTVKEYDOWN *ptvkd;
						ptvkd = (LPNMTVKEYDOWN) lParam;
						hti=TreeView_GetSelection(hArbre);
						if (ptvkd->wVKey==VK_DELETE || ptvkd->wVKey==VK_F2)		{
							for (i=0;i<nbreElements;i++)
								if (elements[i].hti==hti)
									break;
							if (i==nbreElements)
								break;
							if (ptvkd->wVKey==VK_DELETE)		{
								if (elements[i].type&TYPE_DOSSIER)		{
									for (j=0;j<nbreElements;j++)		{
										if (!strcmp(elements[j].dossier,elements[i].nom_court))
											break;
									}
									if (j<nbreElements)		{
										if (MessageBox(gblHDlg,"Ce dossier n'est pas vide! Vous devriez d'abord supprimer les lments qui s'y trouvent!\nVoulez-vous VRAIMENT le supprimer?","Attention!",MB_ICONEXCLAMATION|MB_YESNO|MB_DEFBUTTON2)==IDNO)
											break;
									}
									EffaceElement(i);
								}
								else	{
									f=fopen(elements[i].nom_fichier,"rb");
									if (f)		{
										j = fMsgBox(gblHDlg, "Question", MB_ICONINFORMATION|MB_YESNOCANCEL|MB_DEFBUTTON2, "Supprimer l'lment dfinitivement, le fichier associ (%s) compris?", elements[i].nom_fichier);
										fclose(f);
									}
									else
										j=IDNO;
									if (j!=IDCANCEL)		{
										if (j==IDYES)		{
											EffaceVersCorbeille(elements[i].nom_fichier);
										}
										EffaceElement(i);
									}
								}
							}
							else if (ptvkd->wVKey==VK_F2)
								TreeView_EditLabel(hArbre,hti);
						}
						break;

					case TVN_SELCHANGED:
						//La slection a chang. On redessine la fentre en signalant
						//la nouvelle slection.
						pnmtv = (LPNMTREEVIEW) lParam;
						if (notification)
							DessFenetre(hDlg,pnmtv->itemNew.hItem);
						break;

					case NM_DBLCLK:
						GetCursorPos(&point);
						ScreenToClient(hArbre,&point);
						thti.pt.x=point.x;
						thti.pt.y=point.y;
						hti=TreeView_HitTest(hArbre,&thti);
						if (!hti)
							break;
//						TreeView_DeleteItem(hArbre,hti);
						for (i=0;i<nbreElements;i++)
							if (elements[i].hti==hti)
								break;
						if (i==nbreElements)
							break;
						if (elements[i].type&TYPE_DOSSIER)
							break;
						if (((elements[i].type)&MASQUE_TYPE)==TYPE_CARTE)		{
							Editer=TRUE;
							hti=TreeView_GetSelection(hArbre);
							DessFenetre(gblHDlg,hti);
							DessFenetre(gblHDlg,hti);
						}
						else	{
							sprintf(str,"notepad \"%s\"",elements[i].nom_fichier);
							WinExec(str,1);
						}
						break;
					case NM_RCLICK:
						GetCursorPos(&point);
						ScreenToClient(hArbre,&point);
						thti.pt.x=point.x;
						thti.pt.y=point.y;
						hti=TreeView_HitTest(hArbre,&thti);
						if (!hti)
							break;
//						TreeView_DeleteItem(hArbre,hti);
						GereBoutonDroit(hti);
						break;
				}
			}
			break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 

			switch (HIWORD(wParam))		{
				case CBN_SELCHANGE:
					MajBoutons((HWND)lParam);
					break;
				case BN_CLICKED:
					MajBoutons((HWND)lParam);
					break;
			}

			if (wmId>=BASEMENU && wmId<BASEMENU+nbreProcedures)		{
				GetMenuString(GetMenu(hDlg),wmId,str,sizeof(str),MF_BYCOMMAND);
				OuvreFichierConfig(fichierConfigAOuvrir,str);
				break;
			}

			//Analyse les slections du menu
			switch (wmId)
			{
				case IDM_NOUVEAU:
					i=MessageBox(hDlg,"Enregistrer le projet d'abord?","Attention",MB_ICONINFORMATION|MB_YESNOCANCEL);
					if (i==IDCANCEL)
						break;
					if (i==IDYES)		{
						VerifFichierProjetExiste(str);
						if (!(*str))
							break;
						SauveProjet(str);
					}
					memset(elements,0,1000*sizeof(ELEMENT));
					nbreElements=0;
					fichierProjet[0]=0;
					MajListe(hDlg);
					break;
				case IDM_OUVRIR:
					i=MessageBox(hDlg,"Enregistrer le projet d'abord?","Attention",MB_ICONINFORMATION|MB_YESNOCANCEL);
					if (i==IDCANCEL)
						break;
					if (i==IDYES)		{
						VerifFichierProjetExiste(str);
						if (!(*str))
							break;
						SauveProjet(str);
					}
					memset(str,0,MAX_PATH);
					if (OuvreFichier(str,"\1Fichiers projet GBA Graphics *.pgg\0*.pgg\0\0"))		{
						ChargeProjet(str);
						FichierProjetActif(str);
						MajListe(hDlg);
					}
					break;

				case IDM_NETTOYER:
					if (MessageBox(hDlg, "Tous les lments pointant vers un fichier qui n'existe plus seront supprims.\nDe plus, les proprits des fichiers qui n'existent plus seront supprimes du fichier index (.ref).", "Nettoyage du projet", MB_ICONINFORMATION | MB_OKCANCEL) == IDOK)
						nettoieProjetCourant();
					break;

				case IDM_EXPORTERIMAGE:
					if (bImageTropGrosse)			{
						i = fMsgBox(hDlg, "Avertissement", MB_ICONEXCLAMATION|MB_OKCANCEL, "L'image ne peut pas tre sauvegarde compltement car la mmoire alloue est insuffisante. Si vous voulez copier l'image entire, veuillez augmenter dans les options la mmoire disponible pour les aperus (au moins %i Mo sont requis).", (bImageTropGrosse>>20)+1);
						if (i==IDCANCEL)
							break;
					}
					SauveBmpDisque();
					break;

				case IDM_COPIER:
					if (bImageTropGrosse)			{
						i = fMsgBox(hDlg, "Avertissement", MB_ICONEXCLAMATION|MB_OKCANCEL, "L'image ne peut pas tre sauvegarde compltement car la mmoire alloue est insuffisante. Si vous voulez copier l'image entire, veuillez augmenter dans les options la mmoire disponible pour les aperus (au moins %i Mo sont requis).", (bImageTropGrosse>>20)+1);
						if (i==IDCANCEL)
							break;
					}
					//A remplacer par les tailles max. du buffer
				//	i=tailleX>DIMENSION_MAX?DIMENSION_MAX:tailleX;
				//	j=tailleY>DIMENSION_MAX?DIMENSION_MAX:tailleY;
					i=LARG;
					j=HAUT;
					AnalyseImage(scrollX,scrollY,i,j,cFond,RGB(rougeMasque,vertMasque,bleuMasque));
					SauveBmpPressePapiers();
					AnalyseImage(scrollX,scrollY,i,j,RGB(rougeMasque,vertMasque,bleuMasque),cFond);
					break;

				case IDM_NOUVDOSS:
					DialogBox(hInst,(LPCTSTR)IDD_DOSSIER,hDlg,(DLGPROC)DlgNouvDoss);
					break;

				case IDM_SAUVER:
					VerifFichierProjetExiste(str);
					if (*str)		{
						FichierProjetActif(str);
						SauveProjet(str);
					}
					break;

				case IDM_SAUVERSOUS:
					DemandeSauveProjet(str);
					if (!(*str))
						break;
					FichierProjetActif(str);
					SauveProjet(str);
					break;
				case IDM_ACTUALISER:
					MajListe(hDlg);
					break;
				case IDM_ESCAPE:
					TreeView_EndEditLabelNow(hArbre,TRUE);
					break;
				case IDM_APROPOS:
//					MessageBox(hDlg,"GBA Graphics par Florian Brnnimann\nf_bron@hotmail.com, www.brunni.ch.vu\nCe programme peut tre distribu librement, la source galement. Cependant, si vous y aportez des amliorations, ce serait sympa de me les envoyer pour que tout le monde puisse en profiter.\nVous pouvez distribuer le programme modifi tant que vous n'enlevez pas mon nom et cette bote doit rester intacte.\nAmusez-vous bien! ;)","A propos",MB_ICONINFORMATION);
					MessageBox(hDlg,"GBA Graphics version "
						GBA_GRAPHICS_VERSION
						" par Florian Brnnimann (alias Brunni).\nf_bron@hotmail.com, http://gbagraphics.palib.info/\nCe programme est gratuit pour une utilisation non commerciale seulement (dans le cas inverse, veuillez me contacter).\nAmusez-vous bien! ;)","A propos",MB_ICONINFORMATION);
//					MessageBox(hDlg,"GBA Graphics par Florian Brnnimann\nf_bron@hotmail.com, www.brunni.ch.vu\nCe programme est sous license GPL (OpenSource). Vous pouvez me faire part de vos impressions et/ou modifications du prog par e-mail.\nAmusez-vous bien! ;-)","A propos",MB_ICONINFORMATION);
					break;
				case IDM_AIDE:
					sprintf(str, "%s\\help.chm", cExePath);
					ShellExecute(hDlg, NULL, str, NULL, NULL, SW_SHOWNORMAL);
					break;
				case IDM_AIDEPERSO:
					AidePerso();
					break;
				case IDM_COULEURS:
//					DialogBox(hInst,(LPCTSTR)IDD_COULEURS,hDlg,(DLGPROC)DlgCouleurs);
					DialogBox(hInst,(LPCTSTR)IDD_OPTIONSGENERALESONGLETS,hDlg,(DLGPROC)DlgOptionsGeneralesOnglets);
					break;
				case IDM_FORMAT:
					DialogBox(hInst,(LPCTSTR)IDD_FORMAT,hDlg,(DLGPROC)DlgFormats);
					break;

				case IDM_PLATFORMS:
					DialogBox(hInst,(LPCTSTR)IDD_PLATFORMS,hDlg,(DLGPROC)DlgPlateformes);
					break;

				case IDM_SHIFTTAB:
					//Gre la touche tabulation
					SendMessage(hDlg,WM_NEXTDLGCTL,TRUE,FALSE);
					break;
				case IDM_TAB:
					//Gre la touche tabulation
					SendMessage(hDlg,WM_NEXTDLGCTL,FALSE,FALSE);
					break;
				case IDM_QUITTER:
					if (editeurOuvert)
						break;
					OuvreFichierConfig(fichierConfigAOuvrir,"onquit");
					if (!retourScript)
						break;
					if (tooltip_nbreToolTips > 0)
						Debug("ERREUR HYPER GRAVE!!!!");
					tooltip_DestroyTooltip();
					EndDialog(hDlg,0);
					PostQuitMessage(0);
					break;
				case IDM_ENTREE:
					//Essaie de valider la zone de saisie. S'il ne peut pas (pas en train
					//d'diter) on lance cela comme un appui du bouton Ok.
					if (TreeView_EndEditLabelNow(hArbre,FALSE))		{
						//Simuler l'appui sur le bouton Ok  n'importe quel moment avec la
						//touche Entre.
						GereBoutonInconnu(hDlg, (HWND)hBoutonOk);
					}
					break;
				case IDM_EXECUTER:
					DialogBox(hInst,(LPCTSTR)IDD_EXECUTER,hDlg,(DLGPROC)DlgExec);
					break;

				default:
					//Un bouton non-enregistr nous a envoy un message
					GereBoutonInconnu(hDlg, (HWND)lParam);
			}
			break;

		case UM_REFRESH:
			//Mise  jour de la fentre
			hti = TreeView_GetSelection(hArbre);
			DessFenetre(hDlg, hti);
			break;

		case WM_CLOSE:
			if (editeurOuvert)
				return TRUE;
			OuvreFichierConfig(fichierConfigAOuvrir,"onquit");
			if (!retourScript)
				break;
			VerifFichierProjetExiste(str);
			if (!(*str))
				break;
			SauveProjet(str);
			DestroyWindow(hDlg);
			Quitter=TRUE;
			PostQuitMessage(0);
			break;
	}
	return FALSE;
}

void nettoieProjetCourant()
{
	for (int i = nbreElements - 1; i >= 0; i--)		{
		if (!(elements[i].type & TYPE_DOSSIER))			{
			if (!FichierExiste(elements[i].nom_fichier))
				EffaceElement(i);
		}
	}

	refFile::cleanDeletedFiles();
}

