#include "main.h"

namespace refFile			{
	//Ne pas traduire
	const char COMMENT_STRING[] = "# GBA Graphics property reference index file version 1.0\n";
	//Utilise par getName
	char tempNameStr[MAX_PATH];

	void getName(char *destBuffer)			{
		int i;

		strcpy(destBuffer, fichierProjet);

		//Trouve le dernier '.'
		for (i = strlen(destBuffer) - 1;
			 i >= 0 && destBuffer[i] != '.';
			 i--);

		if (i >= 0)		{
			//Remplace l'extension par .ref.
			strcpy(destBuffer + i, ".ref");
		}
	//Traduction possible
	}

	FILE *openRefFile(const char *mode)
	{
		FILE *f;
		char fileName[MAX_PATH], commentString[sizeof(COMMENT_STRING)];

		getName(fileName);
		f = fopen(fileName, mode);

		if (f && mode[0] == 'r')
		{
			fgets(commentString, sizeof(COMMENT_STRING), f);
			rewind(f);
			if (strncmp(commentString, COMMENT_STRING, sizeof(COMMENT_STRING) - 2) != 0)
			{
				char newFileName[MAX_PATH];
				// Le fichier est incorrect! On va informer l'utilisateur et en faire une copie puis crer un nouveau fichier vierge.
				fclose(f);
				f = NULL;
				strcpy(newFileName, fileName);
				strcat(newFileName, ".bak");
				if (MoveFile(fileName, newFileName))
					MessageBox(gblHDlg, "Le fichier rfrence est incorrect et a t rinitialis. Le fichier d'origine a t renomm avec l'extension .bak.", "Avertissement", MB_ICONINFORMATION);
				else
					MessageBox(gblHDlg, "Le fichier rfrence est incorrect mais il est impossible d'en faire une copie!", "Erreur", MB_ICONEXCLAMATION);
			}
		}

		return f;
	}

	int findSection(char *sectionName, char *fileBlock, int maxSize)		{
		char sectionSearched[MAX_PATH];
		int length;
		int offset = 0;

		sprintf(sectionSearched, "@%s@", sectionName);
		length = strlen(sectionSearched);

		//Parcourt le fichier  la recherche de la section
		while (offset < maxSize)		{
			//Trouv?
			if (!strncmp(fileBlock + offset, sectionSearched, length))
				return offset;

			//Trouve la fin de la ligne
			while (fileBlock[offset] != '\n' && offset < maxSize)
				offset++;

			if (offset < maxSize)		{
				if (fileBlock[offset] == '\n')
					offset++;
			}
		}

		return -1;
	}

	bool findSectionFile(char *sectionName, FILE *f)		{
		char sectionSearched[MAX_PATH];
		int length;
		int offset = 0;
		char line[MAX_PATH * 2];

		sprintf(sectionSearched, "@%s@", sectionName);
		length = strlen(sectionSearched);

		//Parcourt le fichier  la recherche de la section
		rewind(f);
		while (1)		{
			//Lit une ligne
			fgets(line, sizeof(line), f);
			if (feof(f))
				return false;

			//Trouv?
			if (!strncmp(line, sectionSearched, length))
				return true;
		}
	}

	int nextLine(char *fileBlock, int offset, int maxSize)		{
		//Trouve la prochaine ligne
		while (fileBlock[offset] != '\n' && offset < maxSize)
			offset++;
		//C'est un '\n' => sauter
		if (offset < maxSize)
			offset++;
		return offset;
	}

	int findNextSection(char *fileBlock, int offset, int maxSize)			{
		while (offset < maxSize - 1)		{
			int offsetDebut = offset;

			//@ en dbut de ligne: c'est peut tre un label?
			if (fileBlock[offset] == '@')		{
				offset++;
				//Jusqu' la fin de la ligne pour un autre @
				while ( fileBlock[offset] != '\n' &&
						fileBlock[offset] != '@' &&
						offset < maxSize)
					offset++;

				//Un autre @ a t trouv
				if (fileBlock[offset] == '@')		{
					offset++;
					//Vrifions qu'il est bien  la fin de la ligne
/*					while (fileBlock[offset] != '\n')		{
						//S'il n'y a pas que des espaces aprs le label, a ne marche pas
						if (fileBlock[offset] != ' ' && fileBlock[offset] != '	')
							break;
					}*/
					if (fileBlock[offset] == '\n')		{
/*						offset--;
						//Retour au dbut de la ligne
						while (offset >= 0 && fileBlock[offset] != '\n')
							offset--;
						offset++;
						return offset;*/
						return offsetDebut;
					}
				}
			}

			//Prochaine ligne
			while (fileBlock[offset] != '\n' && offset < maxSize)
				offset++;
			if (offset < maxSize)
				offset++;
		}
		return -1;
	}

	void readSectionFiltree(char *chaine, ELEMENT *e)		{
		char *fileBlock = NULL;
		int fileBlockSize = -1;
		char sectionName[MAX_PATH];
		FILE *f;
		int offset;

		//Si la chane est vide, rien  faire
		if (!chaine[0])
			return;

		//Nom de la section
		sprintf(sectionName, "%s", /*types_en[e->type],*/ e->nom_fichier);

		//Ouvre le fichier rfrence
		f = openRefFile("rb");

		if (f)		{
			//Rcupre la taille
			fseek(f, 0, SEEK_END);
			fileBlockSize = ftell(f);
			rewind(f);

			//Alloue un gros bloc pour y placer tout le contenu du fichier
			fileBlock = (char*)malloc(fileBlockSize + 1);
			if (fileBlock)			{
				fileBlockSize = fread(fileBlock, 1, fileBlockSize, f);
				fileBlock[fileBlockSize] = 0;

				//Cherche la section
				offset = findSection(sectionName, fileBlock, fileBlockSize);

				//Trouve?
				if (offset >= 0)		{
					int end;
					offset = nextLine(fileBlock, offset, fileBlockSize);

					//Lit jusqu' la prochaine section
					end = findNextSection(fileBlock, offset, fileBlockSize);
					if (end < 0)
						end = fileBlockSize;
					LitChaineFiltree(offset, fileBlock, chaine, end);
				}

			}
			fclose(f);
		}
	}

	void writeSectionFiltree(char *chaine, ELEMENT *e)		{
		FILE *f;
		char sectionName[MAX_PATH];
		char *fileBlock = NULL;
		int fileBlockSize = -1;
		int avantSection = -1, apresSection = -1;
		int offset;

		//Si la chane est vide, rien  faire
		if (!chaine[0])
			return;

		//Nom de la section
		sprintf(sectionName, "%s", /*types_en[e->type],*/ e->nom_fichier);

		//Ouvre le fichier pour tenter d'y trouver la section
		f = openRefFile("rt");

		if (f)		{
			//Rcupre la taille
			fseek(f, 0, SEEK_END);
			fileBlockSize = ftell(f);
			rewind(f);

			//Alloue un gros bloc pour y placer tout le contenu du fichier
			fileBlock = (char*)malloc(fileBlockSize + 1);
			if (fileBlock)			{
				fileBlockSize = fread(fileBlock, 1, fileBlockSize, f);
				fileBlock[fileBlockSize] = 0;

				//Cherche la section
				offset = findSection(sectionName, fileBlock, fileBlockSize);
				if (offset >= 0)		{
					//Stocke le dbut de la section
					avantSection = offset;

					//Saute l'en-tte
					offset = nextLine(fileBlock, offset, fileBlockSize);

					//Trouve la section qui vient aprs
					apresSection = findNextSection(fileBlock, offset, fileBlockSize);

					//Si on n'a pas de section aprs (-1) ce n'est pas grave
				}
				else
					avantSection = fileBlockSize;
			}

			fclose(f);
		}

		//Ouvre le fichier rfrence pour crire la chane filtre
		f = openRefFile("wt");

		if (f)		{
			// Le fichier tait vide: on le cre initialement
			if (avantSection < 0 && apresSection < 0)
				fputs(COMMENT_STRING, f);

			//Ecrit ce qu'il y avait avant dans le fichier
			if (avantSection > 0)
				fwrite(fileBlock, 1, avantSection, f);

			//Ajoute le nom de la section
			fprintf(f, "@%s@\n", sectionName);
			//Ecrit les donnes de la section
			fputc(' ', f);
			EcritChaineFiltree(chaine, f, false);
			fputc('\n', f);

			//Ecrit ce qu'il y avait aprs dans le fichier
			if (apresSection > 0)
				fwrite(fileBlock + apresSection, 1, fileBlockSize - apresSection, f);
			
			fclose(f);
		}

		//Libre les ressources
		if (fileBlock)
			free(fileBlock);
	}

	//Ne pas traduire
	void reworkSection(REWORK_TYPE wt, char *curSection, char *newSection)
	{
		FILE *f;
		char sectionName[MAX_PATH], newSectionName[MAX_PATH];
		char *fileBlock = NULL;
		int fileBlockSize = -1;
		int avantSection = -1, apresSection = -1;
		int offset;

		//Nom de la section
		sprintf(sectionName, "%s", curSection);

		//Ouvre le fichier pour tenter d'y trouver la section
		f = openRefFile("rt");

		if (f)		{
			//Rcupre la taille
			fseek(f, 0, SEEK_END);
			fileBlockSize = ftell(f);
			rewind(f);

			//Alloue un gros bloc pour y placer tout le contenu du fichier
			fileBlock = (char*)malloc(fileBlockSize + 1);
			if (fileBlock)			{
				fileBlockSize = fread(fileBlock, 1, fileBlockSize, f);
				fileBlock[fileBlockSize] = 0;

				//Cherche la section
				offset = findSection(sectionName, fileBlock, fileBlockSize);
				if (offset >= 0)		{
					//Stocke le dbut de la section
					avantSection = offset;

					//Saute l'en-tte
					offset = nextLine(fileBlock, offset, fileBlockSize);

					//Trouve la section qui vient aprs
					apresSection = findNextSection(fileBlock, offset, fileBlockSize);

					//S'assure de ne pas dpasser de la fin du fichier
					if (apresSection < 0)
						apresSection = fileBlockSize;
				}
				else
					avantSection = fileBlockSize;
			}

			fclose(f);
		}

		//Ouvre le fichier rfrence pour crire la chane filtre
		f = openRefFile("wt");

		if (f)		{
			// Le fichier tait vide: on le cre initialement
			if (avantSection < 0 && apresSection < 0)
				fputs("# GBA Graphics reference index file version 1.0\n", f);

			//Ecrit ce qu'il y avait avant dans le fichier
			if (avantSection > 0)
				fwrite(fileBlock, 1, avantSection, f);

			if (newSection)
				sprintf(newSectionName, "%s", newSection);
			else if (wt != deleteSection)
				MessageBox(gblHDlg, "reworkSection(deleteSection): the newSection parameter is null!", "Serious error", MB_ICONEXCLAMATION);

			switch (wt)
			{
				case renameSection:
					// Ajoute le nom de la section
					fprintf(f, "@%s@\n", newSectionName);
					// Reprend la mme section
					fwrite(fileBlock + offset, 1, apresSection - offset, f);
					break;

				case copySection:
					// Ajoute la section originale
					fprintf(f, "@%s@\n", sectionName);
					fwrite(fileBlock + offset, 1, apresSection - offset, f);
					// Ajoute la nouvelle section
					fprintf(f, "@%s@\n", newSectionName);
					fwrite(fileBlock + offset, 1, apresSection - offset, f);
					break;

				case deleteSection:
					// Do nothing...
					break;
			}

			//Ecrit ce qu'il y avait aprs dans le fichier
			if (apresSection > 0)
				fwrite(fileBlock + apresSection, 1, fileBlockSize - apresSection, f);
			
			fclose(f);
		}

		//Libre les ressources
		if (fileBlock)
			free(fileBlock);
	}
	//Traduction possible

	void cleanDeletedFiles()
	{
		FILE *f;
		char *fileBlock = NULL;
		int fileBlockSize = -1;
		int avantSection = -1, apresSection = -1;
		int offset = 0;

		//Ouvre le fichier pour tenter d'y trouver la section
		f = openRefFile("rt");

		if (f)		{
			//Rcupre la taille
			fseek(f, 0, SEEK_END);
			fileBlockSize = ftell(f);
			rewind(f);

			//Alloue un gros bloc pour y placer tout le contenu du fichier
			fileBlock = (char*)malloc(fileBlockSize + 1);
			if (fileBlock)			{
				fileBlockSize = fread(fileBlock, 1, fileBlockSize, f);
				fileBlock[fileBlockSize] = 0;

				// Parcourt le fichier  la recherche de la section
				while (offset < fileBlockSize)		{
					char curLine[MAX_PATH];
					int indexLine = 0;

					if (fileBlock[offset] == '@')
					{
						offset++;
						// Copie jusqu' la fin de la ligne
						while (indexLine < numberof(curLine) && fileBlock[offset] != '\n' && offset < fileBlockSize)
							curLine[indexLine++] = fileBlock[offset++];
						curLine[indexLine] = 0;

						if (curLine[indexLine - 1] == '@')
						{
							curLine[indexLine - 1] = 0;
							// On a le nom du fichier de la section, s'il n'existe pas on le supprime
							if (!FichierExiste(curLine))
								reworkSection(deleteSection, curLine);
						}
						else
							// Il y a une erreur: pas de @ en fin de ligne
							continue;
					}
					else
					{
						// Va  la prochaine ligne
						while (fileBlock[offset] != '\n' && offset < fileBlockSize)
							offset++;
					}

					if (offset < fileBlockSize)
						if (fileBlock[offset] == '\n')
							offset++;
				}
			}
		}
	}
};
