#include "main.h"
#include "supportDpi.h"

namespace PluginPropertiesWindow
{
	DLGPROC dpHandler;
	HWND hParent = NULL;
	int bExit;
	int sizeX, sizeY, nFlags;
	RECT rt;
	POINT pt;

	LRESULT CALLBACK Handler(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)		{
		static int isCapturing;
		int bFromLClick = 0;

		dpHandler(hDlg, message, wParam, lParam);
		switch (message)
		{
			case WM_INITDIALOG:
				RECT rtParent, rtCurrent, rtDesktop, rtClient;
				int diffX, diffY;
				HMONITOR hMonitor;
				MONITORINFO mi;

				//Pour placer correctement, comme un menu
				hMonitor = MonitorFromWindow(hParent, MONITOR_DEFAULTTONEAREST);
				mi.cbSize = sizeof(mi);
				GetMonitorInfo(hMonitor, &mi);
				//Espace de travail (sans la barre des tches)
//				rtDesktop = mi.rcWork;
				//Ecran complet (avec HWND_TOPMOST)
				rtDesktop = mi.rcMonitor;

				GetWindowRect(hParent, &rtParent);
				GetWindowRect(hDlg, &rtCurrent);
				GetClientRect(hDlg, &rtClient);
				//Diffrence de taille relle / cliente
				diffX = ABS((rtCurrent.right - rtCurrent.left) - (rtClient.right - rtClient.left));
				diffY = ABS((rtCurrent.bottom - rtCurrent.top) - (rtClient.bottom - rtClient.top));
				//Trop  droite
				if (rtParent.left + sizeX + diffX >= rtDesktop.right)
					rtParent.left -= sizeX + diffX - (rtParent.right - rtParent.left);
				//Trop bas
				if (rtParent.bottom + sizeY + diffY >= rtDesktop.bottom)
					rtParent.bottom -= sizeY + diffY + (rtParent.bottom - rtParent.top);

				SetWindowPos(hDlg, HWND_TOPMOST, rtParent.left, rtParent.bottom, sizeX + diffX, sizeY + diffY, 0);

				AnimateWindow(hDlg, 150, AW_BLEND);
				SetTimer(hDlg, 189, 10, NULL);

				isCapturing = 0;
				return TRUE;

			case WM_TIMER:
				int shouldCapture;
				GetWindowRect(hDlg, &rt);
				GetCursorPos(&pt);
				if (PtInRect(&rt, pt))
					shouldCapture = 0;
				else
					shouldCapture = 1;
				if (shouldCapture != isCapturing)			{
					if (shouldCapture)		{
						if (!GetCapture())
							SetCapture(hDlg);
					}
					else		{
						if (GetCapture() == hDlg)
							ReleaseCapture();
					}
					isCapturing = shouldCapture;
				}
				break;

			case WM_LBUTTONDOWN:
				bFromLClick = 1;
				GetWindowRect(hDlg, &rt);
				GetCursorPos(&pt);
				if (!PtInRect(&rt, pt))
					goto quitter;
				break;

			case WM_CTLCOLORBTN:
			case WM_CTLCOLORSTATIC:
				SetBkMode((HDC)wParam, TRANSPARENT);
				return (LRESULT)GetSysColorBrush(COLOR_MENU);

			case WM_CTLCOLORDLG:
				return (LRESULT)GetSysColorBrush(COLOR_MENU);

			case WM_ACTIVATE:
				//Inactif -> loin
				if (LOWORD(wParam) == WA_INACTIVE && !bExit)		{
quitter:
				//Sauver ici

quitter_definitif:
					bExit = 1;
					ReleaseCapture();
					DestroyWindow(hDlg);
					//Remet le clic
					if (bFromLClick)
						mouse_event(MOUSEEVENTF_LEFTDOWN|MOUSEEVENTF_ABSOLUTE, pt.x, pt.y, 0, GetMessageExtraInfo());
				}
				break;

			case WM_COMMAND:
				if (LOWORD(wParam) == IDOK)
					goto quitter;
				else if (LOWORD(wParam) == IDCANCEL)
					goto quitter_definitif;
				break;
		}

		return FALSE;
	}

	void Create(int flags, int *cmode, int l, int h, DLGPROC handler)
	{
		HWND hWnd, hPrev;
		MSG msg;

		dpHandler = handler;
		bExit = 0;
		hPrev = GetFocus();
		sizeX = l;
		sizeY = h;
		nFlags = flags;
		
		hWnd = CreateDialog(hInst, (LPCTSTR)IDD_PLUGINEMPTY, gblHDlg, (DLGPROC)Handler);
		while (GetMessage(&msg, NULL, 0, 0) && !bExit)
		{
			if (msg.message == WM_KEYDOWN)			{
				if (msg.wParam == VK_RETURN || msg.wParam == VK_ESCAPE)
					SendMessage(hWnd, WM_COMMAND, IDOK, 0);
			}
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

		SetFocus(hPrev);
	}
}

// "Handler" pour la bote de dialogue
LRESULT CALLBACK DlgTiles(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int i,j;

	switch (message)
	{
		case WM_INITDIALOG:
			//Inscription des valeurs par dfaut dans les cases prvues  cet effet...
			sprintf(str,"%i",tileX);
			SetDlgItemText(hDlg,IDC_EDIT1,str);
			sprintf(str,"%i",tileY);
			SetDlgItemText(hDlg,IDC_EDIT2,str);
			return TRUE;

		case WM_COMMAND:

			//Bouton ok
			if (LOWORD(wParam) == IDOK) 
			{
				//Rcupration des valeurs et conversion en entiers
				GetDlgItemText(hDlg,IDC_EDIT1,str,sizeof(str));
				i=atoi(str);
				GetDlgItemText(hDlg,IDC_EDIT2,str,sizeof(str));
				j=atoi(str);
				//D'abord faire quelques tests pour vrifier s'il ne s'agit pas d'neries...
				if (i%8!=0 || j%8!=0)	{
					MessageBox(hDlg,"Les dimensions des blocs doivent tre multiple de 8 pour passer sur la GBA! ;-)","Oups...",MB_ICONERROR);
					break;
				}
				if (i<8 || j<8 || i>64 || j>64)	{
					MessageBox(hDlg,"La taille entre est trop petite ou trop grande,  vous de voir.\n8<=Taille(x;y)<=64","Oups...",MB_ICONERROR);
					break;
				}
				if ((i!=8 && i!=16 && i!=32 && i!=64) || (j!=8 && j!=16 && j!=32 && j!=64))	{
					if (MessageBox(hDlg,"Pour passer correctement sous l'diteur, la largeur et la hauteur doivent tre une de ces valeurs:\n8, 16, 32, 64.\nSi cette rgle n'est pas respecte, l'diteur intgr refusera d'ouvrir votre fichier, mais le rsultat sera tout de mme utilisable sur GBA (et encore, a dpend de la taille de la map).\ntes-vous sr(e) de vouloir utiliser ce format?","Oups...",MB_ICONEXCLAMATION|MB_YESNO|MB_DEFBUTTON2)==IDNO)
						break;
				}
				//Avertissement si on choisit un format plus grand que l'original
				if ((i>tileX || j>tileY) && editeurOuvert)		{
					if (MessageBox(hDlg,"D'une manire gnrale, si vous convertissez les tiles  un format plus grand que l'original, le rsultat sera faux, car les tiles n'ont pas t  la base arranges pour (ou bien elles ont t optimises).\ntes-vous sr(e) de vouloir utiliser ce format?","Oups...",MB_ICONEXCLAMATION|MB_YESNO|MB_DEFBUTTON2)==IDNO)
						break;
				}

				//Tests passs ;)
				tileX=i, tileY=j;
				sprintf(str,"%ix%i",i,j);
				SendMessage(hComboTiles,CB_DELETESTRING,3,0);
				SendMessage(hComboTiles,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)str);
				SendMessage(hComboTiles,CB_SETCURSEL,3,0);
				//Dialogue termin
				EndDialog(hDlg, IDOK);
				return TRUE;
			}

			//Bouton annuler
			if (LOWORD(wParam) == IDCANCEL)
			{
				EndDialog(hDlg, IDCANCEL);
				return TRUE;
			}

			break;
	}

    return FALSE;
}


// "Handler" pour la bote de dialogue
LRESULT CALLBACK DlgNouvDoss(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hCombo;
	int i;
	char nom[31], dossier[31];
	char str[1000];
	ELEMENT el;

	switch (message)
	{
		case WM_INITDIALOG:
			hCombo=GetDlgItem(hDlg,IDC_COMBO1);
			for (i=0;i<nbreDossiersBaseLang;i++)		{
				SendMessage(hCombo,CB_ADDSTRING,0,(LPARAM)noms_dossiers_base[i]);
			}
			for (i=0;i<nbreElements;i++)		{
				if (elements[i].type&TYPE_DOSSIER)
					SendMessage(hCombo,CB_ADDSTRING,0,(LPARAM)elements[i].nom_court);
			}
			SendMessage(hCombo,CB_SETCURSEL,0,0);
			return TRUE;

		case WM_COMMAND:

			//Bouton ok
			if (LOWORD(wParam) == IDOK) 
			{
				GetDlgItemText(hDlg,IDC_EDIT1,nom,sizeof(nom));
				GetDlgItemText(hDlg,IDC_COMBO1,dossier,sizeof(dossier));
				for (i=0;i<nbreElements;i++)		{
					if (elements[i].type&TYPE_DOSSIER)
						if (!strcmp(elements[i].nom_court,nom))		{
							sprintf(str,"Ce nom de dossier existe dj dans le rpertoire %s.\nChoisissez-en un autre ou prcdez ce nom d'un autre puis d'un slash pour les diffrencier.\nPar exemple Rep1\\Test et Rep2\\Test sont tous deux affichs Test mais identifis diffremment.",elements[i].dossier);
							MessageBox(hDlg,str,"Erreur",MB_ICONERROR);
							return FALSE;
						}
				}
				strcpy(el.dossier,dossier);
				strcpy(el.nom_court,nom);
				el.type=DANS_DOSSIER|TYPE_DOSSIER;
				AjouteAuProjet(el);
				//Dialogue termin
				EndDialog(hDlg, IDOK);
				return TRUE;
			}

			//Bouton annuler
			if (LOWORD(wParam) == IDCANCEL)
			{
				EndDialog(hDlg, IDCANCEL);
				return TRUE;
			}

			break;
	}

    return FALSE;
}

LRESULT CALLBACK DlgExec(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)		{
	FILE *f;
	char str[10000], *ptr;
	static char *contenu=NULL;

	switch (message)
	{
		case WM_INITDIALOG:
			if (bInviteScriptContenuSauve)			{
				SetDlgItemText(hDlg, IDC_EDIT1, contenu);
				SendDlgItemMessage(hDlg, IDC_EDIT1, EM_SETSEL, 0, -1);
			}
			return TRUE;

		case WM_COMMAND:

			//Bouton ok
			if (LOWORD(wParam) == IDOK) 
			{
				GetDlgItemText(hDlg,IDC_EDIT1,str,sizeof(str));

				//Sauvegarde le contenu
				if (!bInviteScriptContenuSauve)
					contenu = (char*)malloc(sizeof(str));
				bInviteScriptContenuSauve=1;
				strcpy(contenu, str);

				f=tmpfile();
				ptr=str;
				for (ptr=str;*ptr;ptr++)		{
					if (*ptr!='\r')
						fputc(*ptr,f);
				}
				fputs("\nFin\n\n\n\n",f);
				fseek(f,0,SEEK_SET);
				ExecScript(f,NULL, NULL);

				//Dialogue termin
				EndDialog(hDlg, IDOK);
				return TRUE;
			}

			//Bouton annuler
			if (LOWORD(wParam) == IDCANCEL)
			{
				EndDialog(hDlg, IDCANCEL);
				return TRUE;
			}

			break;
	}

    return FALSE;
}



LRESULT CALLBACK DlgLier(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)		{
	char str[1000], str2[1000];
	HWND hCombo;
	int i,j;

	switch (message)
	{
		case WM_INITDIALOG:
			hCombo=GetDlgItem(hDlg,IDC_COMBO1);
			for (i=0;i<nMaps;i++)		{
				sprintf(str,"%i = %s",i+1,ele_fond[i]->nom_court);
				SendMessage(hCombo,CB_ADDSTRING,0,(LPARAM)str);
			}
			strcpy(str2,"");
			for (i=0;liens[fondActif][i]!=LIEN_INVALIDE;i++)		{
				if (i==0)
					sprintf(str,"%i",liens[fondActif][i]+1);
				else
					sprintf(str,", %i",liens[fondActif][i]+1);
				strcat(str2,str);
			}
			SetDlgItemText(hDlg,IDC_EDIT1,str2);
			SetWindowText(hCombo,"(choisissez un fond)");
			return TRUE;

		case WM_COMMAND:

			if (HIWORD(wParam)==CBN_CLOSEUP)		{
				GetDlgItemText(hDlg,IDC_EDIT1,str,sizeof(str)-10);
				i=SendDlgItemMessage(hDlg,IDC_COMBO1,CB_GETCURSEL,0,0);
				if (i==CB_ERR)
					break;
				if (str[0]==0)
					sprintf(str2,"%i",i+1);
				else
					sprintf(str2,", %i",i+1);
				strcat(str,str2);
				SetDlgItemText(hDlg,IDC_EDIT1,str);
				break;
			}

			//Bouton ok
			if (LOWORD(wParam) == IDOK) 
			{
				GetDlgItemText(hDlg,IDC_EDIT1,str,sizeof(str));
				if (strlen(str)==0)
					sprintf(str, "%i", fondActif+1);
				//Initialise les liens -> chaque map pointe sur elle-mme :)
				for (j=0;liens[fondActif][j]!=LIEN_INVALIDE;j++)		{
					i=liens[fondActif][j];
					if (i!=fondActif)		{
						liens[i][0]=i;
						liens[i][1]=LIEN_INVALIDE;
					}
				}
				FctLieMap(str);

				//Dialogue termin
				EndDialog(hDlg, IDOK);
				return TRUE;
			}

			//Bouton annuler
			if (LOWORD(wParam) == IDCANCEL)
			{
				EndDialog(hDlg, IDCANCEL);
				return TRUE;
			}

			break;
	}

    return FALSE;
}



LRESULT CALLBACK DlgCouleurs(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)		{
	static CBoutonCouleur cBtClr;
	int nPos;
	double temp;
	unsigned char *ptr;
	static int maxNuances;
/*	unsigned char *ptr;
	char str[1000];
	static int posX=0, posY=0, selCouleur=0;
	int r,v,b,sel, nPos;
	double temp;
	LPDRAWITEMSTRUCT lpdis;
	HBRUSH hbr;
	HPEN hpen;
	HWND hBouton;
	RECT rect;
	POINT pt;
	static COLORREF couleurs[16];
	static CHOOSECOLOR cc=		{
		sizeof(CHOOSECOLOR),
		NULL,
		NULL,
		0,
		couleurs,
		CC_ANYCOLOR|CC_FULLOPEN|CC_RGBINIT,
		NULL,
		NULL,
		NULL
	};*/
	static COnglets *onglets;

	switch (message)
	{
		case WM_INITDIALOG:
			onglets = (COnglets*)lParam;

			//Nombre max de nuances
/*			maxNuances = 2;
			for (i=0;i<curPF->pfNumber;i++)			{
				maxNuances = max(maxNuances, 1 << curPF->pfList[i].pixel->rwidth);
				maxNuances = max(maxNuances, 1 << curPF->pfList[i].pixel->vwidth);
				maxNuances = max(maxNuances, 1 << curPF->pfList[i].pixel->bwidth);
			}*/
			//En fait toujours 256
			maxNuances = 256;

			SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_SETRANGEMAX,1,max((int)(100.0/GammaV),300));
			SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_SETPOS,1,(LPARAM)(100.0/GammaV));

			SendDlgItemMessage(hDlg,IDC_SLIDER2,TBM_SETRANGEMIN,1,-255);
			SendDlgItemMessage(hDlg,IDC_SLIDER2,TBM_SETRANGEMAX,1,255);
			SendDlgItemMessage(hDlg,IDC_SLIDER2,TBM_SETPOS,1,(LPARAM)AdditionV);

			SendDlgItemMessage(hDlg,IDC_SLIDER3,TBM_SETRANGEMIN,1,-255);
			SendDlgItemMessage(hDlg,IDC_SLIDER3,TBM_SETRANGEMAX,1,255);
			SendDlgItemMessage(hDlg,IDC_SLIDER3,TBM_SETPOS,1,(LPARAM)AlphaV);

			SendDlgItemMessage(hDlg,IDC_SLIDER4,TBM_SETRANGEMIN,1,2);
			SendDlgItemMessage(hDlg,IDC_SLIDER4,TBM_SETRANGEMAX,1,maxNuances);
			SendDlgItemMessage(hDlg,IDC_SLIDER4,TBM_SETPOS,1,(LPARAM)nuances+1);

			SendDlgItemMessage(hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM)"Standard");
			SendDlgItemMessage(hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM)"Tram");
			SendDlgItemMessage(hDlg,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM)"Optimal");
			SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,modeConversion,0);

//			SendDlgItemMessage(hDlg,IDC_CHECK1,BM_SETCHECK,(nuancesAvant?BST_CHECKED:BST_UNCHECKED),0);
			
			cBtClr.OnInit(GetDlgItem(hDlg, IDC_BOUTONCOULEUR));
			cBtClr.cc.rgbResult=RGB(rougeMasque,vertMasque,bleuMasque);

			SendMessage(hDlg,WM_HSCROLL,0,0);
/*			int i;
			i = GetWindowLong(GetDlgItem(hDlg, IDC_BOUTONCOULEUR), GWL_STYLE);
			SetWindowLong(GetDlgItem(hDlg, IDC_BOUTONCOULEUR), GWL_STYLE, i|WS_CHILD);*/
//			SetTimer(hDlg,1,20,NULL);
			return TRUE;

		case WM_SETCURSOR:
			cBtClr.OnSetCursor(hDlg, wParam);
			break;

		case WM_DRAWITEM:
			cBtClr.OnDrawItem(hDlg, lParam);
			break;

		case WM_HSCROLL:
			nPos = SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_GETPOS,0,0);
			sprintf(str,"%#.2f",nPos/100.0);
			SetDlgItemText(hDlg,IDC_EDIT1,str);

			nPos = SendDlgItemMessage(hDlg,IDC_SLIDER2,TBM_GETPOS,0,0);
			sprintf(str,"%i",nPos);
			SetDlgItemText(hDlg,IDC_EDIT2,str);

			nPos = SendDlgItemMessage(hDlg,IDC_SLIDER3,TBM_GETPOS,0,0);
			sprintf(str,"%i",nPos);
			SetDlgItemText(hDlg,IDC_EDIT3,str);

			nPos = SendDlgItemMessage(hDlg,IDC_SLIDER4,TBM_GETPOS,0,0);
			sprintf(str,"%i",nPos);
			SetDlgItemText(hDlg,IDC_EDIT4,str);

			break;

		case WM_SIZE:
			onglets->UpdateBackgroundBrush();
			break;

		case WM_CTLCOLORSTATIC:
			BOOL bHandled;
			return onglets->OnCtlColor(message, wParam, lParam, bHandled);

		case WM_ERASEBKGND:
			return TRUE;

		case WM_COMMAND:

			if (LOWORD(wParam) == IDC_AVANCE || LOWORD(wParam) == IDC_AVANCEFINI)		{
				SendMessage(GetParent(hDlg), message, wParam, lParam);
			}
			else if (LOWORD(wParam) == IDC_BOUTONCOULEUR)		{
				cBtClr.OnClick(hDlg);
			}
			else if (LOWORD(wParam) == IDC_BUTTON1)		{
				SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_SETRANGEMAX,1,300);
				SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_SETPOS,1,100);
				SendDlgItemMessage(hDlg,IDC_SLIDER2,TBM_SETPOS,1,0);
				SendDlgItemMessage(hDlg,IDC_SLIDER3,TBM_SETPOS,1,0);
				SendDlgItemMessage(hDlg,IDC_SLIDER4,TBM_SETPOS,1,maxNuances);
				SendDlgItemMessage(hDlg,IDC_COMBO1,CB_SETCURSEL,0,0);
//				SendDlgItemMessage(hDlg,IDC_CHECK1,BM_SETCHECK,BST_UNCHECKED,0);
				SendMessage(hDlg,WM_HSCROLL,0,0);
			}
			else if ((LOWORD(wParam)==IDC_EDIT1 || LOWORD(wParam)==IDC_EDIT2 || LOWORD(wParam)==IDC_EDIT3 || LOWORD(wParam)==IDC_EDIT4) && HIWORD(wParam)==EN_KILLFOCUS)		{
				GetDlgItemText(hDlg,IDC_EDIT1,str,sizeof(str));
				temp=atof(str);
				SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_SETRANGEMAX,1,max((int)(temp*100),300));
				SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_SETPOS,1,(LPARAM)(temp*100.0));

				GetDlgItemText(hDlg,IDC_EDIT2,str,sizeof(str));
				temp=atof(str);
				SendDlgItemMessage(hDlg,IDC_SLIDER2,TBM_SETPOS,1,(LPARAM)temp);

				GetDlgItemText(hDlg,IDC_EDIT3,str,sizeof(str));
				temp=atof(str);
				SendDlgItemMessage(hDlg,IDC_SLIDER3,TBM_SETPOS,1,(LPARAM)temp);

				GetDlgItemText(hDlg,IDC_EDIT4,str,sizeof(str));
				temp=atof(str);
				SendDlgItemMessage(hDlg,IDC_SLIDER4,TBM_SETPOS,1,(LPARAM)temp);
			}

			//Bouton ok
			else if (LOWORD(wParam) == IDOK) 
			{
				ptr=(unsigned char*)&cBtClr.cc.rgbResult;
				rougeMasque=*ptr++;
				vertMasque=*ptr++;
				bleuMasque=*ptr++;

				GetDlgItemText(hDlg,IDC_EDIT1,str,sizeof(str));
				temp=atof(str);
				if (temp>0)
					GammaB=GammaV=GammaR=1/temp;

				GetDlgItemText(hDlg,IDC_EDIT2,str,sizeof(str));
				temp=atoi(str);
				if (temp>=-255 && temp<=255)
					AdditionR=AdditionV=AdditionB=temp;

				GetDlgItemText(hDlg,IDC_EDIT3,str,sizeof(str));
				temp=atoi(str);
				if (temp>=-255 && temp<=255)
					AlphaR=AlphaV=AlphaB=temp;

				GetDlgItemText(hDlg,IDC_EDIT4,str,sizeof(str));
				temp=atoi(str);
				if (temp>=2 && temp<=maxNuances)
					nuances=(int)temp-1;
				else
					nuances = maxNuances;

				CreeCouleurs();

				modeConversion=SendDlgItemMessage(hDlg,IDC_COMBO1,CB_GETCURSEL,0,0);

				//Dialogue termin
				EndDialog(hDlg, IDOK);
				return TRUE;
			}

			//Bouton annuler
			else if (LOWORD(wParam) == IDCANCEL)
			{
				EndDialog(hDlg, IDCANCEL);
				return TRUE;
			}

			break;
	}

    return FALSE;
}



LRESULT CALLBACK DlgFormats(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)		{
	HWND hListe;
	int i;

	switch (message)
	{
		case WM_INITDIALOG:
			hListe=GetDlgItem(hDlg,IDC_LIST1);
			for (i=0;i<nb_sections;i++)
				SendMessage(hListe,LB_ADDSTRING,0,(LPARAM)formats[i].nom);
			for (i=0;i<nb_sections;i++)		{
				if (ptr_formatActuel==&formats[i])		{
					SendMessage(hListe, LB_SETCURSEL, i, 0);
				}
			}
			return TRUE;

		case WM_NOTIFY:
			break;

		case WM_COMMAND:


			if (LOWORD(wParam) == IDC_LIST1)			{
				if (HIWORD(wParam)==LBN_DBLCLK)
					goto ok;
			}

			//Bouton ok
			if (LOWORD(wParam) == IDOK) 
			{
ok:
				i=SendDlgItemMessage(hDlg,IDC_LIST1,LB_GETCURSEL,0,0);
				if (i==LB_ERR)
					break;
				DefFormat(&formats[i]);
				//Dialogue termin
				EndDialog(hDlg, IDOK);
				return TRUE;
			}

			//Bouton annuler
			if (LOWORD(wParam) == IDCANCEL)
			{
				EndDialog(hDlg, IDCANCEL);
				return TRUE;
			}

			break;
	}

    return FALSE;
}

/*static LRESULT CALLBACK DlgPlateformesListeWndProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	WNDPROC hParent;
	hParent = (WNDPROC)GetWindowLong(hDlg, GWL_USERDATA);
	switch (message)
	{
		case WM_RBUTTONUP:
			SendMessage(GetParent(hDlg), WM_COMMAND, IDC_PROPERTIES, 0);
			break;
	}
	return CallWindowProc (hParent, hDlg, message, wParam, lParam);
}*/

int fctPluginConfigureIsEnabled(PLATFORM_INFO *p, int flags, int cmode)
{
	if (p->fctPluginConfigure)			{
		if (p->fctPluginConfigure(flags|0x8000, &cmode))
			return 1;
	}
	return 0;
}


LRESULT CALLBACK DlgPlateformes(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)		{
	HWND hListe;
	int i;
	static WNDPROC hParentProc;

	switch (message)
	{
		case WM_INITDIALOG:
			hListe=GetDlgItem(hDlg,IDC_LIST1);
			for (i=0;i<nbrePlateformes;i++)
				SendMessage(hListe,LB_ADDSTRING,0,(LPARAM)plateformes[i].pName);
			for (i=0;i<nbrePlateformes;i++)		{
				if (curPF == &plateformes[i])		{
					SendMessage(hListe, LB_SETCURSEL, i, 0);
					EnableWindow(GetDlgItem(hDlg, IDC_PROPERTIES), fctPluginConfigureIsEnabled(&plateformes[i], 0x1000, -1));
				}
			}
/*			hParentProc = (WNDPROC) GetWindowLong (hListe, GWL_WNDPROC);
			SetWindowLong(hListe, GWL_WNDPROC, (LONG)DlgPlateformesListeWndProc);
			SetWindowLong(hListe, GWL_USERDATA, (LONG)hParentProc);*/
			return TRUE;

		case WM_NOTIFY:
			break;

		case WM_COMMAND:


			if (LOWORD(wParam) == IDC_LIST1)			{
				if (HIWORD(wParam)==LBN_SELCHANGE)		{
					i=SendDlgItemMessage(hDlg,IDC_LIST1,LB_GETCURSEL,0,0);
					if (i==LB_ERR)
						break;
					EnableWindow(GetDlgItem(hDlg, IDC_PROPERTIES), fctPluginConfigureIsEnabled(&plateformes[i], 0x1000, -1));
				}
				if (HIWORD(wParam)==LBN_DBLCLK)
					goto ok;
			}

			if (LOWORD(wParam) == IDC_PROPERTIES) 
			{
				int cmode = -1;
				PLATFORM_INFO *pf;
				i=SendDlgItemMessage(hDlg,IDC_LIST1,LB_GETCURSEL,0,0);
				if (i==LB_ERR)
					break;
				pf = &plateformes[i];
				PluginPropertiesWindow::hParent = GetDlgItem(hDlg, IDC_PROPERTIES);
				if (pf->fctPluginConfigure)
					pf->fctPluginConfigure(0x1000, &cmode);
			}

			//Bouton ok
			if (LOWORD(wParam) == IDOK) 
			{
ok:
				i=SendDlgItemMessage(hDlg,IDC_LIST1,LB_GETCURSEL,0,0);
				if (i==LB_ERR)
					break;
				DefPlateforme(&plateformes[i]);
				//Dialogue termin
				EndDialog(hDlg, IDOK);
				return TRUE;
			}

			//Bouton annuler
			if (LOWORD(wParam) == IDCANCEL)
			{
				EndDialog(hDlg, IDCANCEL);
				return TRUE;
			}

			break;
	}

    return FALSE;
}


void AppliqueMasque(int etat, unsigned long masque)		{
	int i,j,tmp;
	MAP (*bloc)[1024];
//	for (k=0;k<profondeurSel;k++)				{
//		bloc=blocCopie+1024*k;
		bloc=(MAP (*)[1024])BufferActif();
		if (bloc && CopieX && CopieY)		{
			for (j=0;j<CopieY;j++)		{
				for (i=0;i<CopieX;i++)		{
					tmp=bloc[j][i];
					if (tmp==masqueInvisible || (tmp==0 && bitsMasqueZero))
						continue;
					if (etat)
						tmp|=masque;
					else
						tmp&=~masque;
					bloc[j][i]=tmp;
				}
			}
		}
		else		{
			if (etat)
				motifChoisi |= masque;
			else
				motifChoisi &= ~masque;
			Console_Print("Motif: %i (%04x)", motifChoisi, motifChoisi);
		}
//	}
}


#define Set1Bit(controle,masque)		SendMessage(controle,BM_SETCHECK,(valeur&masque)?BST_CHECKED:BST_UNCHECKED,0);

void SetBits(int valeur)		{
	int i;
	if (!fenBits)
		return;

	for (i=0;i<NOMBRE_BITS;i++)		{
		if (hCtlBits[i])
			Set1Bit(hCtlBits[i], 1 << i);
	}
}

void Alloc_Bits()			{
	int i,j;
	if (!nomsBits)			{
		nomsBits=(char(*)[NOMBRE_BITS][TAILLE_MAX_CHAINES_GRID])malloc(TAILLE_MAX_CHAINES_GRID * NOMBRE_BITS * MAX_FONDS);
		for (i=0;i<NOMBRE_BITS;i++)
			strcpy(nomsBits[0][i], chneNomsDefautBits[i]);
		for (i=1;i<MAX_FONDS;i++)
			memcpy(&nomsBits[i], &nomsBits[0], sizeof(nomsBits[0]));
	}
	if (!bitsActives)			{
		bitsActives=(char(*)[NOMBRE_BITS])malloc(NOMBRE_BITS*MAX_FONDS);
		for (i=0;i<MAX_FONDS;i++)		{
			for (j=0;j<NOMBRE_BITS;j++)
				bitsActives[i][j]=0;
			for (j=10;j<=15;j++)
				bitsActives[i][j]=1;
		}
	}
}

void Dealloc_Bits()		{
	if (nomsBits)
		free(nomsBits);
	if (bitsActives)
		free(bitsActives);
	nomsBits=NULL;
	bitsActives=NULL;
}

BOOL IsAllocated_Bits()			{
	if (nomsBits && bitsActives)
		return TRUE;
	else
		return FALSE;
}

void BitsUpdate()
{
	//TODO: SAUVEGARDER LE CONTENU AVANT DE SUPPRIMER!!!
	int i, pos = 5;
	RECT rt, rtc, rtf;
	if (!IsAllocated_Bits())
		return;
	for (i=NOMBRE_BITS-1;i>=0;i--)		{
		if (hCtlBits[i])
			DestroyWindow(hCtlBits[i]);
		if (bitsActives[fondActif][i])			{
			//Existe dj?
			hCtlBits[i] = CreateWindow ("Button", "", WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX,
				10, pos, SIZEX_FEN(120), SIZEY_FEN(16), hDlgBits, NULL, hInst, NULL);
			SendMessage(hCtlBits[i], WM_SETFONT, (WPARAM)hFonte, MAKELPARAM(1, 0));
			SetWindowText(hCtlBits[i], nomsBits[fondActif][i]);
			EnableWindow(hCtlBits[i], bitsActives[fondActif][i]);
			pos += SIZEY_FEN(16);
		}
		else
			hCtlBits[i] = NULL;
	}
	pos += 5;
	//La fentre DOIT faire 120x120!
	GetWindowRect(hDlgBits, &rt);
	GetClientRect(hDlgBits, &rtc);
	rtf.left = rtf.top = 0;
	rtf.right = (rt.right - rt.left) + (SIZEX_FEN(130) - rtc.right);
	rtf.bottom = (rt.bottom - rt.top) + (pos - rtc.bottom);
	if (rtf.right != rt.right - rt.left || rtf.bottom != rt.bottom - rt.top)
		SetWindowPos(hDlgBits, HWND_TOP, rtf.left, rtf.top, rtf.right, rtf.bottom, SWP_NOMOVE|SWP_NOZORDER);
}


LRESULT CALLBACK DlgBits(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)		{
	int etat, i;
	MAP (*bloc)[1024];

	switch (message)
	{
		case WM_INITDIALOG:
			hDlgBits=hDlg;
			fenBits=1;

			Alloc_Bits();
			BitsUpdate();

			bloc=(MAP (*)[1024])BufferActif();
			if (bloc)
				SetBits(bloc[0][0]);
			else
				SetBits(motifChoisi);
			return TRUE;

		case WM_COMMAND:
			for (i=0;i<NOMBRE_BITS;i++)			{
				if ((HWND)lParam == hCtlBits[i])		{
					etat = SendMessage(hCtlBits[i], BM_GETCHECK, 0, 0);
					AppliqueMasque(etat, 1 << i);
				}
			}
			//Bouton annuler
			if (LOWORD(wParam) == IDCANCEL)
			{
				ShowWindow(hDlg,SW_HIDE);
				return TRUE;
			}

			break;
	}

    return FALSE;
}

int GetParamOffset(int nParam)		{
	SD_PARAMS *sdp=&sdParams[gblSdModele];
	int i, r;
	r=0;
	for (i=0;i<nParam;i++)		{
		r += sdp->sdTaillesParam[i];
	}
	return r;
}

char *ExtraitNomParam(char *nom)		{
	char *lastS, *ptr;
	strcpy(str, nom);
	ptr=str;
	lastS=ptr;
	while(*ptr!='>' && *ptr)		{
		if (*ptr=='<')
			lastS=ptr+1;
		ptr++;
	}
	*ptr=0;
	return lastS;
}

LRESULT CALLBACK DlgAttributs(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)		{
	static HWND hStatics[MAX_SD], hTextes[MAX_SD];
	int i, j, nElement, nbreEls;
	char str[MAX_PATH];
	int *ptr;
	SD_PARAMS *sdp=&sdParams[gblSdModele];

	switch (message)
	{
		case WM_INITDIALOG:
			if (sdp->sdNumParams<=0)		{
				MessageBox(hDlg, "Vous devez d'abord dfinir des proprits pour l'objet avant de pouvoir les diter!", "Erreur", MB_ICONEXCLAMATION);
				EndDialog(hDlg, -1);
				break;
			}

			//Premier lment de la slection multiple
			if (lstSelMulNbre)
				nElement = lstSelMulListe[0];
			else
				nElement = listeSelection;

			for (i=0;i<sdp->sdNumParams;i++)			{
				sprintf(str," %s", ExtraitNomParam(sdp->sdNomsParams[i]));
				hStatics[i]=CreateWindow ("Static", str, WS_BORDER | WS_CHILD | WS_VISIBLE,
					6,10+i*20,100,18, hDlg, NULL, hInst, NULL);

				if (sdp->sdTypeParam[i]==SDT_ENTIER)			{
					ptr= (int*)((char*)(_SD(gblSpriteListe,nElement))->params+GetParamOffset(i));
					sprintf(str,"%i",(int)*ptr);
				}
				else if (sdp->sdTypeParam[i]==SDT_BRUT)			{
					char *cptr;
					cptr=(char*)(_SD(gblSpriteListe,nElement))->params+GetParamOffset(i);
					strcpy(str, cptr);
				}
				hTextes[i]=CreateWindow ("Edit", str, WS_BORDER | WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_TABSTOP,
					120,10+i*20,100,18, hDlg, NULL, hInst, NULL);
			}
			RECT r1, r2;
			GetWindowRect(hDlg, &r1);
			GetClientRect(hDlg, &r2);
			SetWindowPos(hDlg, HWND_TOP, 0, 0, 230+((r1.right-r1.left)-(r2.right-r2.left)), 38+(i-1)*20+((r1.bottom-r1.top)-(r2.bottom-r2.top)), SWP_NOZORDER|SWP_NOMOVE);
			return TRUE;

		case WM_COMMAND:
			//Bouton ok
			if (LOWORD(wParam) == IDOK) 
			{
				if (lstSelMulNbre)
					nbreEls = lstSelMulNbre;
				else
					nbreEls = 1;

				//Support slection multiple
				for (j=0;j<nbreEls;j++)		{
					if (lstSelMulNbre)
						nElement = lstSelMulListe[j];
					else
						nElement = listeSelection;
					for (i=0;i<sdp->sdNumParams;i++)			{
						if (sdp->sdTypeParam[i]==SDT_ENTIER)		{
							GetWindowText(hTextes[i],str,MAX_PATH);
							ptr= (int*)((char*)(_SD(gblSpriteListe,nElement))->params+GetParamOffset(i));
							*ptr=GetEntier(str);
						}
						else if (sdp->sdTypeParam[i]==SDT_BRUT)			{
							char *cptr;
							GetWindowText(hTextes[i],str,MAX_PATH);
							cptr=(char*)(_SD(gblSpriteListe,nElement))->params+GetParamOffset(i);
							str[GetParamOffset(i+1)-GetParamOffset(i)-1]=0;
							strcpy(cptr, str);
						}
					}
				}
				//Dialogue termin
				EndDialog(hDlg, IDOK);
				return TRUE;
			}

			//Bouton annuler
			if (LOWORD(wParam) == IDCANCEL)
			{
				EndDialog(hDlg, IDCANCEL);
				return TRUE;
			}

			break;
	}

    return FALSE;
}

LRESULT CALLBACK DlgAttributsElement(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)		{
	static int noElement;
	int i, j, nTrouve;
	char *texte;
	BOOL bMajListeRequise;
	HWND hCombo;
	int *lookupTable = (int*)alloca(sizeof(int) * types_numberof);		// alloca sur GCC
	char tempTypes[1000];

	switch (message)
	{
		case WM_INITDIALOG:
			noElement = lParam;						//Pass en paramtre
			Dialog_SetText(hDlg, IDC_EDIT1, elements[noElement].nom_fichier);
			Dialog_SetText(hDlg, IDC_EDIT2, elements[noElement].nom_base);
			Dialog_SetText(hDlg, IDC_EDIT3, elements[noElement].nom_court);
			if (!(elements[noElement].type & DANS_DOSSIER))
				strcpy(elements[noElement].dossier, "");
			Dialog_SetText(hDlg, IDC_EDIT4, elements[noElement].dossier);
			j=0;
			for (i=0;i<types_numberof;i++)			{
				lookupTable[i]=j;
				if (i!=0 && i!=TYPE_SPRITE)			{
					Combo_AddItem(hDlg, IDC_COMBO1, types_all[i]);
					j++;
				}
			}
			Combo_SetValue(hDlg, IDC_COMBO1, lookupTable[elements[noElement].type&MASQUE_TYPE]);

			//Dossiers
			hCombo=GetDlgItem(hDlg,IDC_COMBO3);
			nTrouve = 0;
			SendMessage(hCombo,CB_ADDSTRING,0,(LPARAM)"(Aucun)");
			j = 1;
			for (i=0;i<nbreElements;i++)		{
				if (elements[i].type&TYPE_DOSSIER)			{
					SendMessage(hCombo,CB_ADDSTRING,0,(LPARAM)elements[i].nom_court);
					if (!strcmp(elements[i].nom_court, elements[noElement].dossier))
						nTrouve = j;
					j++;
				}
			}
			SendMessage(hCombo,CB_SETCURSEL, nTrouve, 0);

			sprintf(str, "Proprits de %s", elements[noElement].nom_court);
			SetWindowText(hDlg, str);
			return TRUE;

		case WM_COMMAND:

			if (LOWORD(wParam) == IDC_BUTTON1)			{
				sprintf(tempTypes, "%cFichiers GBA Graphics%c*%s;*%s;*%s;*%s;*%s%c%c",1,0, bmp_def_ext, pal_def_ext, til_def_ext, map_def_ext, lst_def_ext,0,0);
				strcpy(str, "");
				if (SauveFichier(str, tempTypes))
					SetDlgItemText(hDlg,IDC_EDIT1, CreeNomRelatif(str));
			}
			if (LOWORD(wParam) == IDC_BUTTON6)			{
				strcpy(str, "");
				if (OuvreFichier(str,"\1Tous les fichiers\0*.*\0\0"))
					SetDlgItemText(hDlg,IDC_EDIT2, CreeNomRelatif(str));
			}

			if (LOWORD(wParam) == IDC_BUTTON7)			{
				i = IsWindowEnabled(GetDlgItem(hDlg, IDC_COMBO1));
				if (!i)		{
					j = MessageBox(hDlg, "Vous pouvez modifier le type de fichier, mais ceci est compltement dconseill. Vous ne devriez le faire que si vous tes absolument sr de vous.\nVoulez-vous vraiment modifier le type de fichier?", "Avertissement", MB_ICONEXCLAMATION|MB_OKCANCEL|MB_DEFBUTTON2);
					if (j!=IDOK)
						break;
					EnableWindow(GetDlgItem(hDlg, IDC_COMBO1), TRUE);
					EnableWindow(GetDlgItem(hDlg, IDC_BUTTON7), FALSE);
				}
//				else
//					EnableWindow(GetDlgItem(hDlg, IDC_COMBO1), FALSE);
			}

			//Bouton ok
			if (LOWORD(wParam) == IDOK)
			{
				bMajListeRequise = FALSE;

				texte = Dialog_GetText(hDlg, IDC_EDIT1);
				if (strcmp(texte, elements[noElement].nom_fichier))				{
					if (!FichierExiste(texte) && FichierExiste(elements[noElement].nom_fichier))				{
						for (i=0;i<nbreElements;i++)		{
							if (!strcmp(elements[i].nom_fichier, elements[noElement].nom_fichier) && i!=noElement)
								break;
						}
						//Il est dj utilis ailleurs?
						if (i<nbreElements)
						{
							if (CopyFile(elements[noElement].nom_fichier, texte, TRUE))
								refFile::reworkSection(refFile::copySection, elements[noElement].nom_fichier, texte);
						}
						else
						{
							if (MoveFile(elements[noElement].nom_fichier, texte))
								refFile::reworkSection(refFile::renameSection, elements[noElement].nom_fichier, texte);
						}
					}
					else if (FichierExiste(elements[noElement].nom_fichier))		{
						for (i=0;i<nbreElements;i++)		{
							if (!strcmp(elements[i].nom_fichier, elements[noElement].nom_fichier) && i!=noElement)
								break;
						}
						if (i>=nbreElements)		{
							j = fMsgBox(hDlg, "Question", MB_ICONQUESTION|MB_YESNOCANCEL|MB_DEFBUTTON3, "Le fichier actuel (%s) ne sera plus utilis du tout dans le projet, voulez-vous le supprimer?", elements[noElement].nom_fichier);
							if (j==IDCANCEL)
								break;
							if (j==IDYES)
								EffaceVersCorbeille(elements[noElement].nom_fichier);
						}
					}
					strcpy(elements[noElement].nom_fichier, texte);
				}

				texte = Dialog_GetText(hDlg, IDC_EDIT2);
				if (strcmp(texte, elements[noElement].nom_base))
					strcpy(elements[noElement].nom_base, texte);

				texte = Dialog_GetText(hDlg, IDC_EDIT3);
				if (strcmp(texte, elements[noElement].nom_court))			{
					strcpy(elements[noElement].nom_court, texte);
					bMajListeRequise = TRUE;
				}

				texte = Dialog_GetText(hDlg, IDC_COMBO3);
				i = Combo_GetValue(hDlg, IDC_COMBO3);
				if ((i!=0 && strcmp(texte, elements[noElement].dossier)) || (i==0 && elements[noElement].dossier[0]))			{
					if (i > 0)
						elements[noElement].type |= DANS_DOSSIER;
					else
						elements[noElement].type &= ~DANS_DOSSIER;
					strcpy(elements[noElement].dossier, texte);
					bMajListeRequise = TRUE;
				}

				texte = Dialog_GetText(hDlg, IDC_COMBO1);
				i = -1;
				for (j=0;j<types_numberof;j++)			{
					if (!strcmp(types_fr[j], texte) || !strcmp(types_en[j], texte))
						i = j;
				}

				if (i!=(elements[noElement].type&MASQUE_TYPE) && i>=0)			{
					elements[noElement].type &= ~MASQUE_TYPE;
					elements[noElement].type |= i;
					bMajListeRequise = TRUE;
				}

				if (bMajListeRequise)			{
					EffaceElementArbre(noElement);
					AjouteElementArbre(noElement);
//					MajListe(gblHDlg);
				}

				//Dialogue termin
				EndDialog(hDlg, IDOK);
				return TRUE;
			}

			//Bouton annuler
			if (LOWORD(wParam) == IDCANCEL)
			{
				EndDialog(hDlg, IDCANCEL);
				return TRUE;
			}
			break;
	}
    return FALSE;
}


LRESULT CALLBACK DlgOptionsTileset(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)		{
	//Ne pas traduire
	static HWND hStatic, hCombo;
	char *defaultSizes[]=		{
		"256",
		"512",
		"1024",
		"2048",
		"4096",
	};
	int i;
	//Traduction possible

	switch (message)
	{
		case WM_INITDIALOG:
			//Pour choisir la taille...
			hStatic = CreateWindow ("Static", "Largeur", WS_CHILD | WS_VISIBLE,
				10, 9, 300, 18, hDlg, NULL, hInst, NULL);
			hCombo = CreateWindow("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWN | WS_TABSTOP,
				55, 5, 60, 180, hDlg, NULL, hInst, NULL);

			for (i=0;i<numberof(defaultSizes);i++)
				SendMessage(hCombo, CB_ADDSTRING, 0, (LPARAM)defaultSizes[i]);
			Dialog_SetInt(hCombo, 0, gnTilesetWidth);
			break;

		case WM_DESTROY:
			i = Dialog_GetInt(hCombo, 0);
			if (i >= 8)
				gnTilesetWidth = i;
			break;
	}
	return FALSE;
}

LRESULT CALLBACK DlgOptionsPalette(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)		{
	//Ne pas traduire
	static HWND hStatic, hCombo;
	char *defaultSizes[]=		{
		"4",
		"16",
		"256",
	};
	int i;
	//Traduction possible

	switch (message)
	{
		case WM_INITDIALOG:
			//Pour choisir la taille...
			hStatic = CreateWindow ("Static", "Largeur", WS_CHILD | WS_VISIBLE,
				10, 9, 300, 18, hDlg, NULL, hInst, NULL);
			hCombo = CreateWindow("ComboBox", "",WS_CHILD | WS_VISIBLE | CBS_DROPDOWN | WS_TABSTOP,
				55, 5, 60, 180, hDlg, NULL, hInst, NULL);

			for (i=0;i<numberof(defaultSizes);i++)
				SendMessage(hCombo, CB_ADDSTRING, 0, (LPARAM)defaultSizes[i]);
			Dialog_SetInt(hCombo, 0, gnPaletteWidth);
			break;

		case WM_DESTROY:
			i = Dialog_GetInt(hCombo, 0);
			if (i > 0)
				gnPaletteWidth = i;
			break;
	}
	return FALSE;
}

