//Copie une structure de type lment, dont la source et la destination sont passes par valeur
#define CopieElement(destination,source)		memcpy(&(destination),&(source),sizeof(ELEMENT))
void DessFenetre(HWND hDlg, HANDLE hItem);
LRESULT CALLBACK DlgImport(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void MajBoutons(HWND hBt);
void GereBoutonInconnu(HWND hDlg, HWND hCtrl);
int OuvreFichierConfig(char *nom_fichier, char *fonction);
char *CreeNomRelatif(char *nom_srce);
bool gdipPalettesIdentical(unsigned char *palette, int count, int nCoulMax);
int gdipCalcPalette(unsigned long *tableau, unsigned char *palette, int h, int l, int nCoulInitiales, int nbBase, int nbMax);
void gdipImageKeying(int dx, int dy);
void nettoieProjetCourant();

void Debug(const char *format, ...);
int fMsgBox(HWND hDlg, const char *titre, int flags, const char *format, ...);
char *SansLeSlash(char *ptr);
HTREEITEM AddItemToTree(HWND hwndTV, LPSTR lpszItem, int nLevel);
HTREEITEM InsereObjDansArbre(HWND hwndTV, HTREEITEM hPrec, LPSTR lpszItem, int nLevel);

typedef struct		{
	char *nom;
	HANDLE *hti;
	int type;
} TYPE_HTI;

extern TYPE_HTI typesHTI[];
extern const char *noms_dossiers_base[];
//Met  jour l'arbre du projet courant
void MajListe(HWND hDlg);

//Constantes pour dfinir le coin haut/gauche dans le quel on peut commencer  crire
//arbre du projet exclus. Faudra trouver une meilleure mthode.
//#define BASEFEN_X 170
//#define BASEFEN_Y 30

//Dessine la barre de titre en dgrad.
void DessTitre(HDC hdc, LPCTSTR chaine);
void CreeEntreeFichier(HWND hDlg);
int atox(char *chn);
int atob(char *chn);
void JusteChemin(char *fichier);

//Cette fonction ouvre un fichier et le garde en mmoire (allez savoir pourquoi)
//Pour le contenu de type, rfrez-vous  la documentation Windows. Il y a juste que le
//premier caractre indique le nombre d'extensions slectionnables...
int OuvreFichier(char *fichier, char *type);
//Cette fonction permet d'enregistrer un fichier
int SauveFichier(char *fichier, char *type);
void AjouteExtension(char *nom, char *ext);
//Calcule le nombre d'objets d'un type donn dans le projet.
int CalcNombreObjets(int type);
void AjouteTypes();
void AjouteTaillesBlocs();
void AjoutePalettesTilesets();
void AjouteTilesets();
void AjouteModeles();
void AjouteMaps();
void TravailEnCours();
void CacheTravail();
void AffTravail();
void TravailTermine();
int TrouveNiemeElement(int type, int numero);
int TrouveNiemeElementCarteListe(int numero);
int TrouveElement(int type, char *nom);
ELEMENT *TrouveElementFichier(int type, char *fichier);
void EffaceElement(int n);
void GereBarresDefil(HWND hDlg);
void AjouteAuProjetRapide(ELEMENT el);
void EffaceElementArbre(int n);
//i: no de l'lment
void AjouteElementArbre(int i);
void VerifieNexistePasDeja(ELEMENT *el,  int bReuseIdenticalFiles);
void AjouteAuProjet(ELEMENT el);
// Haut niveau: ajoute directement le fichier au projet (s'occupe de trouver le bon dossier, etc.)
int AjouteAuProjet(char *fichier);

enum {OM_OUVRIR=1,OM_EDITER,OM_DUPLIQUER,OM_RENOMMER,OM_SUPPRIMER,OM_BMPBASE,OM_SUPPRIMERDOSSIER,OM_PROPRIETES};

int affMenu(HWND hWnd, ELEMENT *el);
int affMenuRestaure(HWND hWnd, HTREEITEM hti);
void SupprimeDossierVirtuel (int i);
//Gre le clic droit de la souris sur un lment de l'arbre
void GereBoutonDroit(HTREEITEM hti);
void DessineBlocArrondi();
void LitComboTiles();
//Cre un nom court depuis un nom de fichier. Par exemple:
//"C:\HAM\Tools\Salut.bmp" devient "Salut".
void faitNomCourt(char *nom_dest,char *nom_court);
void LitNomBase(char *nom_fichier, char *nom_base);
void AidePerso();
extern char NomC[MAX_PATH];
void FaitNomC(char *nom);
int VerifConditions(int i, int fond, int gfxmask);
void VerifNomVar (char *nom_defaut, char *type);
void ChangeTousNomVar(char *nom_defaut);
void AnnuleNomVar();

LRESULT CALLBACK DlgTiles(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DlgOperations(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DlgDeplace(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void ExecScript(FILE *f, char *fonction, char *command);
LRESULT CALLBACK DlgLier(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void FctLieMap(char *ptr);
LRESULT CALLBACK DlgExec(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DlgCouleurs(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void CreeCouleurs();
LRESULT CALLBACK DlgBits(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void SetBits(int valeur);
void BitsUpdate();
void *BufferActif();
LRESULT CALLBACK DlgAttributs(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void MajFichierParams();
char *GetBoolText(int valeur);
int GetParamOffset(int nParam);
void GereBoutonClic(HWND hWnd);

void Console_Print(const char *format, ...);
void Console_Print_Simple(const char *format, ...);
void AjoutePlanSpecimen(int i);

void Dialog_SetInt(HWND hDlg, int ID, int valeur);
int Dialog_GetInt(HWND hDlg, int ID);
void Dialog_SetBool(HWND hDlg, int ID, BOOL valeur);
BOOL Dialog_GetBool(HWND hDlg, int ID);
void Dialog_SetText(HWND hDlg, int ID, const char *texte);
char *Dialog_GetText(HWND hDlg, int ID);
void Combo_AddItem(HWND hDlg, int ID, const char *objet);
int Combo_GetValue(HWND hDlg, int ID);
void Combo_SetValue(HWND hDlg, int ID, int valeur);
int EffaceVersCorbeille(char *nom_fichier);
int findPfFromType(const char *type);
void InitConversion();
void DefPlateforme(PLATFORM_INFO *p);
void InitPlateformes();
void ScriptBegin();
void ScriptEnd();
BOOL RectIsInScreen(RECT *rt);

extern RECT gblMakeRectTemp;
RECT *MakeRect(int x0, int y0, int l, int h);
// Trouve un lment dans la biliothque bas sur son nom de fichier ou en cre un nouveau (temporaire) sinon
ELEMENT makeElement(char *name, int type);

template<typename T>
inline void echange(T &a, T &b) {
	T temp = a;
	a = b;
	b = temp;
}
