//Ces routines proviennent de WinGraph.h (par moi)
extern int LARG_BUF, HAUT_BUF;
extern int LARG, HAUT;
extern int CLIP_X0, CLIP_Y0, CLIP_X1, CLIP_Y1;
#define ASSERT(condition)	if (!(condition))	  MessageBox(GetFocus(),"Une erreur s'est produite car la condition suivante est fausse: "#condition,"Erreur interne",MB_ICONERROR);
extern unsigned long *Bits;
extern BITMAPINFOHEADER BIH;
extern HBITMAP hbm;

typedef unsigned char * SPRITE;

//Clippe un sprite
#define ClipSprite			{										\
							if (!Bits || !sprite)	return;						\
							if (y0<0)	{							\
								sprite+=l*(0-y0);					\
								h-=0-y0;							\
								y0=0;								\
							}										\
							if (x0<0)	{							\
								l+=0+x0;							\
								a=-x0;								\
								sprite+=-x0;						\
								x0=0;								\
							}										\
							y0+=CLIP_Y0;							\
							x0+=CLIP_X0;							\
							if (y0+h>=CLIP_Y1)	{					\
								h+=CLIP_Y1-(y0+h);					\
							}										\
							if (x0+l>=CLIP_X1)	{					\
								a=-(CLIP_X1-(x0+l));				\
								l-=a;								\
							}										\
							if (h<0)	return;						\
							}

//Clippe un sprite 8 bits
#define ClipSprite8			{										\
							if (!Bits || !sprite)	return;			\
							if (y0<0)	{							\
								sprite+=l*(0-y0);					\
								h-=0-y0;							\
								y0=0;								\
							}										\
							if (x0<0)	{							\
								l+=0+x0;							\
								a=-x0;								\
								sprite+=-x0;						\
								x0=0;								\
							}										\
							y0+=CLIP_Y0;							\
							x0+=CLIP_X0;							\
							if (y0+h>=CLIP_Y1)	{					\
								h+=CLIP_Y1-(y0+h);					\
							}										\
							if (x0+l>=CLIP_X1)	{					\
								a=-(CLIP_X1-(x0+l));				\
								l-=a;								\
							}										\
							if (h<0)	return;						\
							}

//Clippe un rectangle (sans blague!)
#define ClipRect			{										\
							if (!Bits)	return;						\
							if (y0<0)	{							\
								h-=0-y0;							\
								y0=0;								\
							}										\
							if (x0<0)	{							\
								l+=0+x0;							\
								x0=0;								\
							}										\
							y0+=CLIP_Y0;							\
							x0+=CLIP_X0;							\
							if (y0+h>=CLIP_Y1)	{					\
								h+=CLIP_Y1-(y0+h);					\
							}										\
							if (x0+l>=CLIP_X1)	{					\
								l+=CLIP_X1-(x0+l);					\
							}										\
							if (h<0)	return;						\
							}


//Cre une DIB de taille "cx" et "cy" pour pouvoir y dessiner en l'utilisant comme un
//bloc de mmoire de "ibitcount" bits par pixel. La slectionne dans "hdc" et la stocke
//dans "hbm". Le pointeur sur les bits de cette bitmap sera crit dans "bits".
int CreeDIB(HDC hdc, int cx, int cy, int ibitcount, HBITMAP *hbm, void **bits);
void ZoneEcran(int x0,int y0,int x1,int y1);
void ColoreCadre(int x0, int y0, int l, int h, int couleur);
void GetRealXY(int *xdst, int *ydst);

/*
	VIDEO BUFFERS
*/

class CVideoBuffer
{
public:
	BITMAPINFOHEADER m_BIH;
	HBITMAP m_hbm;
	HDC m_hdc;
	int m_LARG_BUF, m_HAUT_BUF;
	int m_LARG, m_HAUT;
	unsigned long *m_Bits;
	int m_bpp;

	//Constructeur
	CVideoBuffer::CVideoBuffer();
	//Cre une nouvelle image
	void Create(int bpp=32);
	void Create(int x, int y, int bpp=32);
	//Fini
	void Destroy();
	//Pour dessiner dessus
	void Use();
	//Met  jour un buffer slectionn
	void Update();
	//Redimensionner
	void Resize(int x, int y, int useMaxSize=0);
};

extern CVideoBuffer *currentlyUsedVideoBuffer;
extern CVideoBuffer vbApercu, vbEditeur, vbSpecimen;
extern CVideoBuffer vbConv;			//Temporaire

//Colle une image sur un objet CVideoBuffer
//Ne peut fonctionner que pour vbApercu  cause de hbmConv
int VideoBufferPasteImage(CVideoBuffer &v, const char *fichier, int *dx, int *dy, int donotdelete);

/*
	DESSIN
*/

//Dessine un pixel.
__inline void DessPix(register int x,register int y, register int c) {
	register unsigned long *ptr;
	x+=CLIP_X0;
	y+=CLIP_Y0;
	if (x<0 || y<0 || x>=CLIP_X1 || y>=CLIP_Y1)
		return;
	ptr=Bits+LARG_BUF*(HAUT_BUF-y)-(LARG_BUF-x);
	*ptr++ = c;
}

//Lit un pixel et stocke les valeurs r,v,b de celui-ci dans les paramtre correspondants.
__inline void LitPixRVB(register int x,register int y, register unsigned char *r, register unsigned char *v, register unsigned char *b)		{
	register unsigned char *ptr;
	x+=CLIP_X0;
	y+=CLIP_Y0;
	if (x<0 || y<0 || x>=CLIP_X1 || y>=CLIP_Y1)
		return;
	ptr=(unsigned char*)(Bits+LARG_BUF*(HAUT_BUF-y)-(LARG_BUF-x));
	*b=*(ptr++);
	*v=*(ptr++);
	*r=*(ptr++);
}

//Lit un pixel et stocke les valeurs r,v,b de celui-ci dans les paramtre correspondants.
__inline void LitPixRVBA(register int x,register int y, register unsigned char *r, register unsigned char *v, register unsigned char *b, register unsigned char *a)		{
	register unsigned char *ptr;
	x+=CLIP_X0;
	y+=CLIP_Y0;
	if (x<0 || y<0 || x>=CLIP_X1 || y>=CLIP_Y1)
		return;
	ptr=(unsigned char*)(Bits+LARG_BUF*(HAUT_BUF-y)-(LARG_BUF-x));
	*b=*(ptr++);
	*v=*(ptr++);
	*r=*(ptr++);
	*a=*(ptr++);
}

__inline u32 LitPix(register int x,register int y) {
	x+=CLIP_X0;
	y+=CLIP_Y0;
	if (x<0 || y<0 || x>=CLIP_X1 || y>=CLIP_Y1)
		return 0;
	return *(u32*)(Bits+LARG_BUF*(HAUT_BUF-y)-(LARG_BUF-x));
}

//Colore un cadre sans transparence
void ColoreCadre(int x0, int y0, int l, int h, int couleur);

//Cre une couleur RVB en vitant les dpassements
__inline int RVB(register int r, register int v, register int b) {
	if (r<0)		r=0;
	if (r>255)		r=255;
	if (v<0)		v=0;
	if (v>255)		v=255;
	if (b<0)		b=0;
	if (b>255)		b=255;
	return RGB(r,v,b);
}

void SpritePalSansMasque_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette);

//bUsePal: permet de forcer la palette
void SpritePalSansMasque(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int bUsePal=-1);
void SpritePalMiroirSansMasque_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs);
void SpritePalMiroirSansMasque(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs);
void TransSpritePalMiroirSansMasque_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs, register int niveau);
void TransSpritePalMiroirSansMasque(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs, register int niveau);
void SpritePalMiroir_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs);
void SpritePalMiroir(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs);
void TransSpritePalMiroir_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs, register int niveau);
void TransSpritePalMiroir(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, int MH, int MV, int couleurs, register int niveau);
void SpritePal_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette);
void SpritePal(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette);
void TransCadre(int x0, int y0, int l, int h, int couleur, register int niveau);
void TransSprite(int x0, int y0, int l, int h, register unsigned long *sprite, register int niveau);
void TransSpritePalSansMasque_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, register int niveau);
void TransSpritePalSansMasque(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, register int niveau);
void TransSpritePal_32(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, register int niveau);
void TransSpritePal(int x0, int y0, int l, int h, register unsigned long *sprite, unsigned long *palette, register int niveau);

/*
	FxRect

	Dessine un rectangle avec la possibilit d'appliquer les effets suivants:
	-FX_OPAQUE, FX_ADD, FX_SOUS, FX_MASQUE, FX_TRANS, FX_XOR
*/
void TransRect(int x0, int y0, int l, int h, int couleur, register int niveau);
void TransRectFond(int x0, int y0, int l, int h, int couleur, register int niveau);
