/*
	GBC

	Variables d'environnement
	-------------------------
	Fonctions de lecture: doivent remplir *cmode avec la bonne valeur!
	Grer les autres pixelformats (crecouleurs)!
	Chaque entre de la palette: 3 octets
		- Bleu
		- Vert
		- Rouge
	(!!!) Palette 32 bits (RGBA)!
*/

namespace pluginGBC
{
	int fctInitConversion(int flags, void *data);
	int fctLitPalette(int flags, int *cmode, unsigned char *palette, char *nom_fichier);
	int fctLitTileset(int flags, int *cmode, unsigned char *palette,unsigned long **motiv, const char *nom, int original);
	int fctLitMap(int flags, int *cmode, unsigned char *palette, unsigned long **motifs, MAP **umap, int i);
	int fctLitListe(int flags, int *cmode, unsigned char *palette, unsigned long **motifs, MAP **umap, int i);
	int fctLitBitmap(int flags, int *cmode, unsigned char *palette,unsigned long **motiv, const char *nom, int original);
	int fctEcritPalette(int flags, int *cmode, ELEMENT *e, unsigned char *palette, int nbCouleurs);
	int fctEcritTileset(int flags, int *cmode, ELEMENT *e, ELEMENT *palfile, unsigned long *motifs, unsigned char *palette, int nTiles, int tileX, int tileY);
	int fctEcritMap(int flags, int *cmode, ELEMENT *e, ELEMENT *tilfile, ELEMENT *palfile, unsigned long *map, int tailleX, int tailleY, int tileX, int tileY);
	int fctEcritListe(int flags, int *cmode, ELEMENT *e, ELEMENT *tilfile, ELEMENT *palfile, SPRITE_LISTE *sl, char *typeSd, void *userData, SD_PARAMS *modele, int tileX, int tileY);
	int fctEcritBitmap(int flags, int *cmode, ELEMENT *e, ELEMENT *palfile, unsigned long *tableau, unsigned char *palette, int tailleX, int tailleY);
	int fctPersonnalisation(int flags, int *cmode);
	int bModeDMG;
	PLATFORM_INFO *ptrPF;
	const u32 dmgColorTable[3][4] = {
		{0xffffffff, 0xffaaaaaa, 0xff555555, 0xff000000},
		{0xffd3de34, 0xffa5b52b, 0xff70831b, 0xff284440},
		{0xff00e7ff, 0xff009ac7, 0xff004d8f, 0xff000057},
	};
	u32 dmgPalette[4];

	PF_PIXELFORMAT pixel=	{
		2,						//16 bits (pas utilis pour le moment)
		5, 5, 5, 0,				//RGB(A pas gr pour le moment)
	};
	PF_PALETTEFORMAT pixelFormatList[]=		{
		{	// Sans transparence
			"2 bits BG",
			"4", 4,						//Identificateur
			2,							//Conversion optimise 8x4 palettes (hack)
			FALSE,						//Color keying
			TRUE,						//Palettes arrondies  4
			31, 4, 4,					//Max. 32 couleurs, 4 couleurs par palette
			FALSE,
			NULL,
			&pixel
		},
		{	// Avec transparence
			"2 bits sprite",
			"3", 3,						//Identificateur
			2,							//Conversion optimise 8x4 palettes (hack)
			FALSE,						//Color keying
			TRUE,						//Palettes arrondies  4
			31, 4, 4,					//Max. 32 couleurs, 4 couleurs par palette
			TRUE,
			NULL,
			&pixel
		},
	};

	int Rvba15Bits(int r, int g, int b, int a) {
		// Vrifier...
		return ((r)|((g)<<5)|((b)<<10)|((a)<<15));
	}
	void LitCouleur(int c, unsigned char *palette) {
		*palette++=((c&0x7C00)>>10);
		*palette++=((c&0x3E0)>>5);
		*palette++=(c&0x1F);
		*palette++=(c&0x8000)?0:255;
	}
	int LitCouleurRGBA(int c) {
		unsigned char pal[4];
		LitCouleur(c, pal);
		return RGBA(pal[0], pal[1], pal[2], pal[3]);
	}

	int fctInitConversion(int flags, void *data)
	{
		return 1;
	}

	int fctLitTileset(int flags, int *cmode, unsigned char *palette,unsigned long **motiv, ELEMENT *e, int original)		{
		FILE *f;
		int x,c1,c2,k,j,z=0, realTileX, realTileY;
		unsigned long *motifs;
		char bits[100];
		char *bloc=(char*)malloc(TAILLE_MAXIMUM);
		int taille_totale;

		motifs=*motiv;

		ChoisitFormatFichierExtension(e->nom_fichier);
		f=fopen(e->nom_fichier,"rb");
		if (!f)		{
			free(bloc);
			MessageBox(gblHDlg,"Le fichier tileset spcifi n'existe pas",e->nom_fichier,MB_ICONERROR);
			return 0;
		}

		ReinitSymTable();
		PrepareSymTable(1);

		InitSymbole(6,gblcPal);							//%link%
		InitSymbole(12,bits);							//%bits%
		bits[0]=0;

		taille_totale=fread(bloc,1,TAILLE_MAXIMUM,f);

		//Lit ventuellement ce dont on a besoin dans le ref file
		refFile::readSectionFiltree(til_refdefine, e);

		k=LitChaineFiltree(0,bloc,til_declaration, taille_totale);
		if (k>taille_totale)
			return 0;

		taille=(int)symboles[3].donnees;
		// %depth%, 3 = sprite, 4 = bg
		if ((int)symboles[9].donnees==3)
			*cmode=1;
		else
			*cmode=0;
		//Pour trouver la profondeur (bits)
		if (palette && curPF->pfList[*cmode].bUsePalettes)			{
			ELEMENT e = makeElement(gblcPal, TYPE_PALETTE);
			if (!LitPalette(palette, &e, FALSE, FALSE))		{
				free(bloc);
				fclose(f);
				return 0;
			}
		}

		//Toujours du 8x8!!!!
		taille*=(tileX/8)*(tileY/8);
		if (!motifs)		{
			motifs=(unsigned long*)malloc(tileX*tileY*taille*sizeof(long));
			utilMemoire+=tileX*tileY*taille*sizeof(long);
			*motiv=motifs;
		}


		realTileX=tileX, realTileY=tileY;
		tileX=tileY=8;
		for (j=0;j<taille;j++)		{
			if (j>=TILEMAX)		{
				MessageBox(gblHDlg,"Le nombre de tiles est suprieur  la mmoire. Le format serait-il faux?",e->nom_fichier,MB_ICONERROR);
				fclose(f);
				free(motifs);
				*motiv=NULL;
				taille=0;
				free(bloc);
				return taille-1;
			}

			for (x=0;x<tileY*tileX;x+=8)			{
				if (til_nbChaqueX>0 && z>0 && z%til_nbChaqueX < 2)
					k=LitChaineFiltree(k,bloc,til_chaque_x, taille_totale);

				k=LitValeur(k,bloc,til_chaque_valeur_1,f,&c1,taille_totale);
				k=LitValeur(k,bloc,til_chaque_valeur_1,f,&c2,taille_totale);
				for (int l = 0; l < 8; l++) {
					motifs[(j*tileX*tileY)+x+l] = (c1 & 0x80) >> 7 | (c2 & 0x80) >> 6;
					c1 <<= 1, c2 <<= 1;
				}
				z += 2;
			}
			k=LitChaineFiltree(k,bloc,til_fin_ligne, taille_totale);
			vraieTaille++;
		}
		tileX=realTileX, tileY=realTileY;

		if (vraieTaille<taille)
			taille=vraieTaille;

		fclose(f);
		free(bloc);
		return taille;
	}

	int fctLitPalette(int flags, int *cmode, unsigned char *palette, ELEMENT *e)		{
		FILE *f;
		int c,j, nbCouleurs;
		char *bloc=(char*)malloc(TAILLE_MAXIMUM);
		u8 *palBase = palette;
		int taille_totale;

		// Mode noir et blanc -> palette par dfaut
		if (bModeDMG) {
			nbCouleurs = 4;
			for (int i = 0; i < 16; i++)
				palette[i] = ((u8*)dmgPalette)[i] / 8;
			return 4;
		}

		ChoisitFormatFichierExtension(e->nom_fichier);
		f=fopen(e->nom_fichier,"rb");
		if (!f)		{
			free(bloc);
			MessageBox(gblHDlg,"Le fichier palette spcifi n'existe pas.", e->nom_fichier, MB_ICONERROR);
			return 0;
		}

		ReinitSymTable();
		PrepareSymTable(1);

		InitSymbole(6,gblcPal);							//%link%

		taille_totale=fread(bloc,1,TAILLE_MAXIMUM,f);

		//Lit ventuellement ce dont on a besoin dans le ref file
		refFile::readSectionFiltree(pal_refdefine, e);

		j=LitChaineFiltree(0,bloc,pal_declaration, taille_totale);
		if (j>taille_totale)
			return 0;

		nbCouleurs=0;
		memset(palette,0,256*4);

		while(1)		{
			j=LitValeur(j,bloc,pal_chaque_valeur_1,f,&c, taille_totale);
			if (j>taille_totale)
				break;

			LitCouleur(c, palette);
			palette += 4;
			nbCouleurs++;

			if (pal_nbChaqueX>0 && nbCouleurs>0 && nbCouleurs%pal_nbChaqueX==0)
				j=LitChaineFiltree(j,bloc,pal_chaque_x, taille_totale);

			if (nbCouleurs>=256)
				break;
		}

		//Premire couleur toujours transparente
		if (ptrPF->pfList[curCMode].bFirstColorTransparent)
			*(u32*)palBase = 0;

		fclose(f);
		free(bloc);

		//Toujours le mme type 1
		*cmode = curPF->pfDefaut;
		return nbCouleurs;
	}

	int fctLitMap(int flags, int *cmode, unsigned char *palette, unsigned long **motifs, MAP **umap, ELEMENT *e)		{
		FILE *f;
		char temp[4096];
		int x,y,c, ii, j, tX, tY, z;
		MAP *map=*umap;
		char *bloc=(char*)malloc(TAILLE_MAXIMUM);
		char tempGblUserData[NB_MAX_USERDATA][TAILLE_MAX_CHAINES];
		int taille_totale;

		strcpy(gblcMap,e->nom_fichier);

		ChoisitFormatFichierExtension(e->nom_fichier);
		f=fopen(e->nom_fichier,"rb");
		if (!f)		{
			free(bloc);
			MessageBox(gblHDlg,"Le fichier map spcifi n'existe pas",e->nom_fichier,MB_ICONERROR);
			return 0;
		}

		ReinitSymTable();
		PrepareSymTable(1);
		InitSymbole(5,gblcNomC);						//%name%
		InitSymbole(6,gblcTil);							//%link%
		InitSymbole(10,temp);							//%type%
		gfxmask=0xffffffff;

		taille_totale=fread(bloc,1,TAILLE_MAXIMUM,f);
		ii=taille_totale;

		//Lit ventuellement ce dont on a besoin dans le ref file
		refFile::readSectionFiltree(map_refdefine, e);

		j=LitChaineFiltree(0,bloc,map_declaration, taille_totale);
		if (j>taille_totale)
			return 0;
		memcpy(tempGblUserData, gblUserData, sizeof(gblUserData));

		tX=tileX, tY=tileY;

	//	RedimDIB(tailleX*tileX,tailleY*tileY);

	//	InitVariables();					//Rinitialise le systme de variables...
	//	memset(chneVariables,0,sizeof(chneVariables));

		if ((int)symboles[9].donnees==0)	{					//%depth%
			if (!strcmp(temp,type32))							//%bits%
				ModeTexte=2;
			else if (!strcmp(temp,type8))							//%bits%
				ModeTexte=0;
			else
				ModeTexte=1;
		}
		else if ((int)symboles[9].donnees==32)					//%depth%
			ModeTexte=2;
		else if ((int)symboles[9].donnees==8)					//%depth%
			ModeTexte=0;
		else
			ModeTexte=1;


		if (*gblcTil)		{
			ELEMENT e = makeElement(gblcTil, TYPE_MOSAIQUE);
			taille=LitTileset(palette, motifs, &e, 0);
		}
		if (!taille)		{
			free(bloc);
			fclose(f);
			return 0;
		}

		if (!(*umap))		{
			map=(MAP*)malloc(tailleX*tailleY*sizeof(MAP));
			//Dcommenter pour obtenir la consommation mmoire dans l'diteur (il y en a ailleurs  dcommenter encore)
	//		utilMemoire+=tailleX*tailleY*2;
			memset(map,0,tailleX*tailleY*sizeof(MAP));
			*umap=map;
		}

		taille_totale=ii;

		tileX=tX, tileY=tY;

		taille/=(tileX*tileY)/64;

		for (y=0;y<tailleY;y++)			{
			for (x=0;x<tailleX;x++)		{
				if (*map_fin_ligne)
					z=x;
				else
					z=(y*tailleX)+x;

				if (map_nbChaqueX>0 && z>0 && z%map_nbChaqueX==0)
					j=LitChaineFiltree(j,bloc,map_chaque_x, taille_totale);

				if (ModeTexte==2)
					j=LitValeur(j,bloc,map_chaque_valeur_3,f,&c, taille_totale);
				else if (ModeTexte==1)
					j=LitValeur(j,bloc,map_chaque_valeur_1,f,&c, taille_totale);
				else
					j=LitValeur(j,bloc,map_chaque_valeur_2,f,&c, taille_totale);

				if (j>taille_totale)
					goto fin;

				map[tailleX*y+x]=c;
			}
			j=LitChaineFiltree(j,bloc,map_fin_ligne, taille_totale);
		}

	fin:
		fclose(f);
		free(bloc);
		memcpy(gblUserData, tempGblUserData, sizeof(gblUserData));

		return 1;
	}

	int fctLitListe(int flags, int *cmode, unsigned char *palette, unsigned long **motifs, MAP **umap, ELEMENT *e)		{
		FILE *f;
		char temp[4096];
		int i, ii, j, tX, tY, lastJ;
		MAP *map=*umap;
		char *bloc=(char*)malloc(TAILLE_MAXIMUM);
		char nomModele[TAILLE_MAX_CHAINES];
		char tempGblUserData[NB_MAX_USERDATA][TAILLE_MAX_CHAINES];
		int taille_totale;

		strcpy(gblcMap,e->nom_fichier);

		ChoisitFormatFichierExtension(e->nom_fichier);
		f=fopen(e->nom_fichier,"rb");
		if (!f)		{
			free(bloc);
			MessageBox(gblHDlg,"Le fichier map spcifi n'existe pas",e->nom_fichier,MB_ICONERROR);
			return 0;
		}

		strcpy(nomModele, sdParams[gblSdModele].sdNomModele);
		ReinitSymTable();
		PrepareSymTable(1);
		InitSymbole(5,gblcNomC);						//%name%
		InitSymbole(6,gblcTil);							//%link%
		InitSymbole(10,gblTypeSd);						//%type%
		InitSymbole(15,nomModele);						//%model%
		gfxmask=0xffffffff;

		taille_totale=fread(bloc,1,TAILLE_MAXIMUM,f);
		ii=taille_totale;

		//Lit ventuellement ce dont on a besoin dans le ref file
		refFile::readSectionFiltree(lst_refdefine, e);

		j=LitChaineFiltree(0,bloc,lst_declaration, taille_totale);
		if (j>taille_totale)
			return 0;

		memcpy(tempGblUserData, gblUserData, sizeof(gblUserData));
		if (!AppliqueSdModele(nomModele))			{
			sprintf(str, "Impossible de spcifier le modle de paramtres spcifi: %s", nomModele);
			MessageBox(gblHDlg, str, "Erreur", MB_ICONEXCLAMATION);
			return 0;
		}

		MajFichierParams();

		//Initialisation de la liste
		gblSpriteListe.sizeofSD=sdParams[gblSdModele].sizeofSD;
		gblSpriteListe.sd=(SPRITE_DEF*)realloc(gblSpriteListe.sd, NB_MAX_ELE_LISTE*gblSpriteListe.sizeofSD);
		gblSpriteListe.nbSprites=(int)symboles[3].donnees;

		tX=tileX, tY=tileY;

		ELEMENT el = makeElement(gblcTil, TYPE_MOSAIQUE);
		taille=LitTileset(palette, motifs, &el, 0);
		if (!taille)		{
			free(bloc);
			fclose(f);
			return 0;
		}

		taille_totale=ii;
		tileX=tX, tileY=tY;
		tailleX/=tileX; tailleY/=tileY;
		taille/=(tileX*tileY)/64;

		if (gblSpriteListe.nbSprites>NB_MAX_ELE_LISTE)			{
			free(bloc);
			fclose(f);
			MessageBox(NULL, "Impossible de charger la liste car elle contient plus d'lments qu'allous. Modifiez le nombre maximal d'lments par liste dans les options.", e->nom_fichier, MB_ICONEXCLAMATION);
			return 0;
		}

		gblErrorFlag = 0;
		lastJ = j;
		for (i=0;i<gblSpriteListe.nbSprites;i++)		{
			if (lst_nbChaqueX>0)		{
				if (i%lst_nbChaqueX==0)
					j=LitChaineFiltree(j,bloc,lst_chaque_x, taille_totale);
			}

			if (lst_chaque_valeur_2[0])
			{
				/* Nouveau systme, plus souple */
				gblCurrentSprite = _SD(gblSpriteListe, i);
				j = LitChaineFiltree(j, bloc, lst_chaque_valeur_2, taille_totale);
				gblCurrentSprite = NULL;
			}
			else
				/* Ancien systme */
				j=LitChaineTypes(j,bloc,lst_chaque_valeur_ok,f,_SD(gblSpriteListe,i), 0, NULL, taille_totale);

			if (j>taille_totale)
				break;

			j=LitChaineFiltree(j,bloc,lst_fin_ligne, taille_totale);
		}

		/* Ce flag d'erreur n'est l que pour la compatibilit, normalement il faut l'viter,
		   d'ailleurs avec le nouveau systme, ce genre de cas, qui se produit lorsque la
		   structure des fichiers liste a t change au milieu d'un projet (ajout d'un
		   paramtre par exemple) n'est plus support  cause du support pour les fichiers
		   binaires. */
		if (gblErrorFlag)		{
			SD_PARAMS *sdp=&sdParams[gblSdModele];
			memset(gblSpriteListe.sd, 0, NB_MAX_ELE_LISTE*gblSpriteListe.sizeofSD);
			if (MessageBox(gblHDlg, "Le format de la liste est incorrect, un algorithme plus souple et dductif va tre tente pour pouvoir rcuprer le fichier malgr d'ventuels changements dans le modle de paramtres. Cette opration peut chouer, vous devriez donc vrifier si la liste d'objets est bien correcte et ne l'enregistrer que si c'est le cas.", "Attention", MB_ICONEXCLAMATION|MB_OKCANCEL)!=IDOK)			{
				fclose(f);
				free(bloc);
				return 0;
			}
			for (j=0;j<gblSpriteListe.nbSprites;j++)		{
				SPRITE_DEF *sd=_SD(gblSpriteListe,j);
				for (i=0;i<sdp->sdNumParams;i++)			{
					if (sdp->sdTypeParam[i]==SDT_ENTIER)			{
						int *ptr;
						ptr= (int*)((char*)sd->params+GetParamOffset(i));
						*ptr = GetEntier(sdp->sdTexteDefaut[i]);
					}
					else if (sdp->sdTypeParam[i]==SDT_BRUT)			{
						char *cptr;
						cptr=(char*)sd->params+GetParamOffset(i);
						strcpy(cptr,sdp->sdTexteDefaut[i]);
					}
				}
			}
	//		memset(gblSpriteListe.sd, 0, NB_MAX_ELE_LISTE*gblSpriteListe.sizeofSD);
			//Erreur -> tente de l'importer  la manire forte!
			gblErrorFlag = 0;
			j = lastJ;
			//Fin de ligne
			if (!lst_fin_ligne[0])		{
				//Depuis le dernier #
				for (i=strlen(lst_chaque_valeur_ok)-1;i>=0;i--)		{
					if (lst_chaque_valeur_ok[i]=='#')
						break;
				}
				if (i>=0)
					strcpy(temp, lst_chaque_valeur_ok+i+1);
			}
			else
				strcpy(temp, lst_fin_ligne);
			for (i=0;i<gblSpriteListe.nbSprites;i++)		{
				if (lst_nbChaqueX>0)		{
					if (i%lst_nbChaqueX==0)
						j=LitChaineFiltree(j,bloc,lst_chaque_x, taille_totale);
				}

				j=LitChaineTypes(j,bloc,lst_chaque_valeur_ok,f,_SD(gblSpriteListe,i), 2, temp, taille_totale);
				if (j>taille_totale)
					break;

				j=LitChaineFiltree(j,bloc,lst_fin_ligne, taille_totale);
			}
		}

		fclose(f);
		free(bloc);
		memcpy(gblUserData, tempGblUserData, sizeof(gblUserData));

		return 1;
	}

	int fctLitBitmap(int flags, int *cmode, unsigned char *palette,unsigned long **motiv, ELEMENT *e, int original)		{
		FILE *f;
		int x,y,c,j,z, nbCouleurs;
		unsigned long *motifs;
		char bits[100];
		char *bloc=(char*)malloc(TAILLE_MAXIMUM);
		int taille_totale;

		motifs=*motiv;

		ChoisitFormatFichierExtension(e->nom_fichier);
		f=fopen(e->nom_fichier,"rb");
		if (!f)		{
			free(bloc);
			MessageBox(gblHDlg, "Le fichier bitmap spcifi n'existe pas", e->nom_fichier, MB_ICONERROR);
			return 0;
		}

		ReinitSymTable();
		PrepareSymTable(1);

		InitSymbole(6,gblcPal);							//%link%
		InitSymbole(12,bits);							//%bits%
		bits[0]=0;
		gblcPal[0]=0;

		taille_totale=fread(bloc,1,TAILLE_MAXIMUM,f);

		//Lit ventuellement ce dont on a besoin dans le ref file
		refFile::readSectionFiltree(bmp_refdefine, e);

		j=LitChaineFiltree(0,bloc,bmp_declaration, taille_totale);
		if (j>taille_totale)
			return 0;

//		taille=(int)symboles[3].donnees;
		//Pour trouver la profondeur (bits)
		if ((int)symboles[9].donnees==32)						//%depth%
			*cmode=3;
		else if ((int)symboles[9].donnees==15)					//%depth%
			*cmode=2;
		else if ((int)symboles[9].donnees==4)					//%depth%
			*cmode=0;
		else
			*cmode=1;

		if (palette && curPF->pfList[*cmode].bUsePalettes && gblcPal[0])			{
			ELEMENT eTemp = makeElement(gblcPal, TYPE_PALETTE);

			nbCouleurs = LitPalette(palette,&eTemp,FALSE, FALSE);
			if (!nbCouleurs)		{
				free(bloc);
				fclose(f);
				return 0;
			}
		}

		if (!motifs)		{
			motifs=(unsigned long*)malloc(tailleX*tailleY*sizeof(long));
			utilMemoire+=tailleX*tailleY*sizeof(long);
			*motiv=motifs;
		}

		for (y=0;y<tailleY;y++)			{
			for (x=0;x<tailleX;x++)		{
				if (*bmp_fin_ligne)
					z=x;
				else
					z=x+y*tailleX;

				if (bmp_nbChaqueX>0 && z>0 && z%bmp_nbChaqueX==0)
					j=LitChaineFiltree(j,bloc,bmp_chaque_x, taille_totale);

				if (curPF->pfList[*cmode].ID == 32)			//32 bits RGBA
					j = LitValeur(j,bloc,bmp_chaque_valeur_3,f,&c, taille_totale);
				else if (curPF->pfList[*cmode].ID == 15)	//15 bits
					j=LitValeur(j,bloc,bmp_chaque_valeur_2,f,&c, taille_totale);
				else
					j=LitValeur(j,bloc,bmp_chaque_valeur_1,f,&c, taille_totale);

				if (!curPF->pfList[*cmode].bUsePalettes)		{
					if (curPF->pfList[*cmode].ID == 15)		{
						if (!original)
							c = LitCouleurRGBA(c);
					}
					motifs[tailleX*y+x]=c;
/*					if (c == 0xffffffff)
						c = 0xff000000 | RGB(GetBValue(cFond), GetGValue(cFond), GetRValue(cFond));
					else
						c= RGB (((c&0x7C00)>>10)<<3, ((c&0x3E0)>>5)<<3, (c&0x1F)<<3);*/
				}
				motifs[tailleX*y+x] = c;
			}
			j=LitChaineFiltree(j,bloc,bmp_fin_ligne, taille_totale);
		}

		fclose(f);
		free(bloc);
		return 1;
	}

	int fctEcritPalette(int flags, int *cmode, ELEMENT *e, unsigned char *palette, int nbCouleurs)			{
		FILE *ecri;
		int i;

		if (bModeDMG)		// Pas de palette en mode mono
			return 0;

		//Ecrit la palette
		ecri=fopen(e->nom_fichier, "wb");
		if (!ecri)		{
			CacheTravail();
			MessageBox(gblHDlg,"Impossible d'ouvrir le fichier en criture.\nLe nom est probablement faux.",e->nom_fichier,MB_ICONERROR);
			return 0;
		}

		ReinitSymTable();
		if ((flags & 3) != PL_OPEN)
			PrepareSymTable(2);
		VerifNomVar(e->nom_court,chneNomVarPal);
		InitSymbole(0,e->nom_base);									//%file%
		InitSymbole(3,nbCouleurs);									//%size%
		InitSymbole(4,nbCouleurs*2);								//%memory%
		InitSymbole(5,chneNomVarPal);								//%name%

		//Ecrit ventuellement ce dont on a besoin dans le ref file
		refFile::writeSectionFiltree(pal_refdefine, e);

		EcritChaineFiltree(pal_declaration,ecri);

		for (i=0;i<nbCouleurs;i++)		{
			if (pal_nbChaqueX>0 && i>0 && i%pal_nbChaqueX==0)
				EcritChaineFiltree(pal_chaque_x,ecri);
			myprintf(ecri,pal_chaque_valeur_1, Rvba15Bits(palette[4*i+2],palette[4*i+1],palette[4*i],!(palette[4*i+3]&1)));
		}
		EcritChaineFiltree(pal_fin_declaration,ecri);
		fclose(ecri);
		return 1;
	}

	void trieCouleurs(int *colorMap, unsigned char *palette) {
		int valeur[4], swapped = 1;
		for (int i = 0; i < 4; i++) {
			valeur[i] =
				(255 - palette[i * 4]) * 30 +
				(255 - palette[i * 4 + 1]) * 59 +
				(255 - palette[i * 4 + 2]) * 11;
			colorMap[i] = i;
		}

		// Tri  bulles
		for (int j = 1; j < 4 && swapped; j++) {
			swapped = 0;
			for (int i = 0; i < 4 - j; i++) {
				// Echange les 2 pour ramener le plus grand  la fin
				if (valeur[i] > valeur[i + 1]) {
					echange(valeur[i], valeur[i + 1]);
					echange(colorMap[i], colorMap[i + 1]);
					swapped = 1;
				}
			}
		}
	}

	int fctEcritTileset(int flags, int *cmode, ELEMENT *e, ELEMENT *palfile, unsigned long *motifs, unsigned char *palette, int nTiles, int tileX, int tileY)		{
		int i, j, z = 0;
		FILE *ecri;
		int colorMap[4];		// Mappage des couleurs aux niveaux de gris DMG

		ecri=fopen(e->nom_fichier,"wb");
		if (!ecri)		{
			CacheTravail();
			MessageBox(gblHDlg,"Impossible d'ouvrir le fichier en criture.\nLe nom est probablement faux ou vous n'avez pas les autorisations d'accs dans ce rpertoire (seriez-vous  l'cole?).",e->nom_fichier,MB_ICONERROR);
			return 0;
		}

		i=nTiles*tileX*tileY;
		if (curPF->pfList[*cmode].ID == 4)		i/=2;

		ReinitSymTable();
		if ((flags & 3) != PL_OPEN)
			PrepareSymTable(2);
		VerifNomVar(e->nom_court,chneNomVarTil);
		InitSymbole(0,e->nom_base);									//%file%
	//	InitSymbole(3,nTiles*((tileX*tileY)/(8*8)));				//%size%
		InitSymbole(3,nTiles);										//%size%
		InitSymbole(4,i);											//%memory%
		InitSymbole(5,chneNomVarTil);								//%name%
		if (curPF->pfList[*cmode].bUsePalettes && !bModeDMG)
			InitSymbole(6,palfile->nom_fichier);					//%link%
		else
			InitSymbole(6,"");										//%link%
		InitSymbole(9,curPF->pfList[*cmode].ID);					//%depth%
		InitSymbole(10,type8);										//%type%

		//Ecrit ventuellement ce dont on a besoin dans le ref file
		refFile::writeSectionFiltree(til_refdefine, e);
		EcritChaineFiltree(til_declaration,ecri);

		//Toujours du 8x8
		nTiles*=(tileX/8)*(tileY/8);
		tileX=tileY=8;

		trieCouleurs(colorMap, palette);		// pour le mode DMG

		for (i = 0; i < nTiles; i++)		{
			for (j = 0; j < tileX * tileY; j += 8)		{
				if (til_nbChaqueX>0 && z>0 && z%til_nbChaqueX < 2)
					EcritChaineFiltree(til_chaque_x, ecri);

				// Ecriture de 8 pixels entrelacs - le premier byte a le plan "clair" et le deuxime le plan "fonc"
				unsigned short dest = 0;
				for (int k = 0; k < 8; k++) {
					// Traduit la couleur dans la palette DMG
					int val = motifs[(i*tileX*tileY)+j+k] & 3;
					if (bModeDMG) {
						for (int l = 0; l < 4; l++)
							if (val == colorMap[l]) {
								val = l;
								break;
							}
					}
					if (val & 1)
						dest |= 0x80 >> k;
					if (val & 2)
						dest |= 0x8000 >> k;
				}
				myprintf(ecri,til_chaque_valeur_1, dest & 0xff);
				myprintf(ecri,til_chaque_valeur_1, dest >> 8);
				z += 2;
			}
			EcritChaineFiltree(til_fin_ligne,ecri);
		}
		EcritChaineFiltree(til_fin_declaration,ecri);

		fclose(ecri);
		return 1;
	}


	int fctEcritMap(int flags, int *cmode, ELEMENT *e, ELEMENT *tilfile, ELEMENT *palfile, unsigned long *map, int tailleX, int tailleY, int tileX, int tileY)		{
		FILE *ecri;
		int i, j, nEcrits, z;

		ecri=fopen(e->nom_fichier,"wb");
		if (!ecri)		{
			CacheTravail();
			MessageBox(gblHDlg,"Impossible d'ouvrir le fichier en criture.\nLe nom est probablement faux.",e->nom_fichier,MB_ICONERROR);
			return 0;
		}

	/*	tailleX/=tileX;
		tailleY/=tileY;*/

		ReinitSymTable();
		if ((flags & 3) != PL_OPEN)
			PrepareSymTable(2);
		VerifNomVar(e->nom_court,chneNomVarMap);
		InitSymbole(0,e->nom_base);								//%file%
		InitSymbole(1, &tailleX);								//%sizex%
		InitSymbole(2, &tailleY);								//%sizey%
		i=tailleX*tailleY;
		if (ModeTexte==2)
			InitSymbole(4,tailleX*tailleY*4);						//%memory%
		else if (ModeTexte==1)
			InitSymbole(4,tailleX*tailleY*2);						//%memory%
		else
			InitSymbole(4,tailleX*tailleY);							//%memory%
		InitSymbole(5,chneNomVarMap);								//%name%
		InitSymbole(6,tilfile->nom_fichier);						//%link%
		if (ModeTexte==0)
			InitSymbole(9,8);										//%depth%
		else if (ModeTexte==1)
			InitSymbole(9,16);										//%depth%
		else if (ModeTexte==2)
			InitSymbole(9,32);										//%depth%
		if (ModeTexte==2)
			InitSymbole(10,type32);									//%type%
		else if (ModeTexte)
			InitSymbole(10,type16);									//%type%
		else
			InitSymbole(10,type8);									//%type%

		//Ecrit ventuellement ce dont on a besoin dans le ref file
		refFile::writeSectionFiltree(map_refdefine, e);
		EcritChaineFiltree(map_declaration,ecri);

		nEcrits=0;
		for (j=0;j<tailleY;j++)		{
			for (i=0;i<tailleX;i++)		{
				if (*map_fin_ligne)
					z=i;
				else
					z=(j*tailleX)+i;

				if (map_nbChaqueX>0 && z>0 && z%map_nbChaqueX==0)
					EcritChaineFiltree(map_chaque_x,ecri);

				if (ModeTexte==2)
					myprintf(ecri,map_chaque_valeur_3,map[tailleX*j+i]);
				else if (ModeTexte==1)
					myprintf(ecri,map_chaque_valeur_1,map[tailleX*j+i]);
				else
					myprintf(ecri,map_chaque_valeur_2,map[tailleX*j+i]);

				nEcrits++;
			}
			EcritChaineFiltree(map_fin_ligne,ecri);
		}
		EcritChaineFiltree(map_fin_declaration,ecri);

		fclose(ecri);
		return 1;
	}

	int fctEcritListe(int flags, int *cmode, ELEMENT *e, ELEMENT *tilfile, ELEMENT *palfile, SPRITE_LISTE *sl, char *typeSd, void *userData, SD_PARAMS *modele, int tileX, int tileY)			{
		SPRITE_LISTE listeSauve;
		FILE *ecri;
		int i,j;

		ecri=fopen(e->nom_fichier,"wb");
		if (!ecri)		{
			MessageBox(gblHDlg,"Impossible d'ouvrir le fichier en criture.\nLe nom est probablement faux.",e->nom_fichier,MB_ICONERROR);
			return 0;
		}

	//	FaitNomC(ele_fond[fond]->nom_court);
		ReinitSymTable();
		if ((flags & 3) != PL_OPEN)
			PrepareSymTable(2);
		VerifNomVar(e->nom_court,chneNomVarMap);
		InitSymbole(0,e->nom_base);									//%file%
		InitSymbole(3,sl->nbSprites);								//%size%
		InitSymbole(4,sl->nbSprites*sl->sizeofSD);					//%memory%
		InitSymbole(5,chneNomVarMap);								//%name%
		InitSymbole(6,tilfile->nom_fichier);						//%link%
		InitSymbole(7,&tileX);										//%tilex%
		InitSymbole(8,&tileY);										//%tiley%
		InitSymbole(10,typeSd);										//%type%
		if (userData)
			memcpy(gblUserData, userData, sizeof(gblUserData));
		InitSymbole(15,modele->sdNomModele);						//%model%

		//Ecrit ventuellement ce dont on a besoin dans le ref file
		refFile::writeSectionFiltree(lst_refdefine, e);
		EcritChaineFiltree(lst_declaration,ecri);

		//TRI
		int nBest, bX, bY;
		int *listeX;
		listeSauve.sd=(SPRITE_DEF*)malloc(NB_MAX_ELE_LISTE*sl->sizeofSD);
		listeSauve.sizeofSD=sl->sizeofSD;
		listeX=(int*)malloc(NB_MAX_ELE_LISTE*sizeof(int));
		
		for (i=0;i<sl->nbSprites;i++)		{
			listeX[i]=_SD(*sl,i)->x;
		}

		for (j=0;j<sl->nbSprites;j++)		{
			nBest=-1;
			bX=bY=0x7fffffff;
			for (i=0;i<sl->nbSprites;i++)		{
				if ((_SD(*sl,i)->x<bX) || (_SD(*sl,i)->x==bX && _SD(*sl,i)->y<=bY))		{
	//				if (_SD(sl,i)->y<=bY)		{
						bX=_SD(*sl,i)->x;
						bY=_SD(*sl,i)->y;
						nBest=i;
	//				}
				}
			}

			memcpy(_SD(listeSauve,j),_SD(*sl,nBest), sl->sizeofSD);
			_SD(*sl,nBest)->x=0x7ffffff0;
		}
	//	_SD(sl,nBest)->x=0x7fffffff;

		for (i=0;i<sl->nbSprites;i++)		{
			_SD(*sl,i)->x=listeX[i];
		}

		for (i=0;i<sl->nbSprites;i++)		{
			if (lst_nbChaqueX>0)		{
				if (i%lst_nbChaqueX==0)
					EcritChaineFiltree(lst_chaque_x,ecri);
			}
			if (lst_chaque_valeur_2[0])
			{
				/* Nouveau systme, plus souple */
				gblCurrentSprite = _SD(gblSpriteListe, i);
				EcritChaineFiltree(lst_chaque_valeur_2, ecri);
				gblCurrentSprite = NULL;
			}
			else
				/* Ancien systme */
				analyseChaineTypes(ecri,lst_chaque_valeur_ok,_SD(listeSauve,i));
			
			EcritChaineFiltree(lst_fin_ligne,ecri);
		}
		EcritChaineFiltree(lst_fin_declaration,ecri);

		fclose(ecri);

		free(listeSauve.sd);
		free(listeX);
		return 1;
	}


	int fctEcritBitmap(int flags, int *cmode, ELEMENT *e, ELEMENT *palfile, unsigned long *tableau, unsigned char *palette, int tailleX, int tailleY)			{
		FILE *ecri;
		int i,j, z;

		//Ecrit la bitmap 8 bits
		ecri=fopen(e->nom_fichier,"wb");
		if (!ecri)		{
			CacheTravail();
			MessageBox(gblHDlg,"Impossible d'ouvrir le fichier en criture.\nLe nom est probablement faux ou vous n'avez pas les autorisations d'accs dans ce rpertoire (seriez-vous  l'cole?).",e->nom_fichier,MB_ICONERROR);
			return 0;
		}

		ReinitSymTable();
		PrepareSymTable(2);
		VerifNomVar(e->nom_court,chneNomVarBmp);
		InitSymbole(0,e->nom_base);									//%file%
		InitSymbole(4,tailleX*tailleY);								//%memory%
		InitSymbole(5,chneNomVarBmp);								//%name%
		if (curPF->pfList[*cmode].bUsePalettes && !bModeDMG)
			InitSymbole(6,palfile->nom_fichier);					//%link%
		else
			InitSymbole(6,"");										//%link%
		InitSymbole(9,curPF->pfList[*cmode].ID);					//%depth%
		if (curPF->pfList[*cmode].ID == 32)
			InitSymbole(10,type32);									//%type%
		else if (curPF->pfList[*cmode].ID == 15)
			InitSymbole(10,type16);									//%type%
		else
			InitSymbole(10,type8);									//%type%

		//Ecrit ventuellement ce dont on a besoin dans le ref file
		refFile::writeSectionFiltree(bmp_refdefine, e);
		EcritChaineFiltree(bmp_declaration,ecri);
	//	sprintf(str,"//%s\n//Converti avec GBA Graphics par Brnni\n//Bitmap 8 bits (\"%s\")\n//Taille: %i*%i\n//Mmoire: %i octets\n\nconst unsigned char %s_bitmap8[%i]=	{\n",els[0].nom_base,els[1].nom_fichier,tailleX,tailleY,tailleX*tailleY,els[1].nom_court,tailleY*tailleX);
	//	fputs(str,ecri);

		for (j=0;j<tailleY;j++)		{
			for (i=0;i<tailleX;i++)		{
				if (*bmp_fin_ligne)
					z=i;
				else
					z=i+j*tailleX;
				if (bmp_nbChaqueX>0 && z>0 && z%bmp_nbChaqueX==0)
					EcritChaineFiltree(bmp_chaque_x,ecri);

				if (curPF->pfList[*cmode].ID == 32)			{
					unsigned char *c = (unsigned char*)&tableau[j*tailleX+i];
					myprintf(ecri,bmp_chaque_valeur_3, RGBA(c[0],c[1],c[2],c[3]));
				}
				else if (curPF->pfList[*cmode].ID == 15)			{
					unsigned char *c = (unsigned char*)&tableau[j*tailleX+i];
					myprintf(ecri,bmp_chaque_valeur_2, Rvba15Bits(c[2],c[1],c[0],!(c[3]&1)));
				}
				else
					myprintf(ecri,bmp_chaque_valeur_1,tableau[j*tailleX+i]);
			}
			EcritChaineFiltree(bmp_fin_ligne,ecri);
		}
		EcritChaineFiltree(bmp_fin_declaration,ecri);

		fclose(ecri);

		return 1;
	}

	LRESULT CALLBACK fctPersonnalisationHandler(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)		{
			static HWND hCheckDMG, hComboPalette;
			HWND hStatic;
			int choix;

			switch (message)
			{
				case WM_INITDIALOG:
					//Cration des contrles
					hStatic = MyCreateWindow("Static", "Palette (DMG)", WS_CHILD | WS_VISIBLE,
						10, 5+18+2, 90, 18, hDlg);
					hComboPalette = MyCreateWindow("ComboBox", "", WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP,
						100, 5+18, 90, 18, hDlg);
					SendMessage(hComboPalette, CB_ADDSTRING, 0, (LPARAM)"(choisir...)");
					SendMessage(hComboPalette, CB_ADDSTRING, 0, (LPARAM)"Game Boy Pocket");
					SendMessage(hComboPalette, CB_ADDSTRING, 0, (LPARAM)"Game Boy DMG");
					SendMessage(hComboPalette, CB_ADDSTRING, 0, (LPARAM)"Game Boy Light");
					SendMessage(hComboPalette, CB_SETCURSEL, 0, 0);
					hCheckDMG = MyCreateWindow("Button", "Mode monochrome (DMG)", WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX,
						10, 5, 160, 18, hDlg);
					SendMessage(hCheckDMG, BM_SETCHECK, bModeDMG ? BST_CHECKED : BST_UNCHECKED, 0);
					break;

				case WM_DESTROY:
					bModeDMG = SendMessage(hCheckDMG, BM_GETCHECK, 0, 0);
					choix = SendMessage(hComboPalette, CB_GETCURSEL, 0, 0);
					if (choix >= 1 && choix <= 3)
						memcpy(dmgPalette, dmgColorTable[choix-1], 16);
					break;
			}
			return FALSE;
	}

	int fctPersonnalisation(int flags, int *cmode)
	{
		int hauteur = 46;
		//Le bouton est actif?
		if (flags & 0x8000)		{
			//(flags & 0x7000) == 0x1000 => mode configurer le plugin, cmode toujours 1
			//(flags & 0x7000) == 0x2000 => depuis l'cran de conversion, peut dpendre du cmode
			//(flags & 0xfff) == SEL_LISTES => uniquement pour les listes, par exemple
			if ((flags & 0x7000) == 0x1000 || (flags & 0x7000) == 0x2000)
				return 1;
			else
				return 0;
		}
		PluginPropertiesWindow::Create(flags, cmode, SIZE_FEN(200, hauteur), (DLGPROC)fctPersonnalisationHandler);
//		FctApplyMasks();
		return 1;
	}

	void FctModeDMG(char *ptr) {
		bModeDMG = GetEntier(ptr);
	}

	IDENTIFICATEUR obj[]=	{
		//Commun
		{"dmgmode",				FctModeDMG,		TYPE_FONCTION},
	};
	INFOS_OBJET infoObj[]={sizeof(obj)/sizeof(obj[0]), obj};

	void fctInit(int flags, PLATFORM_INFO *p)
	{
		//Initialisation
		if (flags == 0)
		{
			IDENTIFICATEUR idNouveau = {"gbc", infoObj, TYPE_OBJET};
			ptrPF = p;
			AjouteObjetExterne(&idNouveau);

			bModeDMG = 0;
//			FctApplyMasks();
			memcpy(dmgPalette, dmgColorTable[0], 16);
		}
		//Switch vers ce plugin
		else if (flags == 1)
		{
		}
		//Switch vers un autre plugin
		else if (flags == 2)
		{
		}
	}

	void fctSauvegarde(int flags, FILE *f)
	{
		fprintf(f, "  GBC.dmgmode = %s\n", GetBoolText(bModeDMG));
	}
};
